module     P3B_uux_uux_config
   implicit none

   integer, parameter :: dbl = kind(1.0d0)
   ! QUADRUPLE PRECISION (ki=16):
   ! integer, parameter :: ki = selected_real_kind(33, 4931)
   ! INTERMEDIATE PRECISION (ki=10):
   ! integer, parameter :: ki = selected_real_kind(18, 4931)
   ! DOUBLE PRECISION (ki=8):
   integer, parameter :: ki = kind(1.0d0)

   logical, parameter :: debug_lo_diagrams  = .true.
   logical, parameter :: debug_nlo_diagrams  = .true.

   ! If true, the calculation includes terms proportional to eps^2
   ! multiplying double poles.
   ! These terms are supposed to cancel in QCD.
   logical :: include_eps2_terms = .false.

   ! If true, the calculation includes terms proportional to eps
   ! multiplying double and single poles.
   ! These terms are necessary in 't Hooft-Veltman scheme
   logical :: include_eps_terms = .false.

   logical, parameter :: include_color_avg_factor = .true.
   logical, parameter :: include_helicity_avg_factor = .true.
   logical, parameter :: include_symmetry_factor = .false.

   
   ! Parameters for the initialization of samurai
   ! they can also be set using the subroutine parse in model.f90
   integer :: samurai_scalar = 1
   integer :: samurai_verbosity = 0
   integer :: samurai_test = 0
   ! The following parameter sets the 'istop' argument in all samurai
   ! calls. Unless you really know what you do, you should stick to the
   ! default value.
   integer :: samurai_istop = 0
   logical :: samurai_group_numerators = .true.

   ! Options to control the interoperation between different
   ! reduction methods
   integer :: reduction_interoperation = 2
   ! 0: use samurai only
   ! 1: golem95 only
   ! 2: try samurai first, use golem95 if samurai fails
   ! 3: tens. reconstruction with golem95, reduction with samurai
   ! 4: tens. reconstruction with golem95, reduction with samurai,
   !    use golem95 if samurai fails
   ! Parameter to switch UV-Counterterms on or off
   integer :: renormalisation = 0

   ! Parameter: Use stable accumulation of diagrams or builtin sum
   !            Stable accumulation is implemented in accu.f90
   logical :: use_sorted_sum = .false.

   ! Flag to decide if results should be converted to CDR
   ! if they are not already in that scheme
   logical :: convert_to_cdr = .false.

   integer :: logfile = 19

end module P3B_uux_uux_config

