module     P3B_uux_uux_groups
   use precision, only: ki_sam => ki
   use madds
   use precision_golem, only: ki_gol => ki
   use tens_rec
   use P3B_uux_uux_config, only: ki
   implicit none
   save

   private
!---#[ tensor coefficients for golem95:
   !-----#[ tensor coefficients group 0:
   type tensrec_info_group0
      type(coeff_type_4) :: coeffs_21
      type(coeff_type_4) :: coeffs_22
      type(coeff_type_4) :: coeffs_23
      type(coeff_type_4) :: coeffs_24
   end type

   public :: tensrec_info_group0
   type(tensrec_info_group0), pointer, public :: coeffs_group0
   public :: reduce_numetens_group0
   !-----#] tensor coefficients group 0:
   !-----#[ tensor coefficients group 1:
   type tensrec_info_group1
      type(coeff_type_4) :: coeffs_17
      type(coeff_type_4) :: coeffs_18
      type(coeff_type_4) :: coeffs_19
      type(coeff_type_4) :: coeffs_20
      type(coeff_type_3) :: coeffs_49
      type(coeff_type_3) :: coeffs_50
      type(coeff_type_3) :: coeffs_51
      type(coeff_type_3) :: coeffs_52
      type(coeff_type_3) :: coeffs_53
      type(coeff_type_3) :: coeffs_54
      type(coeff_type_3) :: coeffs_55
      type(coeff_type_3) :: coeffs_56
      type(coeff_type_3) :: coeffs_57
      type(coeff_type_3) :: coeffs_58
      type(coeff_type_3) :: coeffs_59
      type(coeff_type_3) :: coeffs_60
      type(coeff_type_3) :: coeffs_61
      type(coeff_type_3) :: coeffs_62
      type(coeff_type_3) :: coeffs_63
      type(coeff_type_3) :: coeffs_64
   end type

   public :: tensrec_info_group1
   type(tensrec_info_group1), pointer, public :: coeffs_group1
   public :: reduce_numetens_group1
   !-----#] tensor coefficients group 1:
   !-----#[ tensor coefficients group 2:
   type tensrec_info_group2
      type(coeff_type_4) :: coeffs_13
      type(coeff_type_4) :: coeffs_14
      type(coeff_type_4) :: coeffs_15
      type(coeff_type_4) :: coeffs_16
   end type

   public :: tensrec_info_group2
   type(tensrec_info_group2), pointer, public :: coeffs_group2
   public :: reduce_numetens_group2
   !-----#] tensor coefficients group 2:
   !-----#[ tensor coefficients group 3:
   type tensrec_info_group3
      type(coeff_type_4) :: coeffs_9
      type(coeff_type_4) :: coeffs_10
      type(coeff_type_4) :: coeffs_11
      type(coeff_type_4) :: coeffs_12
   end type

   public :: tensrec_info_group3
   type(tensrec_info_group3), pointer, public :: coeffs_group3
   public :: reduce_numetens_group3
   !-----#] tensor coefficients group 3:
   !-----#[ tensor coefficients group 4:
   type tensrec_info_group4
      type(coeff_type_4) :: coeffs_1
      type(coeff_type_4) :: coeffs_2
      type(coeff_type_4) :: coeffs_3
      type(coeff_type_4) :: coeffs_4
   end type

   public :: tensrec_info_group4
   type(tensrec_info_group4), pointer, public :: coeffs_group4
   public :: reduce_numetens_group4
   !-----#] tensor coefficients group 4:
   !-----#[ tensor coefficients group 5:
   type tensrec_info_group5
      type(coeff_type_4) :: coeffs_5
      type(coeff_type_4) :: coeffs_6
      type(coeff_type_4) :: coeffs_7
      type(coeff_type_4) :: coeffs_8
      type(coeff_type_3) :: coeffs_33
      type(coeff_type_3) :: coeffs_34
      type(coeff_type_3) :: coeffs_35
      type(coeff_type_3) :: coeffs_36
      type(coeff_type_3) :: coeffs_37
      type(coeff_type_3) :: coeffs_38
      type(coeff_type_3) :: coeffs_39
      type(coeff_type_3) :: coeffs_40
      type(coeff_type_3) :: coeffs_41
      type(coeff_type_3) :: coeffs_42
      type(coeff_type_3) :: coeffs_43
      type(coeff_type_3) :: coeffs_44
      type(coeff_type_3) :: coeffs_45
      type(coeff_type_3) :: coeffs_46
      type(coeff_type_3) :: coeffs_47
      type(coeff_type_3) :: coeffs_48
   end type

   public :: tensrec_info_group5
   type(tensrec_info_group5), pointer, public :: coeffs_group5
   public :: reduce_numetens_group5
   !-----#] tensor coefficients group 5:
!---#] tensor coefficients for golem95:
   integer :: prev_ls = -1

   interface contract_golem95
      module procedure contract_tensor_coefficients_group_0
      module procedure contract_tensor_coefficients_group_1
      module procedure contract_tensor_coefficients_group_2
      module procedure contract_tensor_coefficients_group_3
      module procedure contract_tensor_coefficients_group_4
      module procedure contract_tensor_coefficients_group_5
   end interface

   public :: contract_golem95
   public :: tear_down_golem95

contains
!---#[ contract tensor coefficients golem95:
!-----#[ function contract_tensor_coefficients_group_0:
function     contract_tensor_coefficients_group_0(coeffs) result(amp)
   use matrice_s, only: allocation_s, deallocation_s, s_mat, set_ref, &
                      & s_mat_c, b_ref, preparesmatrix
   use parametre, only: rmass_or_cmass_par, cmass
   use cache, only: allocate_cache, clear_cache, reset_cache
   use array, only: packb
   use tens_comb
   use form_factor_1p, only: a10
   use form_factor_2p, only: a20
   use form_factor_3p, only: a30
   use form_factor_4p, only: a40
   use form_factor_type, only: form_factor, operator(+), operator(-)
   use P3B_uux_uux_config, only: debug_nlo_diagrams, logfile
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8, es45, es3456, es4567, es234, es23, es34, es678, &
   & es812, es2345, es12, es81, es67, es56, es781, es1234, &
   & es345, es78, es123, es456, es567
   use P3B_uux_uux_model
   implicit none
   type(tensrec_info_group0), intent(in) :: coeffs
   type(form_factor) :: amp, dbg_amp

   integer :: b_set
   real(ki_gol), dimension(4,0:3) :: rmomenta

   if(debug_nlo_diagrams) then
      dbg_amp = 0.0_ki
   end if

   if(prev_ls.ne.4) then
      if(prev_ls > 0) then
         !------#[ call sequence of exitgolem95():
         rmass_or_cmass_par = cmass
         nullify(s_mat)
         call deallocation_s()
         call clear_cache()
         !------#] call sequence of exitgolem95():
      end if

      !------#[ call sequence of initgolem95():
      rmass_or_cmass_par = cmass
      call allocation_s(4)
      set_ref = (/1, 2, 3, 4/)
      b_ref = packb(set_ref)
      call allocate_cache(4)
      s_mat => s_mat_c
      !------#] call sequence of initgolem95():
      prev_ls = 4
   !else
   !   reset_cache() is called by preparesmatrix()
   !   call reset_cache()
   end if
   s_mat(1,1)=real(0.0_ki, ki_gol)
   s_mat(1,2)=real(es78, ki_gol)
   s_mat(2,1)=s_mat(1,2)
   s_mat(1,3)=real(es123-es23-es781-es456+es234+es3456+es78-es12+es56-es1234-es34, ki_gol)
   s_mat(3,1)=s_mat(1,3)
   s_mat(1,4)=real(es123-es12-es23, ki_gol)
   s_mat(4,1)=s_mat(1,4)
   s_mat(2,1)=real(es78, ki_gol)
   s_mat(1,2)=s_mat(2,1)
   s_mat(2,2)=real(0.0_ki, ki_gol)
   s_mat(2,3)=real(es234-es23-es34, ki_gol)
   s_mat(3,2)=s_mat(2,3)
   s_mat(2,4)=real(es781+es456-es3456-es23, ki_gol)
   s_mat(4,2)=s_mat(2,4)
   s_mat(3,1)=real(es123-es23-es781-es456+es234+es3456+es78-es12+es56-es1234-es34, ki_gol)
   s_mat(1,3)=s_mat(3,1)
   s_mat(3,2)=real(es234-es23-es34, ki_gol)
   s_mat(2,3)=s_mat(3,2)
   s_mat(3,3)=real(0.0_ki, ki_gol)
   s_mat(3,4)=real(es56, ki_gol)
   s_mat(4,3)=s_mat(3,4)
   s_mat(4,1)=real(es123-es12-es23, ki_gol)
   s_mat(1,4)=s_mat(4,1)
   s_mat(4,2)=real(es781+es456-es3456-es23, ki_gol)
   s_mat(2,4)=s_mat(4,2)
   s_mat(4,3)=real(es56, ki_gol)
   s_mat(3,4)=s_mat(4,3)
   s_mat(4,4)=real(0.0_ki, ki_gol)
   call preparesmatrix()
   rmomenta(1,:) = real(-k2+k7+k8+k4, ki_gol)
   rmomenta(2,:) = real(-k2+k4, ki_gol)
   rmomenta(3,:) = 0.0_ki_gol
   rmomenta(4,:) = real(-k6-k5, ki_gol)
   !-------#[ Diagram 21:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='21'>"
   end if
   b_set = 0

   amp = + Nfrat * (contract4_4(coeffs%coeffs_21, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 21:
   !-------#[ Diagram 22:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='22'>"
   end if
   b_set = 0

   amp = amp + Nfrat * (contract4_4(coeffs%coeffs_22, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 22:
   !-------#[ Diagram 23:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='23'>"
   end if
   b_set = 0

   amp = amp + Nfrat * (contract4_4(coeffs%coeffs_23, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 23:
   !-------#[ Diagram 24:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='24'>"
   end if
   b_set = 0

   amp = amp + Nfrat * (contract4_4(coeffs%coeffs_24, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 24:
end function contract_tensor_coefficients_group_0
!-----#] function contract_tensor_coefficients_group_0:
!-----#[ function contract_tensor_coefficients_group_1:
function     contract_tensor_coefficients_group_1(coeffs) result(amp)
   use matrice_s, only: allocation_s, deallocation_s, s_mat, set_ref, &
                      & s_mat_c, b_ref, preparesmatrix
   use parametre, only: rmass_or_cmass_par, cmass
   use cache, only: allocate_cache, clear_cache, reset_cache
   use array, only: packb
   use tens_comb
   use form_factor_1p, only: a10
   use form_factor_2p, only: a20
   use form_factor_3p, only: a30
   use form_factor_4p, only: a40
   use form_factor_type, only: form_factor, operator(+), operator(-)
   use P3B_uux_uux_config, only: debug_nlo_diagrams, logfile
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8, es45, es3456, es4567, es234, es23, es34, es678, &
   & es812, es2345, es12, es81, es67, es56, es781, es1234, &
   & es345, es78, es123, es456, es567
   use P3B_uux_uux_model
   implicit none
   type(tensrec_info_group1), intent(in) :: coeffs
   type(form_factor) :: amp, dbg_amp

   integer :: b_set
   real(ki_gol), dimension(4,0:3) :: rmomenta

   if(debug_nlo_diagrams) then
      dbg_amp = amp
   end if

   if(prev_ls.ne.4) then
      if(prev_ls > 0) then
         !------#[ call sequence of exitgolem95():
         rmass_or_cmass_par = cmass
         nullify(s_mat)
         call deallocation_s()
         call clear_cache()
         !------#] call sequence of exitgolem95():
      end if

      !------#[ call sequence of initgolem95():
      rmass_or_cmass_par = cmass
      call allocation_s(4)
      set_ref = (/1, 2, 3, 4/)
      b_ref = packb(set_ref)
      call allocate_cache(4)
      s_mat => s_mat_c
      !------#] call sequence of initgolem95():
      prev_ls = 4
   !else
   !   reset_cache() is called by preparesmatrix()
   !   call reset_cache()
   end if
   s_mat(1,1)=real(0.0_ki, ki_gol)
   s_mat(1,2)=real(es78, ki_gol)
   s_mat(2,1)=s_mat(1,2)
   s_mat(1,3)=real(es1234, ki_gol)
   s_mat(3,1)=s_mat(1,3)
   s_mat(1,4)=real(es123-es12-es23, ki_gol)
   s_mat(4,1)=s_mat(1,4)
   s_mat(2,1)=real(es78, ki_gol)
   s_mat(1,2)=s_mat(2,1)
   s_mat(2,2)=real(0.0_ki, ki_gol)
   s_mat(2,3)=real(es56, ki_gol)
   s_mat(3,2)=s_mat(2,3)
   s_mat(2,4)=real(es781+es456-es3456-es23, ki_gol)
   s_mat(4,2)=s_mat(2,4)
   s_mat(3,1)=real(es1234, ki_gol)
   s_mat(1,3)=s_mat(3,1)
   s_mat(3,2)=real(es56, ki_gol)
   s_mat(2,3)=s_mat(3,2)
   s_mat(3,3)=real(0.0_ki, ki_gol)
   s_mat(3,4)=real(es234-es23-es34, ki_gol)
   s_mat(4,3)=s_mat(3,4)
   s_mat(4,1)=real(es123-es12-es23, ki_gol)
   s_mat(1,4)=s_mat(4,1)
   s_mat(4,2)=real(es781+es456-es3456-es23, ki_gol)
   s_mat(2,4)=s_mat(4,2)
   s_mat(4,3)=real(es234-es23-es34, ki_gol)
   s_mat(3,4)=s_mat(4,3)
   s_mat(4,4)=real(0.0_ki, ki_gol)
   call preparesmatrix()
   rmomenta(1,:) = real(-k7-k8-k5-k6, ki_gol)
   rmomenta(2,:) = real(-k6-k5, ki_gol)
   rmomenta(3,:) = 0.0_ki_gol
   rmomenta(4,:) = real(-k2+k4, ki_gol)
   !-------#[ Diagram 17:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='17'>"
   end if
   b_set = 0

   amp = + Nfrat * (contract4_4(coeffs%coeffs_17, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 17:
   !-------#[ Diagram 18:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='18'>"
   end if
   b_set = 0

   amp = amp + Nfrat * (contract4_4(coeffs%coeffs_18, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 18:
   !-------#[ Diagram 19:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='19'>"
   end if
   b_set = 0

   amp = amp + Nfrat * (contract4_4(coeffs%coeffs_19, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 19:
   !-------#[ Diagram 20:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='20'>"
   end if
   b_set = 0

   amp = amp + Nfrat * (contract4_4(coeffs%coeffs_20, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 20:
   !-------#[ Diagram 49:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='49'>"
   end if
   b_set = packb((/2/))

   amp = amp + Nfrat * (contract3_3(coeffs%coeffs_49, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 49:
   !-------#[ Diagram 50:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='50'>"
   end if
   b_set = packb((/2/))

   amp = amp + Nfrat * (contract3_3(coeffs%coeffs_50, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 50:
   !-------#[ Diagram 51:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='51'>"
   end if
   b_set = packb((/2/))

   amp = amp + Nfrat * (contract3_3(coeffs%coeffs_51, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 51:
   !-------#[ Diagram 52:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='52'>"
   end if
   b_set = packb((/2/))

   amp = amp + Nfrat * (contract3_3(coeffs%coeffs_52, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 52:
   !-------#[ Diagram 53:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='53'>"
   end if
   b_set = packb((/2/))

   amp = amp + Nfrat * (contract3_3(coeffs%coeffs_53, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 53:
   !-------#[ Diagram 54:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='54'>"
   end if
   b_set = packb((/2/))

   amp = amp + Nfrat * (contract3_3(coeffs%coeffs_54, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 54:
   !-------#[ Diagram 55:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='55'>"
   end if
   b_set = packb((/2/))

   amp = amp + Nfrat * (contract3_3(coeffs%coeffs_55, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 55:
   !-------#[ Diagram 56:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='56'>"
   end if
   b_set = packb((/2/))

   amp = amp + Nfrat * (contract3_3(coeffs%coeffs_56, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 56:
   !-------#[ Diagram 57:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='57'>"
   end if
   b_set = packb((/2/))

   amp = amp + Nfrat * (contract3_3(coeffs%coeffs_57, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 57:
   !-------#[ Diagram 58:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='58'>"
   end if
   b_set = packb((/2/))

   amp = amp + Nfrat * (contract3_3(coeffs%coeffs_58, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 58:
   !-------#[ Diagram 59:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='59'>"
   end if
   b_set = packb((/2/))

   amp = amp + Nfrat * (contract3_3(coeffs%coeffs_59, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 59:
   !-------#[ Diagram 60:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='60'>"
   end if
   b_set = packb((/2/))

   amp = amp + Nfrat * (contract3_3(coeffs%coeffs_60, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 60:
   !-------#[ Diagram 61:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='61'>"
   end if
   b_set = packb((/2/))

   amp = amp + Nfrat * (contract3_3(coeffs%coeffs_61, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 61:
   !-------#[ Diagram 62:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='62'>"
   end if
   b_set = packb((/2/))

   amp = amp + Nfrat * (contract3_3(coeffs%coeffs_62, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 62:
   !-------#[ Diagram 63:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='63'>"
   end if
   b_set = packb((/2/))

   amp = amp + Nfrat * (contract3_3(coeffs%coeffs_63, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 63:
   !-------#[ Diagram 64:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='64'>"
   end if
   b_set = packb((/2/))

   amp = amp + Nfrat * (contract3_3(coeffs%coeffs_64, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 64:
end function contract_tensor_coefficients_group_1
!-----#] function contract_tensor_coefficients_group_1:
!-----#[ function contract_tensor_coefficients_group_2:
function     contract_tensor_coefficients_group_2(coeffs) result(amp)
   use matrice_s, only: allocation_s, deallocation_s, s_mat, set_ref, &
                      & s_mat_c, b_ref, preparesmatrix
   use parametre, only: rmass_or_cmass_par, cmass
   use cache, only: allocate_cache, clear_cache, reset_cache
   use array, only: packb
   use tens_comb
   use form_factor_1p, only: a10
   use form_factor_2p, only: a20
   use form_factor_3p, only: a30
   use form_factor_4p, only: a40
   use form_factor_type, only: form_factor, operator(+), operator(-)
   use P3B_uux_uux_config, only: debug_nlo_diagrams, logfile
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8, es45, es3456, es4567, es234, es23, es34, es678, &
   & es812, es2345, es12, es81, es67, es56, es781, es1234, &
   & es345, es78, es123, es456, es567
   use P3B_uux_uux_model
   implicit none
   type(tensrec_info_group2), intent(in) :: coeffs
   type(form_factor) :: amp, dbg_amp

   integer :: b_set
   real(ki_gol), dimension(4,0:3) :: rmomenta

   if(debug_nlo_diagrams) then
      dbg_amp = amp
   end if

   if(prev_ls.ne.4) then
      if(prev_ls > 0) then
         !------#[ call sequence of exitgolem95():
         rmass_or_cmass_par = cmass
         nullify(s_mat)
         call deallocation_s()
         call clear_cache()
         !------#] call sequence of exitgolem95():
      end if

      !------#[ call sequence of initgolem95():
      rmass_or_cmass_par = cmass
      call allocation_s(4)
      set_ref = (/1, 2, 3, 4/)
      b_ref = packb(set_ref)
      call allocate_cache(4)
      s_mat => s_mat_c
      !------#] call sequence of initgolem95():
      prev_ls = 4
   !else
   !   reset_cache() is called by preparesmatrix()
   !   call reset_cache()
   end if
   s_mat(1,1)=real(0.0_ki, ki_gol)
   s_mat(1,2)=real(es56, ki_gol)
   s_mat(2,1)=s_mat(1,2)
   s_mat(1,3)=real(es1234, ki_gol)
   s_mat(3,1)=s_mat(1,3)
   s_mat(1,4)=real(es123-es12-es23, ki_gol)
   s_mat(4,1)=s_mat(1,4)
   s_mat(2,1)=real(es56, ki_gol)
   s_mat(1,2)=s_mat(2,1)
   s_mat(2,2)=real(0.0_ki, ki_gol)
   s_mat(2,3)=real(es78, ki_gol)
   s_mat(3,2)=s_mat(2,3)
   s_mat(2,4)=real(es123-es23-es781-es456+es234+es3456+es78-es12+es56-es1234-es34, ki_gol)
   s_mat(4,2)=s_mat(2,4)
   s_mat(3,1)=real(es1234, ki_gol)
   s_mat(1,3)=s_mat(3,1)
   s_mat(3,2)=real(es78, ki_gol)
   s_mat(2,3)=s_mat(3,2)
   s_mat(3,3)=real(0.0_ki, ki_gol)
   s_mat(3,4)=real(es234-es23-es34, ki_gol)
   s_mat(4,3)=s_mat(3,4)
   s_mat(4,1)=real(es123-es12-es23, ki_gol)
   s_mat(1,4)=s_mat(4,1)
   s_mat(4,2)=real(es123-es23-es781-es456+es234+es3456+es78-es12+es56-es1234-es34, ki_gol)
   s_mat(2,4)=s_mat(4,2)
   s_mat(4,3)=real(es234-es23-es34, ki_gol)
   s_mat(3,4)=s_mat(4,3)
   s_mat(4,4)=real(0.0_ki, ki_gol)
   call preparesmatrix()
   rmomenta(1,:) = real(-k7-k8-k5-k6, ki_gol)
   rmomenta(2,:) = real(-k7-k8, ki_gol)
   rmomenta(3,:) = 0.0_ki_gol
   rmomenta(4,:) = real(-k2+k4, ki_gol)
   !-------#[ Diagram 13:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='13'>"
   end if
   b_set = 0

   amp = + Nfrat * (contract4_4(coeffs%coeffs_13, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 13:
   !-------#[ Diagram 14:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='14'>"
   end if
   b_set = 0

   amp = amp + Nfrat * (contract4_4(coeffs%coeffs_14, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 14:
   !-------#[ Diagram 15:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='15'>"
   end if
   b_set = 0

   amp = amp + Nfrat * (contract4_4(coeffs%coeffs_15, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 15:
   !-------#[ Diagram 16:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='16'>"
   end if
   b_set = 0

   amp = amp + Nfrat * (contract4_4(coeffs%coeffs_16, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 16:
end function contract_tensor_coefficients_group_2
!-----#] function contract_tensor_coefficients_group_2:
!-----#[ function contract_tensor_coefficients_group_3:
function     contract_tensor_coefficients_group_3(coeffs) result(amp)
   use matrice_s, only: allocation_s, deallocation_s, s_mat, set_ref, &
                      & s_mat_c, b_ref, preparesmatrix
   use parametre, only: rmass_or_cmass_par, cmass
   use cache, only: allocate_cache, clear_cache, reset_cache
   use array, only: packb
   use tens_comb
   use form_factor_1p, only: a10
   use form_factor_2p, only: a20
   use form_factor_3p, only: a30
   use form_factor_4p, only: a40
   use form_factor_type, only: form_factor, operator(+), operator(-)
   use P3B_uux_uux_config, only: debug_nlo_diagrams, logfile
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8, es45, es3456, es4567, es234, es23, es34, es678, &
   & es812, es2345, es12, es81, es67, es56, es781, es1234, &
   & es345, es78, es123, es456, es567
   use P3B_uux_uux_model
   implicit none
   type(tensrec_info_group3), intent(in) :: coeffs
   type(form_factor) :: amp, dbg_amp

   integer :: b_set
   real(ki_gol), dimension(4,0:3) :: rmomenta

   if(debug_nlo_diagrams) then
      dbg_amp = amp
   end if

   if(prev_ls.ne.4) then
      if(prev_ls > 0) then
         !------#[ call sequence of exitgolem95():
         rmass_or_cmass_par = cmass
         nullify(s_mat)
         call deallocation_s()
         call clear_cache()
         !------#] call sequence of exitgolem95():
      end if

      !------#[ call sequence of initgolem95():
      rmass_or_cmass_par = cmass
      call allocation_s(4)
      set_ref = (/1, 2, 3, 4/)
      b_ref = packb(set_ref)
      call allocate_cache(4)
      s_mat => s_mat_c
      !------#] call sequence of initgolem95():
      prev_ls = 4
   !else
   !   reset_cache() is called by preparesmatrix()
   !   call reset_cache()
   end if
   s_mat(1,1)=real(0.0_ki, ki_gol)
   s_mat(1,2)=real(es78, ki_gol)
   s_mat(2,1)=s_mat(1,2)
   s_mat(1,3)=real(es34+es56-es3456+es78+es12-es1234, ki_gol)
   s_mat(3,1)=s_mat(1,3)
   s_mat(1,4)=real(es12, ki_gol)
   s_mat(4,1)=s_mat(1,4)
   s_mat(2,1)=real(es78, ki_gol)
   s_mat(1,2)=s_mat(2,1)
   s_mat(2,2)=real(0.0_ki, ki_gol)
   s_mat(2,3)=real(es34, ki_gol)
   s_mat(3,2)=s_mat(2,3)
   s_mat(2,4)=real(es3456, ki_gol)
   s_mat(4,2)=s_mat(2,4)
   s_mat(3,1)=real(es34+es56-es3456+es78+es12-es1234, ki_gol)
   s_mat(1,3)=s_mat(3,1)
   s_mat(3,2)=real(es34, ki_gol)
   s_mat(2,3)=s_mat(3,2)
   s_mat(3,3)=real(0.0_ki, ki_gol)
   s_mat(3,4)=real(es56, ki_gol)
   s_mat(4,3)=s_mat(3,4)
   s_mat(4,1)=real(es12, ki_gol)
   s_mat(1,4)=s_mat(4,1)
   s_mat(4,2)=real(es3456, ki_gol)
   s_mat(2,4)=s_mat(4,2)
   s_mat(4,3)=real(es56, ki_gol)
   s_mat(3,4)=s_mat(4,3)
   s_mat(4,4)=real(0.0_ki, ki_gol)
   call preparesmatrix()
   rmomenta(1,:) = real(k7+k8, ki_gol)
   rmomenta(2,:) = 0.0_ki_gol
   rmomenta(3,:) = real(-k3-k4, ki_gol)
   rmomenta(4,:) = real(-k3-k6-k5-k4, ki_gol)
   !-------#[ Diagram 9:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='9'>"
   end if
   b_set = 0

   amp = - Nfrat * (contract4_4(coeffs%coeffs_9, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 9:
   !-------#[ Diagram 10:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='10'>"
   end if
   b_set = 0

   amp = amp - Nfrat * (contract4_4(coeffs%coeffs_10, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 10:
   !-------#[ Diagram 11:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='11'>"
   end if
   b_set = 0

   amp = amp - Nfrat * (contract4_4(coeffs%coeffs_11, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 11:
   !-------#[ Diagram 12:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='12'>"
   end if
   b_set = 0

   amp = amp - Nfrat * (contract4_4(coeffs%coeffs_12, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 12:
end function contract_tensor_coefficients_group_3
!-----#] function contract_tensor_coefficients_group_3:
!-----#[ function contract_tensor_coefficients_group_4:
function     contract_tensor_coefficients_group_4(coeffs) result(amp)
   use matrice_s, only: allocation_s, deallocation_s, s_mat, set_ref, &
                      & s_mat_c, b_ref, preparesmatrix
   use parametre, only: rmass_or_cmass_par, cmass
   use cache, only: allocate_cache, clear_cache, reset_cache
   use array, only: packb
   use tens_comb
   use form_factor_1p, only: a10
   use form_factor_2p, only: a20
   use form_factor_3p, only: a30
   use form_factor_4p, only: a40
   use form_factor_type, only: form_factor, operator(+), operator(-)
   use P3B_uux_uux_config, only: debug_nlo_diagrams, logfile
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8, es45, es3456, es4567, es234, es23, es34, es678, &
   & es812, es2345, es12, es81, es67, es56, es781, es1234, &
   & es345, es78, es123, es456, es567
   use P3B_uux_uux_model
   implicit none
   type(tensrec_info_group4), intent(in) :: coeffs
   type(form_factor) :: amp, dbg_amp

   integer :: b_set
   real(ki_gol), dimension(4,0:3) :: rmomenta

   if(debug_nlo_diagrams) then
      dbg_amp = amp
   end if

   if(prev_ls.ne.4) then
      if(prev_ls > 0) then
         !------#[ call sequence of exitgolem95():
         rmass_or_cmass_par = cmass
         nullify(s_mat)
         call deallocation_s()
         call clear_cache()
         !------#] call sequence of exitgolem95():
      end if

      !------#[ call sequence of initgolem95():
      rmass_or_cmass_par = cmass
      call allocation_s(4)
      set_ref = (/1, 2, 3, 4/)
      b_ref = packb(set_ref)
      call allocate_cache(4)
      s_mat => s_mat_c
      !------#] call sequence of initgolem95():
      prev_ls = 4
   !else
   !   reset_cache() is called by preparesmatrix()
   !   call reset_cache()
   end if
   s_mat(1,1)=real(0.0_ki, ki_gol)
   s_mat(1,2)=real(es56, ki_gol)
   s_mat(2,1)=s_mat(1,2)
   s_mat(1,3)=real(es1234, ki_gol)
   s_mat(3,1)=s_mat(1,3)
   s_mat(1,4)=real(es12, ki_gol)
   s_mat(4,1)=s_mat(1,4)
   s_mat(2,1)=real(es56, ki_gol)
   s_mat(1,2)=s_mat(2,1)
   s_mat(2,2)=real(0.0_ki, ki_gol)
   s_mat(2,3)=real(es78, ki_gol)
   s_mat(3,2)=s_mat(2,3)
   s_mat(2,4)=real(es34+es56-es3456+es78+es12-es1234, ki_gol)
   s_mat(4,2)=s_mat(2,4)
   s_mat(3,1)=real(es1234, ki_gol)
   s_mat(1,3)=s_mat(3,1)
   s_mat(3,2)=real(es78, ki_gol)
   s_mat(2,3)=s_mat(3,2)
   s_mat(3,3)=real(0.0_ki, ki_gol)
   s_mat(3,4)=real(es34, ki_gol)
   s_mat(4,3)=s_mat(3,4)
   s_mat(4,1)=real(es12, ki_gol)
   s_mat(1,4)=s_mat(4,1)
   s_mat(4,2)=real(es34+es56-es3456+es78+es12-es1234, ki_gol)
   s_mat(2,4)=s_mat(4,2)
   s_mat(4,3)=real(es34, ki_gol)
   s_mat(3,4)=s_mat(4,3)
   s_mat(4,4)=real(0.0_ki, ki_gol)
   call preparesmatrix()
   rmomenta(1,:) = real(k7+k8+k5+k6, ki_gol)
   rmomenta(2,:) = real(k7+k8, ki_gol)
   rmomenta(3,:) = 0.0_ki_gol
   rmomenta(4,:) = real(-k3-k4, ki_gol)
   !-------#[ Diagram 1:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='1'>"
   end if
   b_set = 0

   amp = - Nfrat * (contract4_4(coeffs%coeffs_1, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 1:
   !-------#[ Diagram 2:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='2'>"
   end if
   b_set = 0

   amp = amp - Nfrat * (contract4_4(coeffs%coeffs_2, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 2:
   !-------#[ Diagram 3:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='3'>"
   end if
   b_set = 0

   amp = amp - Nfrat * (contract4_4(coeffs%coeffs_3, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 3:
   !-------#[ Diagram 4:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='4'>"
   end if
   b_set = 0

   amp = amp - Nfrat * (contract4_4(coeffs%coeffs_4, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 4:
end function contract_tensor_coefficients_group_4
!-----#] function contract_tensor_coefficients_group_4:
!-----#[ function contract_tensor_coefficients_group_5:
function     contract_tensor_coefficients_group_5(coeffs) result(amp)
   use matrice_s, only: allocation_s, deallocation_s, s_mat, set_ref, &
                      & s_mat_c, b_ref, preparesmatrix
   use parametre, only: rmass_or_cmass_par, cmass
   use cache, only: allocate_cache, clear_cache, reset_cache
   use array, only: packb
   use tens_comb
   use form_factor_1p, only: a10
   use form_factor_2p, only: a20
   use form_factor_3p, only: a30
   use form_factor_4p, only: a40
   use form_factor_type, only: form_factor, operator(+), operator(-)
   use P3B_uux_uux_config, only: debug_nlo_diagrams, logfile
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8, es45, es3456, es4567, es234, es23, es34, es678, &
   & es812, es2345, es12, es81, es67, es56, es781, es1234, &
   & es345, es78, es123, es456, es567
   use P3B_uux_uux_model
   implicit none
   type(tensrec_info_group5), intent(in) :: coeffs
   type(form_factor) :: amp, dbg_amp

   integer :: b_set
   real(ki_gol), dimension(4,0:3) :: rmomenta

   if(debug_nlo_diagrams) then
      dbg_amp = amp
   end if

   if(prev_ls.ne.4) then
      if(prev_ls > 0) then
         !------#[ call sequence of exitgolem95():
         rmass_or_cmass_par = cmass
         nullify(s_mat)
         call deallocation_s()
         call clear_cache()
         !------#] call sequence of exitgolem95():
      end if

      !------#[ call sequence of initgolem95():
      rmass_or_cmass_par = cmass
      call allocation_s(4)
      set_ref = (/1, 2, 3, 4/)
      b_ref = packb(set_ref)
      call allocate_cache(4)
      s_mat => s_mat_c
      !------#] call sequence of initgolem95():
      prev_ls = 4
   !else
   !   reset_cache() is called by preparesmatrix()
   !   call reset_cache()
   end if
   s_mat(1,1)=real(0.0_ki, ki_gol)
   s_mat(1,2)=real(es78, ki_gol)
   s_mat(2,1)=s_mat(1,2)
   s_mat(1,3)=real(es1234, ki_gol)
   s_mat(3,1)=s_mat(1,3)
   s_mat(1,4)=real(es12, ki_gol)
   s_mat(4,1)=s_mat(1,4)
   s_mat(2,1)=real(es78, ki_gol)
   s_mat(1,2)=s_mat(2,1)
   s_mat(2,2)=real(0.0_ki, ki_gol)
   s_mat(2,3)=real(es56, ki_gol)
   s_mat(3,2)=s_mat(2,3)
   s_mat(2,4)=real(es3456, ki_gol)
   s_mat(4,2)=s_mat(2,4)
   s_mat(3,1)=real(es1234, ki_gol)
   s_mat(1,3)=s_mat(3,1)
   s_mat(3,2)=real(es56, ki_gol)
   s_mat(2,3)=s_mat(3,2)
   s_mat(3,3)=real(0.0_ki, ki_gol)
   s_mat(3,4)=real(es34, ki_gol)
   s_mat(4,3)=s_mat(3,4)
   s_mat(4,1)=real(es12, ki_gol)
   s_mat(1,4)=s_mat(4,1)
   s_mat(4,2)=real(es3456, ki_gol)
   s_mat(2,4)=s_mat(4,2)
   s_mat(4,3)=real(es34, ki_gol)
   s_mat(3,4)=s_mat(4,3)
   s_mat(4,4)=real(0.0_ki, ki_gol)
   call preparesmatrix()
   rmomenta(1,:) = real(k7+k8+k5+k6, ki_gol)
   rmomenta(2,:) = real(k6+k5, ki_gol)
   rmomenta(3,:) = 0.0_ki_gol
   rmomenta(4,:) = real(-k3-k4, ki_gol)
   !-------#[ Diagram 5:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='5'>"
   end if
   b_set = 0

   amp = - Nfrat * (contract4_4(coeffs%coeffs_5, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 5:
   !-------#[ Diagram 6:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='6'>"
   end if
   b_set = 0

   amp = amp - Nfrat * (contract4_4(coeffs%coeffs_6, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 6:
   !-------#[ Diagram 7:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='7'>"
   end if
   b_set = 0

   amp = amp - Nfrat * (contract4_4(coeffs%coeffs_7, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 7:
   !-------#[ Diagram 8:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='8'>"
   end if
   b_set = 0

   amp = amp - Nfrat * (contract4_4(coeffs%coeffs_8, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 8:
   !-------#[ Diagram 33:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='33'>"
   end if
   b_set = packb((/2/))

   amp = amp - Nfrat * (contract3_3(coeffs%coeffs_33, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 33:
   !-------#[ Diagram 34:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='34'>"
   end if
   b_set = packb((/2/))

   amp = amp - Nfrat * (contract3_3(coeffs%coeffs_34, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 34:
   !-------#[ Diagram 35:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='35'>"
   end if
   b_set = packb((/2/))

   amp = amp - Nfrat * (contract3_3(coeffs%coeffs_35, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 35:
   !-------#[ Diagram 36:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='36'>"
   end if
   b_set = packb((/2/))

   amp = amp - Nfrat * (contract3_3(coeffs%coeffs_36, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 36:
   !-------#[ Diagram 37:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='37'>"
   end if
   b_set = packb((/2/))

   amp = amp - Nfrat * (contract3_3(coeffs%coeffs_37, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 37:
   !-------#[ Diagram 38:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='38'>"
   end if
   b_set = packb((/2/))

   amp = amp - Nfrat * (contract3_3(coeffs%coeffs_38, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 38:
   !-------#[ Diagram 39:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='39'>"
   end if
   b_set = packb((/2/))

   amp = amp - Nfrat * (contract3_3(coeffs%coeffs_39, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 39:
   !-------#[ Diagram 40:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='40'>"
   end if
   b_set = packb((/2/))

   amp = amp - Nfrat * (contract3_3(coeffs%coeffs_40, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 40:
   !-------#[ Diagram 41:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='41'>"
   end if
   b_set = packb((/2/))

   amp = amp - Nfrat * (contract3_3(coeffs%coeffs_41, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 41:
   !-------#[ Diagram 42:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='42'>"
   end if
   b_set = packb((/2/))

   amp = amp - Nfrat * (contract3_3(coeffs%coeffs_42, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 42:
   !-------#[ Diagram 43:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='43'>"
   end if
   b_set = packb((/2/))

   amp = amp - Nfrat * (contract3_3(coeffs%coeffs_43, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 43:
   !-------#[ Diagram 44:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='44'>"
   end if
   b_set = packb((/2/))

   amp = amp - Nfrat * (contract3_3(coeffs%coeffs_44, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 44:
   !-------#[ Diagram 45:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='45'>"
   end if
   b_set = packb((/2/))

   amp = amp - Nfrat * (contract3_3(coeffs%coeffs_45, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 45:
   !-------#[ Diagram 46:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='46'>"
   end if
   b_set = packb((/2/))

   amp = amp - Nfrat * (contract3_3(coeffs%coeffs_46, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 46:
   !-------#[ Diagram 47:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='47'>"
   end if
   b_set = packb((/2/))

   amp = amp - Nfrat * (contract3_3(coeffs%coeffs_47, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 47:
   !-------#[ Diagram 48:
   if(debug_nlo_diagrams) then
      write(logfile,*) "<diagram index='48'>"
   end if
   b_set = packb((/2/))

   amp = amp - Nfrat * (contract3_3(coeffs%coeffs_48, rmomenta, b_set))
   if(debug_nlo_diagrams) then
      dbg_amp = amp - dbg_amp
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-finite' re='", real(dbg_amp%C, ki), &
         & "' im='", aimag(dbg_amp%C), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-single' re='", real(dbg_amp%B, ki), &
         & "' im='", aimag(dbg_amp%B), "'/>"
      write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
         & "<result kind='nlo-double' re='", real(dbg_amp%A, ki), &
         & "' im='", aimag(dbg_amp%A), "'/>"
      write(logfile,*) "</diagram>"
   end if
   !-------#] Diagram 48:
end function contract_tensor_coefficients_group_5
!-----#] function contract_tensor_coefficients_group_5:
!---#] contract tensor coefficients golem95:
!---#[ numetens golem95:
!-----#[ function numetens_group0:
function     numetens_group0(icut, Q, mu2) result(num)
   use tens_rec
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P3B_uux_uux_model
   implicit none
   integer, intent(in) :: icut
   complex(ki_sam), dimension(4), intent(in) :: Q
   real(ki_sam), intent(in) :: mu2
   complex(ki_sam) :: num

   logical, dimension(0:4-1) :: nonzero
   complex(ki_gol), dimension(0:3) :: Qg
   real(ki_gol), dimension(0:3) :: R
   complex(ki_gol) :: Q2
   complex(ki_sam) :: diag, denom1, denom2, denom3, denom4

   nonzero(:) = .true.
   Qg(0) = Q(4)
   Qg(1:3) = Q(1:3)
   Q2 = Qg(0)*Qg(0) - Qg(1)*Qg(1) - Qg(2)*Qg(2) - Qg(3)*Qg(3) - mu2

   select case(icut)
   case default
      R = real(-k2+k7+k8+k4, ki_gol)
      denom1 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
      R = real(-k2+k4, ki_gol)
      denom2 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
      denom3 = Q2
      R = real(-k6-k5, ki_gol)
      denom4 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
   end select

   num = (0.0_ki_sam, 0.0_ki_sam)
   !-------#[ Diagram 21:
   if(nonzero(0)) then
      diag = ctenseval4(Qg, coeffs_group0%coeffs_21)
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 21:
   !-------#[ Diagram 22:
   if(nonzero(1)) then
      diag = ctenseval4(Qg, coeffs_group0%coeffs_22)
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 22:
   !-------#[ Diagram 23:
   if(nonzero(2)) then
      diag = ctenseval4(Qg, coeffs_group0%coeffs_23)
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 23:
   !-------#[ Diagram 24:
   if(nonzero(3)) then
      diag = ctenseval4(Qg, coeffs_group0%coeffs_24)
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 24:
end function numetens_group0
!-----#] function numetens_group0:
!-----#[ subroutine reduce_numetens_group0:
subroutine     reduce_numetens_group0(scale2,tot,totr,ok)
   use msamurai, only: samurai
   use options, only: samurai_out => iout
   use P3B_uux_uux_config, only: samurai_group_numerators, &
      samurai_istop, samurai_verbosity
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P3B_uux_uux_model
   use P3B_uux_uux_globalsl1, only: epspow
   implicit none
   real(ki_sam), intent(in) :: scale2
   complex(ki_sam), dimension(-2:0), intent(out) :: tot
   complex(ki_sam), intent(out) :: totr
   logical, intent(out) :: ok

   integer, parameter :: effective_group_rank = 4

   real(ki), dimension(4) :: msq
   real(ki), dimension(4,4) :: Vi
   msq(1) = 0.0_ki
   Vi(1,:) = -k2((/2,3,4,1/))+k7((/2,3,4,1/))+k8((/2,3,4,1/))+k4((/2,3,4,1/))
   msq(2) = 0.0_ki
   Vi(2,:) = -k2((/2,3,4,1/))+k4((/2,3,4,1/))
   msq(3) = 0.0_ki
   Vi(3,:) = 0
   msq(4) = 0.0_ki
   Vi(4,:) = -k6((/2,3,4,1/))-k5((/2,3,4,1/))
   if(samurai_verbosity > 0) then
      write(samurai_out,*) "[golem-2.0] numetens_group0"
      write(samurai_out,*) "[golem-2.0] epspow=", epspow
   end if
   call samurai(numetens_group0, tot, totr, Vi, msq, 4, &
      & effective_group_rank, samurai_istop, scale2, ok)
end subroutine reduce_numetens_group0
!-----#] subroutine reduce_numetens_group0:
!-----#[ function numetens_group1:
function     numetens_group1(icut, Q, mu2) result(num)
   use tens_rec
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P3B_uux_uux_model
   implicit none
   integer, intent(in) :: icut
   complex(ki_sam), dimension(4), intent(in) :: Q
   real(ki_sam), intent(in) :: mu2
   complex(ki_sam) :: num

   logical, dimension(0:20-1) :: nonzero
   complex(ki_gol), dimension(0:3) :: Qg
   real(ki_gol), dimension(0:3) :: R
   complex(ki_gol) :: Q2
   complex(ki_sam) :: diag, denom1, denom2, denom3, denom4

   nonzero(:) = .true.
   Qg(0) = Q(4)
   Qg(1:3) = Q(1:3)
   Q2 = Qg(0)*Qg(0) - Qg(1)*Qg(1) - Qg(2)*Qg(2) - Qg(3)*Qg(3) - mu2

   select case(icut)
   case(1)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      R = real(-k7-k8-k5-k6, ki_gol)
      denom1 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
      denom2 = 0.0_ki
      denom3 = Q2
      R = real(-k2+k4, ki_gol)
      denom4 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
   case(10)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      denom1 = 0.0_ki
      denom2 = 0.0_ki
      denom3 = Q2
      R = real(-k2+k4, ki_gol)
      denom4 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
   case(21)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      R = real(-k7-k8-k5-k6, ki_gol)
      denom1 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
      denom2 = 0.0_ki
      denom3 = 0.0_ki
      R = real(-k2+k4, ki_gol)
      denom4 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
   case(210)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      denom1 = 0.0_ki
      denom2 = 0.0_ki
      denom3 = 0.0_ki
      R = real(-k2+k4, ki_gol)
      denom4 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
   case(31)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      R = real(-k7-k8-k5-k6, ki_gol)
      denom1 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
      denom2 = 0.0_ki
      denom3 = Q2
      denom4 = 0.0_ki
   case(310)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      denom1 = 0.0_ki
      denom2 = 0.0_ki
      denom3 = Q2
      denom4 = 0.0_ki
   case(321)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      R = real(-k7-k8-k5-k6, ki_gol)
      denom1 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
      denom2 = 0.0_ki
      denom3 = 0.0_ki
      denom4 = 0.0_ki
   case(3210)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      denom1 = 0.0_ki
      denom2 = 0.0_ki
      denom3 = 0.0_ki
      denom4 = 0.0_ki
   case default
      R = real(-k7-k8-k5-k6, ki_gol)
      denom1 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
      R = real(-k6-k5, ki_gol)
      denom2 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
      denom3 = Q2
      R = real(-k2+k4, ki_gol)
      denom4 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
   end select

   num = (0.0_ki_sam, 0.0_ki_sam)
   !-------#[ Diagram 17:
   if(nonzero(0)) then
      diag = ctenseval4(Qg, coeffs_group1%coeffs_17)
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 17:
   !-------#[ Diagram 18:
   if(nonzero(1)) then
      diag = ctenseval4(Qg, coeffs_group1%coeffs_18)
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 18:
   !-------#[ Diagram 19:
   if(nonzero(2)) then
      diag = ctenseval4(Qg, coeffs_group1%coeffs_19)
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 19:
   !-------#[ Diagram 20:
   if(nonzero(3)) then
      diag = ctenseval4(Qg, coeffs_group1%coeffs_20)
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 20:
   !-------#[ Diagram 49:
   if(nonzero(4)) then
      diag = ctenseval3(Qg, coeffs_group1%coeffs_49)
      diag = diag * denom2
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 49:
   !-------#[ Diagram 50:
   if(nonzero(5)) then
      diag = ctenseval3(Qg, coeffs_group1%coeffs_50)
      diag = diag * denom2
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 50:
   !-------#[ Diagram 51:
   if(nonzero(6)) then
      diag = ctenseval3(Qg, coeffs_group1%coeffs_51)
      diag = diag * denom2
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 51:
   !-------#[ Diagram 52:
   if(nonzero(7)) then
      diag = ctenseval3(Qg, coeffs_group1%coeffs_52)
      diag = diag * denom2
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 52:
   !-------#[ Diagram 53:
   if(nonzero(8)) then
      diag = ctenseval3(Qg, coeffs_group1%coeffs_53)
      diag = diag * denom2
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 53:
   !-------#[ Diagram 54:
   if(nonzero(9)) then
      diag = ctenseval3(Qg, coeffs_group1%coeffs_54)
      diag = diag * denom2
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 54:
   !-------#[ Diagram 55:
   if(nonzero(10)) then
      diag = ctenseval3(Qg, coeffs_group1%coeffs_55)
      diag = diag * denom2
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 55:
   !-------#[ Diagram 56:
   if(nonzero(11)) then
      diag = ctenseval3(Qg, coeffs_group1%coeffs_56)
      diag = diag * denom2
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 56:
   !-------#[ Diagram 57:
   if(nonzero(12)) then
      diag = ctenseval3(Qg, coeffs_group1%coeffs_57)
      diag = diag * denom2
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 57:
   !-------#[ Diagram 58:
   if(nonzero(13)) then
      diag = ctenseval3(Qg, coeffs_group1%coeffs_58)
      diag = diag * denom2
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 58:
   !-------#[ Diagram 59:
   if(nonzero(14)) then
      diag = ctenseval3(Qg, coeffs_group1%coeffs_59)
      diag = diag * denom2
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 59:
   !-------#[ Diagram 60:
   if(nonzero(15)) then
      diag = ctenseval3(Qg, coeffs_group1%coeffs_60)
      diag = diag * denom2
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 60:
   !-------#[ Diagram 61:
   if(nonzero(16)) then
      diag = ctenseval3(Qg, coeffs_group1%coeffs_61)
      diag = diag * denom2
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 61:
   !-------#[ Diagram 62:
   if(nonzero(17)) then
      diag = ctenseval3(Qg, coeffs_group1%coeffs_62)
      diag = diag * denom2
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 62:
   !-------#[ Diagram 63:
   if(nonzero(18)) then
      diag = ctenseval3(Qg, coeffs_group1%coeffs_63)
      diag = diag * denom2
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 63:
   !-------#[ Diagram 64:
   if(nonzero(19)) then
      diag = ctenseval3(Qg, coeffs_group1%coeffs_64)
      diag = diag * denom2
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 64:
end function numetens_group1
!-----#] function numetens_group1:
!-----#[ subroutine reduce_numetens_group1:
subroutine     reduce_numetens_group1(scale2,tot,totr,ok)
   use msamurai, only: samurai
   use options, only: samurai_out => iout
   use P3B_uux_uux_config, only: samurai_group_numerators, &
      samurai_istop, samurai_verbosity
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P3B_uux_uux_model
   use P3B_uux_uux_globalsl1, only: epspow
   implicit none
   real(ki_sam), intent(in) :: scale2
   complex(ki_sam), dimension(-2:0), intent(out) :: tot
   complex(ki_sam), intent(out) :: totr
   logical, intent(out) :: ok

   integer, parameter :: effective_group_rank = 4

   real(ki), dimension(4) :: msq
   real(ki), dimension(4,4) :: Vi
   msq(1) = 0.0_ki
   Vi(1,:) = -k7((/2,3,4,1/))-k8((/2,3,4,1/))-k5((/2,3,4,1/))-k6((/2,3,4,1/))
   msq(2) = 0.0_ki
   Vi(2,:) = -k6((/2,3,4,1/))-k5((/2,3,4,1/))
   msq(3) = 0.0_ki
   Vi(3,:) = 0
   msq(4) = 0.0_ki
   Vi(4,:) = -k2((/2,3,4,1/))+k4((/2,3,4,1/))
   if(samurai_verbosity > 0) then
      write(samurai_out,*) "[golem-2.0] numetens_group1"
      write(samurai_out,*) "[golem-2.0] epspow=", epspow
   end if
   call samurai(numetens_group1, tot, totr, Vi, msq, 4, &
      & effective_group_rank, samurai_istop, scale2, ok)
end subroutine reduce_numetens_group1
!-----#] subroutine reduce_numetens_group1:
!-----#[ function numetens_group2:
function     numetens_group2(icut, Q, mu2) result(num)
   use tens_rec
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P3B_uux_uux_model
   implicit none
   integer, intent(in) :: icut
   complex(ki_sam), dimension(4), intent(in) :: Q
   real(ki_sam), intent(in) :: mu2
   complex(ki_sam) :: num

   logical, dimension(0:4-1) :: nonzero
   complex(ki_gol), dimension(0:3) :: Qg
   real(ki_gol), dimension(0:3) :: R
   complex(ki_gol) :: Q2
   complex(ki_sam) :: diag, denom1, denom2, denom3, denom4

   nonzero(:) = .true.
   Qg(0) = Q(4)
   Qg(1:3) = Q(1:3)
   Q2 = Qg(0)*Qg(0) - Qg(1)*Qg(1) - Qg(2)*Qg(2) - Qg(3)*Qg(3) - mu2

   select case(icut)
   case default
      R = real(-k7-k8-k5-k6, ki_gol)
      denom1 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
      R = real(-k7-k8, ki_gol)
      denom2 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
      denom3 = Q2
      R = real(-k2+k4, ki_gol)
      denom4 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
   end select

   num = (0.0_ki_sam, 0.0_ki_sam)
   !-------#[ Diagram 13:
   if(nonzero(0)) then
      diag = ctenseval4(Qg, coeffs_group2%coeffs_13)
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 13:
   !-------#[ Diagram 14:
   if(nonzero(1)) then
      diag = ctenseval4(Qg, coeffs_group2%coeffs_14)
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 14:
   !-------#[ Diagram 15:
   if(nonzero(2)) then
      diag = ctenseval4(Qg, coeffs_group2%coeffs_15)
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 15:
   !-------#[ Diagram 16:
   if(nonzero(3)) then
      diag = ctenseval4(Qg, coeffs_group2%coeffs_16)
      num = num + Nfrat * diag
   end if
   !-------#] Diagram 16:
end function numetens_group2
!-----#] function numetens_group2:
!-----#[ subroutine reduce_numetens_group2:
subroutine     reduce_numetens_group2(scale2,tot,totr,ok)
   use msamurai, only: samurai
   use options, only: samurai_out => iout
   use P3B_uux_uux_config, only: samurai_group_numerators, &
      samurai_istop, samurai_verbosity
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P3B_uux_uux_model
   use P3B_uux_uux_globalsl1, only: epspow
   implicit none
   real(ki_sam), intent(in) :: scale2
   complex(ki_sam), dimension(-2:0), intent(out) :: tot
   complex(ki_sam), intent(out) :: totr
   logical, intent(out) :: ok

   integer, parameter :: effective_group_rank = 4

   real(ki), dimension(4) :: msq
   real(ki), dimension(4,4) :: Vi
   msq(1) = 0.0_ki
   Vi(1,:) = -k7((/2,3,4,1/))-k8((/2,3,4,1/))-k5((/2,3,4,1/))-k6((/2,3,4,1/))
   msq(2) = 0.0_ki
   Vi(2,:) = -k7((/2,3,4,1/))-k8((/2,3,4,1/))
   msq(3) = 0.0_ki
   Vi(3,:) = 0
   msq(4) = 0.0_ki
   Vi(4,:) = -k2((/2,3,4,1/))+k4((/2,3,4,1/))
   if(samurai_verbosity > 0) then
      write(samurai_out,*) "[golem-2.0] numetens_group2"
      write(samurai_out,*) "[golem-2.0] epspow=", epspow
   end if
   call samurai(numetens_group2, tot, totr, Vi, msq, 4, &
      & effective_group_rank, samurai_istop, scale2, ok)
end subroutine reduce_numetens_group2
!-----#] subroutine reduce_numetens_group2:
!-----#[ function numetens_group3:
function     numetens_group3(icut, Q, mu2) result(num)
   use tens_rec
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P3B_uux_uux_model
   implicit none
   integer, intent(in) :: icut
   complex(ki_sam), dimension(4), intent(in) :: Q
   real(ki_sam), intent(in) :: mu2
   complex(ki_sam) :: num

   logical, dimension(0:4-1) :: nonzero
   complex(ki_gol), dimension(0:3) :: Qg
   real(ki_gol), dimension(0:3) :: R
   complex(ki_gol) :: Q2
   complex(ki_sam) :: diag, denom1, denom2, denom3, denom4

   nonzero(:) = .true.
   Qg(0) = Q(4)
   Qg(1:3) = Q(1:3)
   Q2 = Qg(0)*Qg(0) - Qg(1)*Qg(1) - Qg(2)*Qg(2) - Qg(3)*Qg(3) - mu2

   select case(icut)
   case default
      R = real(k7+k8, ki_gol)
      denom1 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
      denom2 = Q2
      R = real(-k3-k4, ki_gol)
      denom3 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
      R = real(-k3-k6-k5-k4, ki_gol)
      denom4 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
   end select

   num = (0.0_ki_sam, 0.0_ki_sam)
   !-------#[ Diagram 9:
   if(nonzero(0)) then
      diag = ctenseval4(Qg, coeffs_group3%coeffs_9)
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 9:
   !-------#[ Diagram 10:
   if(nonzero(1)) then
      diag = ctenseval4(Qg, coeffs_group3%coeffs_10)
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 10:
   !-------#[ Diagram 11:
   if(nonzero(2)) then
      diag = ctenseval4(Qg, coeffs_group3%coeffs_11)
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 11:
   !-------#[ Diagram 12:
   if(nonzero(3)) then
      diag = ctenseval4(Qg, coeffs_group3%coeffs_12)
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 12:
end function numetens_group3
!-----#] function numetens_group3:
!-----#[ subroutine reduce_numetens_group3:
subroutine     reduce_numetens_group3(scale2,tot,totr,ok)
   use msamurai, only: samurai
   use options, only: samurai_out => iout
   use P3B_uux_uux_config, only: samurai_group_numerators, &
      samurai_istop, samurai_verbosity
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P3B_uux_uux_model
   use P3B_uux_uux_globalsl1, only: epspow
   implicit none
   real(ki_sam), intent(in) :: scale2
   complex(ki_sam), dimension(-2:0), intent(out) :: tot
   complex(ki_sam), intent(out) :: totr
   logical, intent(out) :: ok

   integer, parameter :: effective_group_rank = 4

   real(ki), dimension(4) :: msq
   real(ki), dimension(4,4) :: Vi
   msq(1) = 0.0_ki
   Vi(1,:) = k7((/2,3,4,1/))+k8((/2,3,4,1/))
   msq(2) = 0.0_ki
   Vi(2,:) = 0
   msq(3) = 0.0_ki
   Vi(3,:) = -k3((/2,3,4,1/))-k4((/2,3,4,1/))
   msq(4) = 0.0_ki
   Vi(4,:) = -k3((/2,3,4,1/))-k6((/2,3,4,1/))-k5((/2,3,4,1/))-k4((/2,3,4,1/))
   if(samurai_verbosity > 0) then
      write(samurai_out,*) "[golem-2.0] numetens_group3"
      write(samurai_out,*) "[golem-2.0] epspow=", epspow
   end if
   call samurai(numetens_group3, tot, totr, Vi, msq, 4, &
      & effective_group_rank, samurai_istop, scale2, ok)
end subroutine reduce_numetens_group3
!-----#] subroutine reduce_numetens_group3:
!-----#[ function numetens_group4:
function     numetens_group4(icut, Q, mu2) result(num)
   use tens_rec
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P3B_uux_uux_model
   implicit none
   integer, intent(in) :: icut
   complex(ki_sam), dimension(4), intent(in) :: Q
   real(ki_sam), intent(in) :: mu2
   complex(ki_sam) :: num

   logical, dimension(0:4-1) :: nonzero
   complex(ki_gol), dimension(0:3) :: Qg
   real(ki_gol), dimension(0:3) :: R
   complex(ki_gol) :: Q2
   complex(ki_sam) :: diag, denom1, denom2, denom3, denom4

   nonzero(:) = .true.
   Qg(0) = Q(4)
   Qg(1:3) = Q(1:3)
   Q2 = Qg(0)*Qg(0) - Qg(1)*Qg(1) - Qg(2)*Qg(2) - Qg(3)*Qg(3) - mu2

   select case(icut)
   case default
      R = real(k7+k8+k5+k6, ki_gol)
      denom1 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
      R = real(k7+k8, ki_gol)
      denom2 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
      denom3 = Q2
      R = real(-k3-k4, ki_gol)
      denom4 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
   end select

   num = (0.0_ki_sam, 0.0_ki_sam)
   !-------#[ Diagram 1:
   if(nonzero(0)) then
      diag = ctenseval4(Qg, coeffs_group4%coeffs_1)
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 1:
   !-------#[ Diagram 2:
   if(nonzero(1)) then
      diag = ctenseval4(Qg, coeffs_group4%coeffs_2)
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 2:
   !-------#[ Diagram 3:
   if(nonzero(2)) then
      diag = ctenseval4(Qg, coeffs_group4%coeffs_3)
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 3:
   !-------#[ Diagram 4:
   if(nonzero(3)) then
      diag = ctenseval4(Qg, coeffs_group4%coeffs_4)
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 4:
end function numetens_group4
!-----#] function numetens_group4:
!-----#[ subroutine reduce_numetens_group4:
subroutine     reduce_numetens_group4(scale2,tot,totr,ok)
   use msamurai, only: samurai
   use options, only: samurai_out => iout
   use P3B_uux_uux_config, only: samurai_group_numerators, &
      samurai_istop, samurai_verbosity
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P3B_uux_uux_model
   use P3B_uux_uux_globalsl1, only: epspow
   implicit none
   real(ki_sam), intent(in) :: scale2
   complex(ki_sam), dimension(-2:0), intent(out) :: tot
   complex(ki_sam), intent(out) :: totr
   logical, intent(out) :: ok

   integer, parameter :: effective_group_rank = 4

   real(ki), dimension(4) :: msq
   real(ki), dimension(4,4) :: Vi
   msq(1) = 0.0_ki
   Vi(1,:) = k7((/2,3,4,1/))+k8((/2,3,4,1/))+k5((/2,3,4,1/))+k6((/2,3,4,1/))
   msq(2) = 0.0_ki
   Vi(2,:) = k7((/2,3,4,1/))+k8((/2,3,4,1/))
   msq(3) = 0.0_ki
   Vi(3,:) = 0
   msq(4) = 0.0_ki
   Vi(4,:) = -k3((/2,3,4,1/))-k4((/2,3,4,1/))
   if(samurai_verbosity > 0) then
      write(samurai_out,*) "[golem-2.0] numetens_group4"
      write(samurai_out,*) "[golem-2.0] epspow=", epspow
   end if
   call samurai(numetens_group4, tot, totr, Vi, msq, 4, &
      & effective_group_rank, samurai_istop, scale2, ok)
end subroutine reduce_numetens_group4
!-----#] subroutine reduce_numetens_group4:
!-----#[ function numetens_group5:
function     numetens_group5(icut, Q, mu2) result(num)
   use tens_rec
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P3B_uux_uux_model
   implicit none
   integer, intent(in) :: icut
   complex(ki_sam), dimension(4), intent(in) :: Q
   real(ki_sam), intent(in) :: mu2
   complex(ki_sam) :: num

   logical, dimension(0:20-1) :: nonzero
   complex(ki_gol), dimension(0:3) :: Qg
   real(ki_gol), dimension(0:3) :: R
   complex(ki_gol) :: Q2
   complex(ki_sam) :: diag, denom1, denom2, denom3, denom4

   nonzero(:) = .true.
   Qg(0) = Q(4)
   Qg(1:3) = Q(1:3)
   Q2 = Qg(0)*Qg(0) - Qg(1)*Qg(1) - Qg(2)*Qg(2) - Qg(3)*Qg(3) - mu2

   select case(icut)
   case(1)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      R = real(k7+k8+k5+k6, ki_gol)
      denom1 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
      denom2 = 0.0_ki
      denom3 = Q2
      R = real(-k3-k4, ki_gol)
      denom4 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
   case(10)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      denom1 = 0.0_ki
      denom2 = 0.0_ki
      denom3 = Q2
      R = real(-k3-k4, ki_gol)
      denom4 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
   case(21)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      R = real(k7+k8+k5+k6, ki_gol)
      denom1 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
      denom2 = 0.0_ki
      denom3 = 0.0_ki
      R = real(-k3-k4, ki_gol)
      denom4 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
   case(210)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      denom1 = 0.0_ki
      denom2 = 0.0_ki
      denom3 = 0.0_ki
      R = real(-k3-k4, ki_gol)
      denom4 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
   case(31)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      R = real(k7+k8+k5+k6, ki_gol)
      denom1 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
      denom2 = 0.0_ki
      denom3 = Q2
      denom4 = 0.0_ki
   case(310)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      denom1 = 0.0_ki
      denom2 = 0.0_ki
      denom3 = Q2
      denom4 = 0.0_ki
   case(321)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      R = real(k7+k8+k5+k6, ki_gol)
      denom1 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
      denom2 = 0.0_ki
      denom3 = 0.0_ki
      denom4 = 0.0_ki
   case(3210)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      denom1 = 0.0_ki
      denom2 = 0.0_ki
      denom3 = 0.0_ki
      denom4 = 0.0_ki
   case default
      R = real(k7+k8+k5+k6, ki_gol)
      denom1 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
      R = real(k6+k5, ki_gol)
      denom2 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
      denom3 = Q2
      R = real(-k3-k4, ki_gol)
      denom4 = Q2 + (Qg(0) + Qg(0) + R(0))*R(0) &
                 &    - (Qg(1) + Qg(1) + R(1))*R(1) &
                 &    - (Qg(2) + Qg(2) + R(2))*R(2) &
                 &    - (Qg(3) + Qg(3) + R(3))*R(3)
   end select

   num = (0.0_ki_sam, 0.0_ki_sam)
   !-------#[ Diagram 5:
   if(nonzero(0)) then
      diag = ctenseval4(Qg, coeffs_group5%coeffs_5)
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 5:
   !-------#[ Diagram 6:
   if(nonzero(1)) then
      diag = ctenseval4(Qg, coeffs_group5%coeffs_6)
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 6:
   !-------#[ Diagram 7:
   if(nonzero(2)) then
      diag = ctenseval4(Qg, coeffs_group5%coeffs_7)
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 7:
   !-------#[ Diagram 8:
   if(nonzero(3)) then
      diag = ctenseval4(Qg, coeffs_group5%coeffs_8)
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 8:
   !-------#[ Diagram 33:
   if(nonzero(4)) then
      diag = ctenseval3(Qg, coeffs_group5%coeffs_33)
      diag = diag * denom2
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 33:
   !-------#[ Diagram 34:
   if(nonzero(5)) then
      diag = ctenseval3(Qg, coeffs_group5%coeffs_34)
      diag = diag * denom2
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 34:
   !-------#[ Diagram 35:
   if(nonzero(6)) then
      diag = ctenseval3(Qg, coeffs_group5%coeffs_35)
      diag = diag * denom2
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 35:
   !-------#[ Diagram 36:
   if(nonzero(7)) then
      diag = ctenseval3(Qg, coeffs_group5%coeffs_36)
      diag = diag * denom2
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 36:
   !-------#[ Diagram 37:
   if(nonzero(8)) then
      diag = ctenseval3(Qg, coeffs_group5%coeffs_37)
      diag = diag * denom2
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 37:
   !-------#[ Diagram 38:
   if(nonzero(9)) then
      diag = ctenseval3(Qg, coeffs_group5%coeffs_38)
      diag = diag * denom2
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 38:
   !-------#[ Diagram 39:
   if(nonzero(10)) then
      diag = ctenseval3(Qg, coeffs_group5%coeffs_39)
      diag = diag * denom2
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 39:
   !-------#[ Diagram 40:
   if(nonzero(11)) then
      diag = ctenseval3(Qg, coeffs_group5%coeffs_40)
      diag = diag * denom2
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 40:
   !-------#[ Diagram 41:
   if(nonzero(12)) then
      diag = ctenseval3(Qg, coeffs_group5%coeffs_41)
      diag = diag * denom2
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 41:
   !-------#[ Diagram 42:
   if(nonzero(13)) then
      diag = ctenseval3(Qg, coeffs_group5%coeffs_42)
      diag = diag * denom2
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 42:
   !-------#[ Diagram 43:
   if(nonzero(14)) then
      diag = ctenseval3(Qg, coeffs_group5%coeffs_43)
      diag = diag * denom2
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 43:
   !-------#[ Diagram 44:
   if(nonzero(15)) then
      diag = ctenseval3(Qg, coeffs_group5%coeffs_44)
      diag = diag * denom2
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 44:
   !-------#[ Diagram 45:
   if(nonzero(16)) then
      diag = ctenseval3(Qg, coeffs_group5%coeffs_45)
      diag = diag * denom2
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 45:
   !-------#[ Diagram 46:
   if(nonzero(17)) then
      diag = ctenseval3(Qg, coeffs_group5%coeffs_46)
      diag = diag * denom2
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 46:
   !-------#[ Diagram 47:
   if(nonzero(18)) then
      diag = ctenseval3(Qg, coeffs_group5%coeffs_47)
      diag = diag * denom2
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 47:
   !-------#[ Diagram 48:
   if(nonzero(19)) then
      diag = ctenseval3(Qg, coeffs_group5%coeffs_48)
      diag = diag * denom2
      num = num - Nfrat * diag
   end if
   !-------#] Diagram 48:
end function numetens_group5
!-----#] function numetens_group5:
!-----#[ subroutine reduce_numetens_group5:
subroutine     reduce_numetens_group5(scale2,tot,totr,ok)
   use msamurai, only: samurai
   use options, only: samurai_out => iout
   use P3B_uux_uux_config, only: samurai_group_numerators, &
      samurai_istop, samurai_verbosity
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P3B_uux_uux_model
   use P3B_uux_uux_globalsl1, only: epspow
   implicit none
   real(ki_sam), intent(in) :: scale2
   complex(ki_sam), dimension(-2:0), intent(out) :: tot
   complex(ki_sam), intent(out) :: totr
   logical, intent(out) :: ok

   integer, parameter :: effective_group_rank = 4

   real(ki), dimension(4) :: msq
   real(ki), dimension(4,4) :: Vi
   msq(1) = 0.0_ki
   Vi(1,:) = k7((/2,3,4,1/))+k8((/2,3,4,1/))+k5((/2,3,4,1/))+k6((/2,3,4,1/))
   msq(2) = 0.0_ki
   Vi(2,:) = k6((/2,3,4,1/))+k5((/2,3,4,1/))
   msq(3) = 0.0_ki
   Vi(3,:) = 0
   msq(4) = 0.0_ki
   Vi(4,:) = -k3((/2,3,4,1/))-k4((/2,3,4,1/))
   if(samurai_verbosity > 0) then
      write(samurai_out,*) "[golem-2.0] numetens_group5"
      write(samurai_out,*) "[golem-2.0] epspow=", epspow
   end if
   call samurai(numetens_group5, tot, totr, Vi, msq, 4, &
      & effective_group_rank, samurai_istop, scale2, ok)
end subroutine reduce_numetens_group5
!-----#] subroutine reduce_numetens_group5:
!---#] numetens golem95:
!---#[ subroutine tear_down_golem95:
subroutine     tear_down_golem95()
   use matrice_s, only: deallocation_s, s_mat
   use parametre, only: rmass_or_cmass_par, cmass
   use cache, only: clear_cache
   implicit none
   if(prev_ls.gt.0) then
      !------#[ call sequence of exitgolem95():
      rmass_or_cmass_par = cmass
      nullify(s_mat)
      call deallocation_s()
      call clear_cache()
      !------#] call sequence of exitgolem95():
      prev_ls = -1
   end if
end subroutine tear_down_golem95
!---#] subroutine tear_down_golem95:
end module P3B_uux_uux_groups
