module     P3B_uux_uux_d15h0l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P3B_uux_
   ! uux/helicity0/d15h0l1.f90
   ! generator: haggies (1.1)
   use P3B_uux_uux_config, only: ki
   use P3B_uux_uux_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P3B_uux_uux_groups, only: &
!           & sign => diagram15_sign, shift => diagram15_shift
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd15h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d15
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2-k4
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d15 = 0.0_ki
      t1 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4))
      t2 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t5 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      t6 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t7 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t8 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t9 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t10 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t11 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t12 = t3*abb15n30
      t13 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4)&
      &)
      t14 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t15 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      t16 = (Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4)&
      &)
      d15 = (t1*abb15n10+t10*t12+t10*abb15n8+t11*t12+t11*abb15n8+t12*t9+t2*abb15&
      &n11+t3*abb15n12+t3*t3*abb15n31+t4*abb15n13+t5*abb15n20+t6*abb15n29+t7*abb&
      &15n6+t8*abb15n7+t9*abb15n8+t1*t2*abb15n17+t1*t3*abb15n18+t1*t4*abb15n19+t&
      &1*t5*abb15n25+t1*t7*abb15n9+t10*t13*abb15n36+t10*t5*abb15n23+t11*t13*abb1&
      &5n36+t11*t5*abb15n23+t13*t14*abb15n39+t13*t2*abb15n45+t13*t3*abb15n46+t13&
      &*t4*abb15n47+t13*t5*abb15n53+t13*t6*abb15n37+t13*t7*abb15n34+t13*t8*abb15&
      &n35+t13*t9*abb15n36+t2*t6*abb15n16+t3*t5*abb15n22+t3*t6*abb15n15+t3*t7*ab&
      &b15n3+t3*t8*abb15n32+t4*t6*abb15n14+t5*t6*abb15n33+t5*t7*abb15n27+t5*t8*a&
      &bb15n21+t5*t9*abb15n23+t6*t7*abb15n5+t1*t5*t7*abb15n24+t10*t13*t5*abb15n5&
      &9+t11*t13*t5*abb15n59+t13*t14*t5*abb15n57+t13*t14*t7*abb15n38+t13*t15*t2*&
      &abb15n42+t13*t15*t3*abb15n43+t13*t15*t4*abb15n44+t13*t16*t2*abb15n56+t13*&
      &t16*t3*abb15n55+t13*t16*t4*abb15n54+t13*t2*t5*abb15n60+t13*t2*t6*abb15n50&
      &+t13*t2*t7*abb15n41+t13*t3*t5*abb15n61+t13*t3*t6*abb15n49+t13*t4*t5*abb15&
      &n62+t13*t4*t6*abb15n48+t13*t4*t7*abb15n40+t13*t5*t6*abb15n64+t13*t5*t7*ab&
      &b15n52+t13*t5*t8*abb15n63+t13*t5*t9*abb15n59+t13*t5*abb15n51*(Q(1)*spvak5&
      &k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))+t13*t5*abb15n58&
      &*(Q(1)*spvak5k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q(4)*spvak5k8(4))+t1&
      &4*t3*t7*abb15n4+t3*t5*t7*abb15n28+t3*t6*t7*abb15n2+t3*t7*abb15n26*(Q(1)*s&
      &pvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))+t13*t5*t6*&
      &t7*abb15n65)
      numerator = cmplx(real(d15, ki), aimag(d15), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd15h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d15
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2-k4
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d15 = 0.0_ki
      t1 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4))
      t2 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t5 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      t6 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t7 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t8 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t9 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t10 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t11 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t12 = t3*abb15n30
      t13 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4)&
      &)
      t14 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t15 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      t16 = (Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4)&
      &)
      d15 = (t1*abb15n10+t10*t12+t10*abb15n8+t11*t12+t11*abb15n8+t12*t9+t2*abb15&
      &n11+t3*abb15n12+t3*t3*abb15n31+t4*abb15n13+t5*abb15n20+t6*abb15n29+t7*abb&
      &15n6+t8*abb15n7+t9*abb15n8+t1*t2*abb15n17+t1*t3*abb15n18+t1*t4*abb15n19+t&
      &1*t5*abb15n25+t1*t7*abb15n9+t10*t13*abb15n36+t10*t5*abb15n23+t11*t13*abb1&
      &5n36+t11*t5*abb15n23+t13*t14*abb15n39+t13*t2*abb15n45+t13*t3*abb15n46+t13&
      &*t4*abb15n47+t13*t5*abb15n53+t13*t6*abb15n37+t13*t7*abb15n34+t13*t8*abb15&
      &n35+t13*t9*abb15n36+t2*t6*abb15n16+t3*t5*abb15n22+t3*t6*abb15n15+t3*t7*ab&
      &b15n3+t3*t8*abb15n32+t4*t6*abb15n14+t5*t6*abb15n33+t5*t7*abb15n27+t5*t8*a&
      &bb15n21+t5*t9*abb15n23+t6*t7*abb15n5+t1*t5*t7*abb15n24+t10*t13*t5*abb15n5&
      &9+t11*t13*t5*abb15n59+t13*t14*t5*abb15n57+t13*t14*t7*abb15n38+t13*t15*t2*&
      &abb15n42+t13*t15*t3*abb15n43+t13*t15*t4*abb15n44+t13*t16*t2*abb15n56+t13*&
      &t16*t3*abb15n55+t13*t16*t4*abb15n54+t13*t2*t5*abb15n60+t13*t2*t6*abb15n50&
      &+t13*t2*t7*abb15n41+t13*t3*t5*abb15n61+t13*t3*t6*abb15n49+t13*t4*t5*abb15&
      &n62+t13*t4*t6*abb15n48+t13*t4*t7*abb15n40+t13*t5*t6*abb15n64+t13*t5*t7*ab&
      &b15n52+t13*t5*t8*abb15n63+t13*t5*t9*abb15n59+t13*t5*abb15n51*(Q(1)*spvak5&
      &k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))+t13*t5*abb15n58&
      &*(Q(1)*spvak5k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q(4)*spvak5k8(4))+t1&
      &4*t3*t7*abb15n4+t3*t5*t7*abb15n28+t3*t6*t7*abb15n2+t3*t7*abb15n26*(Q(1)*s&
      &pvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))+t13*t5*t6*&
      &t7*abb15n65)

      numerator = cmplx(real(d15, ki), aimag(d15), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P3B_uux_uux_d15h0l1
