module     P3B_uux_uux_d51h0l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P3B_uux_
   ! uux/helicity0/d51h0l1.f90
   ! generator: haggies (1.1)
   use P3B_uux_uux_config, only: ki
   use P3B_uux_uux_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P3B_uux_uux_groups, only: &
!           & sign => diagram51_sign, shift => diagram51_shift
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd51h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d51
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2-k4
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d51 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t5 = (Q(1)*spvak1k4(1)-Q(2)*spvak1k4(2)-Q(3)*spvak1k4(3)-Q(4)*spvak1k4(4))
      t6 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t7 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t8 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t9 = t3*abb51n12
      t10 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t11 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t12 = t3*abb51n13
      t13 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t14 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t15 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t16 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t17 = (Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q(3)*spvak6k4(3)-Q(4)*spvak6k4(4)&
      &)
      t18 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      t19 = (Q(1)*spvak8k4(1)-Q(2)*spvak8k4(2)-Q(3)*spvak8k4(3)-Q(4)*spvak8k4(4)&
      &)
      t20 = (Q(1)*spvak2k3(1)-Q(2)*spvak2k3(2)-Q(3)*spvak2k3(3)-Q(4)*spvak2k3(4)&
      &)
      t21 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4)&
      &)
      t22 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t23 = (Q(1)*spvak2k7(1)-Q(2)*spvak2k7(2)-Q(3)*spvak2k7(3)-Q(4)*spvak2k7(4)&
      &)
      t24 = (Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4)&
      &)
      t25 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4)&
      &)
      d51 = (t1*abb51n32+t10*t9+t11*t12+t12*t13+t2*abb51n37+t3*abb51n47+t3*abb51&
      &n6+t4*abb51n7+t8*t9+t1*t25*abb51n62+t10*t20*abb51n33+t10*t5*abb51n8+t11*t&
      &20*abb51n34+t11*t5*abb51n9+t13*t20*abb51n34+t13*t5*abb51n9+t14*t16*abb51n&
      &20+t14*t17*abb51n23+t14*t18*abb51n28+t14*t19*abb51n31+t14*t2*abb51n51+t14&
      &*t21*abb51n38+t14*t22*abb51n41+t14*t23*abb51n46+t14*t24*abb51n50+t14*t25*&
      &abb51n60+t14*t6*abb51n14+t14*t7*abb51n19+t15*t16*abb51n22+t15*t17*abb51n2&
      &5+t15*t18*abb51n26+t15*t19*abb51n29+t15*t2*abb51n53+t15*t21*abb51n40+t15*&
      &t22*abb51n43+t15*t23*abb51n44+t15*t24*abb51n48+t15*t25*abb51n58+t15*t6*ab&
      &b51n16+t15*t7*abb51n17+t16*t25*abb51n55+t16*t3*abb51n21+t17*t25*abb51n54+&
      &t17*t3*abb51n24+t18*t25*abb51n57+t18*t3*abb51n27+t19*t25*abb51n56+t19*t3*&
      &abb51n30+t2*t25*abb51n67+t2*t3*abb51n52+t20*t6*abb51n35+t20*t7*abb51n36+t&
      &20*t8*abb51n33+t21*t25*abb51n63+t21*t3*abb51n39+t22*t25*abb51n64+t22*t3*a&
      &bb51n42+t23*t25*abb51n65+t23*t3*abb51n45+t24*t25*abb51n66+t24*t3*abb51n49&
      &+t25*t3*abb51n59+t25*t4*abb51n61+t3*t6*abb51n15+t3*t7*abb51n18+t5*t6*abb5&
      &1n10+t5*t7*abb51n11+t5*t8*abb51n8+t10*t2*t25*abb51n69+t11*t2*t25*abb51n68&
      &+t13*t2*t25*abb51n68+t2*t25*t6*abb51n70+t2*t25*t7*abb51n71+t2*t25*t8*abb5&
      &1n69)
      numerator = cmplx(real(d51, ki), aimag(d51), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd51h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d51
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2-k4
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d51 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t5 = (Q(1)*spvak1k4(1)-Q(2)*spvak1k4(2)-Q(3)*spvak1k4(3)-Q(4)*spvak1k4(4))
      t6 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t7 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t8 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t9 = t3*abb51n12
      t10 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t11 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t12 = t3*abb51n13
      t13 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t14 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t15 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t16 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t17 = (Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q(3)*spvak6k4(3)-Q(4)*spvak6k4(4)&
      &)
      t18 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      t19 = (Q(1)*spvak8k4(1)-Q(2)*spvak8k4(2)-Q(3)*spvak8k4(3)-Q(4)*spvak8k4(4)&
      &)
      t20 = (Q(1)*spvak2k3(1)-Q(2)*spvak2k3(2)-Q(3)*spvak2k3(3)-Q(4)*spvak2k3(4)&
      &)
      t21 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4)&
      &)
      t22 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t23 = (Q(1)*spvak2k7(1)-Q(2)*spvak2k7(2)-Q(3)*spvak2k7(3)-Q(4)*spvak2k7(4)&
      &)
      t24 = (Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4)&
      &)
      t25 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4)&
      &)
      d51 = (t1*abb51n32+t10*t9+t11*t12+t12*t13+t2*abb51n37+t3*abb51n47+t3*abb51&
      &n6+t4*abb51n7+t8*t9+t1*t25*abb51n62+t10*t20*abb51n33+t10*t5*abb51n8+t11*t&
      &20*abb51n34+t11*t5*abb51n9+t13*t20*abb51n34+t13*t5*abb51n9+t14*t16*abb51n&
      &20+t14*t17*abb51n23+t14*t18*abb51n28+t14*t19*abb51n31+t14*t2*abb51n51+t14&
      &*t21*abb51n38+t14*t22*abb51n41+t14*t23*abb51n46+t14*t24*abb51n50+t14*t25*&
      &abb51n60+t14*t6*abb51n14+t14*t7*abb51n19+t15*t16*abb51n22+t15*t17*abb51n2&
      &5+t15*t18*abb51n26+t15*t19*abb51n29+t15*t2*abb51n53+t15*t21*abb51n40+t15*&
      &t22*abb51n43+t15*t23*abb51n44+t15*t24*abb51n48+t15*t25*abb51n58+t15*t6*ab&
      &b51n16+t15*t7*abb51n17+t16*t25*abb51n55+t16*t3*abb51n21+t17*t25*abb51n54+&
      &t17*t3*abb51n24+t18*t25*abb51n57+t18*t3*abb51n27+t19*t25*abb51n56+t19*t3*&
      &abb51n30+t2*t25*abb51n67+t2*t3*abb51n52+t20*t6*abb51n35+t20*t7*abb51n36+t&
      &20*t8*abb51n33+t21*t25*abb51n63+t21*t3*abb51n39+t22*t25*abb51n64+t22*t3*a&
      &bb51n42+t23*t25*abb51n65+t23*t3*abb51n45+t24*t25*abb51n66+t24*t3*abb51n49&
      &+t25*t3*abb51n59+t25*t4*abb51n61+t3*t6*abb51n15+t3*t7*abb51n18+t5*t6*abb5&
      &1n10+t5*t7*abb51n11+t5*t8*abb51n8+t10*t2*t25*abb51n69+t11*t2*t25*abb51n68&
      &+t13*t2*t25*abb51n68+t2*t25*t6*abb51n70+t2*t25*t7*abb51n71+t2*t25*t8*abb5&
      &1n69)

      numerator = cmplx(real(d51, ki), aimag(d51), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P3B_uux_uux_d51h0l1
