module     P3B_uux_uux_d60h0l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P3B_uux_
   ! uux/helicity0/d60h0l1.f90
   ! generator: haggies (1.1)
   use P3B_uux_uux_config, only: ki
   use P3B_uux_uux_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P3B_uux_uux_groups, only: &
!           & sign => diagram60_sign, shift => diagram60_shift
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd60h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d60
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2-k4
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d60 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4))
      t3 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      t6 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t7 = t1*abb60n14
      t8 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t9 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t10 = t1*abb60n15
      t11 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t12 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t13 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t14 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t15 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t16 = (Q(1)*spvak2k3(1)-Q(2)*spvak2k3(2)-Q(3)*spvak2k3(3)-Q(4)*spvak2k3(4)&
      &)
      t17 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t18 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      t19 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      t20 = (Q(1)*spvak6k3(1)-Q(2)*spvak6k3(2)-Q(3)*spvak6k3(3)-Q(4)*spvak6k3(4)&
      &)
      t21 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4)&
      &)
      t22 = (Q(1)*spvak8k3(1)-Q(2)*spvak8k3(2)-Q(3)*spvak8k3(3)-Q(4)*spvak8k3(4)&
      &)
      t23 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t24 = (Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4)&
      &)
      t25 = (Q(1)*spvak1k4(1)-Q(2)*spvak1k4(2)-Q(3)*spvak1k4(3)-Q(4)*spvak1k4(4)&
      &)
      t26 = (Q(1)*spvak1k5(1)-Q(2)*spvak1k5(2)-Q(3)*spvak1k5(3)-Q(4)*spvak1k5(4)&
      &)
      t27 = (Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4)&
      &)
      t28 = (Q(1)*spvak1k7(1)-Q(2)*spvak1k7(2)-Q(3)*spvak1k7(3)-Q(4)*spvak1k7(4)&
      &)
      t29 = (Q(1)*spvak1k8(1)-Q(2)*spvak1k8(2)-Q(3)*spvak1k8(3)-Q(4)*spvak1k8(4)&
      &)
      d60 = (t1*abb60n12+t1*abb60n22+t1*abb60n68+t10*t11+t10*t9+t2*abb60n13+t2*a&
      &bb60n71+t3*abb60n36+t4*abb60n69+t6*t7+t7*t8+t1*t13*abb60n17+t1*t15*abb60n&
      &20+t1*t17*abb60n43+t1*t18*abb60n47+t1*t2*abb60n28+t1*t23*abb60n64+t1*t24*&
      &abb60n70+t1*t5*abb60n26+t1*abb60n41*(Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q(&
      &3)*spvak6k4(3)-Q(4)*spvak6k4(4))+t1*abb60n45*(Q(1)*spvak8k4(1)-Q(2)*spvak&
      &8k4(2)-Q(3)*spvak8k4(3)-Q(4)*spvak8k4(4))+t1*abb60n61*(Q(1)*spvak2k5(1)-Q&
      &(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+t1*abb60n65*(Q(1)*spva&
      &k2k7(1)-Q(2)*spvak2k7(2)-Q(3)*spvak2k7(3)-Q(4)*spvak2k7(4))+t11*t16*abb60&
      &n37+t11*t25*abb60n73+t12*t13*abb60n16+t12*t15*abb60n21+t12*t17*abb60n44+t&
      &12*t18*abb60n46+t12*t19*abb60n49+t12*t2*abb60n29+t12*t20*abb60n51+t12*t21&
      &*abb60n54+t12*t22*abb60n56+t12*t23*abb60n62+t12*t24*abb60n67+t12*t26*abb6&
      &0n77+t12*t27*abb60n79+t12*t28*abb60n80+t12*t29*abb60n82+t12*t5*abb60n24+t&
      &13*t14*abb60n18+t13*t16*abb60n39+t13*t25*abb60n74+t14*t15*abb60n19+t14*t1&
      &7*abb60n42+t14*t18*abb60n48+t14*t19*abb60n50+t14*t2*abb60n30+t14*t20*abb6&
      &0n52+t14*t21*abb60n53+t14*t22*abb60n55+t14*t23*abb60n63+t14*t24*abb60n66+&
      &t14*t26*abb60n76+t14*t27*abb60n78+t14*t28*abb60n81+t14*t29*abb60n83+t14*t&
      &5*abb60n23+t15*t16*abb60n40+t15*t25*abb60n75+t16*t6*abb60n38+t16*t8*abb60&
      &n38+t16*t9*abb60n37+t19*t5*abb60n58+t2*t5*abb60n11+t2*t5*abb60n31+t20*t5*&
      &abb60n57+t21*t5*abb60n60+t22*t5*abb60n59+t25*t6*abb60n72+t25*t8*abb60n72+&
      &t25*t9*abb60n73+t26*t5*abb60n84+t27*t5*abb60n85+t28*t5*abb60n86+t29*t5*ab&
      &b60n87+t3*t5*abb60n25+t4*t5*abb60n27+t11*t2*t5*abb60n32+t13*t2*t5*abb60n3&
      &4+t15*t2*t5*abb60n35+t2*t5*t6*abb60n33+t2*t5*t8*abb60n33+t2*t5*t9*abb60n3&
      &2)
      numerator = cmplx(real(d60, ki), aimag(d60), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd60h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d60
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2-k4
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d60 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4))
      t3 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      t6 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t7 = t1*abb60n14
      t8 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t9 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t10 = t1*abb60n15
      t11 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t12 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t13 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t14 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t15 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t16 = (Q(1)*spvak2k3(1)-Q(2)*spvak2k3(2)-Q(3)*spvak2k3(3)-Q(4)*spvak2k3(4)&
      &)
      t17 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t18 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      t19 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      t20 = (Q(1)*spvak6k3(1)-Q(2)*spvak6k3(2)-Q(3)*spvak6k3(3)-Q(4)*spvak6k3(4)&
      &)
      t21 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4)&
      &)
      t22 = (Q(1)*spvak8k3(1)-Q(2)*spvak8k3(2)-Q(3)*spvak8k3(3)-Q(4)*spvak8k3(4)&
      &)
      t23 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t24 = (Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4)&
      &)
      t25 = (Q(1)*spvak1k4(1)-Q(2)*spvak1k4(2)-Q(3)*spvak1k4(3)-Q(4)*spvak1k4(4)&
      &)
      t26 = (Q(1)*spvak1k5(1)-Q(2)*spvak1k5(2)-Q(3)*spvak1k5(3)-Q(4)*spvak1k5(4)&
      &)
      t27 = (Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4)&
      &)
      t28 = (Q(1)*spvak1k7(1)-Q(2)*spvak1k7(2)-Q(3)*spvak1k7(3)-Q(4)*spvak1k7(4)&
      &)
      t29 = (Q(1)*spvak1k8(1)-Q(2)*spvak1k8(2)-Q(3)*spvak1k8(3)-Q(4)*spvak1k8(4)&
      &)
      d60 = (t1*abb60n12+t1*abb60n22+t1*abb60n68+t10*t11+t10*t9+t2*abb60n13+t2*a&
      &bb60n71+t3*abb60n36+t4*abb60n69+t6*t7+t7*t8+t1*t13*abb60n17+t1*t15*abb60n&
      &20+t1*t17*abb60n43+t1*t18*abb60n47+t1*t2*abb60n28+t1*t23*abb60n64+t1*t24*&
      &abb60n70+t1*t5*abb60n26+t1*abb60n41*(Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q(&
      &3)*spvak6k4(3)-Q(4)*spvak6k4(4))+t1*abb60n45*(Q(1)*spvak8k4(1)-Q(2)*spvak&
      &8k4(2)-Q(3)*spvak8k4(3)-Q(4)*spvak8k4(4))+t1*abb60n61*(Q(1)*spvak2k5(1)-Q&
      &(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+t1*abb60n65*(Q(1)*spva&
      &k2k7(1)-Q(2)*spvak2k7(2)-Q(3)*spvak2k7(3)-Q(4)*spvak2k7(4))+t11*t16*abb60&
      &n37+t11*t25*abb60n73+t12*t13*abb60n16+t12*t15*abb60n21+t12*t17*abb60n44+t&
      &12*t18*abb60n46+t12*t19*abb60n49+t12*t2*abb60n29+t12*t20*abb60n51+t12*t21&
      &*abb60n54+t12*t22*abb60n56+t12*t23*abb60n62+t12*t24*abb60n67+t12*t26*abb6&
      &0n77+t12*t27*abb60n79+t12*t28*abb60n80+t12*t29*abb60n82+t12*t5*abb60n24+t&
      &13*t14*abb60n18+t13*t16*abb60n39+t13*t25*abb60n74+t14*t15*abb60n19+t14*t1&
      &7*abb60n42+t14*t18*abb60n48+t14*t19*abb60n50+t14*t2*abb60n30+t14*t20*abb6&
      &0n52+t14*t21*abb60n53+t14*t22*abb60n55+t14*t23*abb60n63+t14*t24*abb60n66+&
      &t14*t26*abb60n76+t14*t27*abb60n78+t14*t28*abb60n81+t14*t29*abb60n83+t14*t&
      &5*abb60n23+t15*t16*abb60n40+t15*t25*abb60n75+t16*t6*abb60n38+t16*t8*abb60&
      &n38+t16*t9*abb60n37+t19*t5*abb60n58+t2*t5*abb60n11+t2*t5*abb60n31+t20*t5*&
      &abb60n57+t21*t5*abb60n60+t22*t5*abb60n59+t25*t6*abb60n72+t25*t8*abb60n72+&
      &t25*t9*abb60n73+t26*t5*abb60n84+t27*t5*abb60n85+t28*t5*abb60n86+t29*t5*ab&
      &b60n87+t3*t5*abb60n25+t4*t5*abb60n27+t11*t2*t5*abb60n32+t13*t2*t5*abb60n3&
      &4+t15*t2*t5*abb60n35+t2*t5*t6*abb60n33+t2*t5*t8*abb60n33+t2*t5*t9*abb60n3&
      &2)

      numerator = cmplx(real(d60, ki), aimag(d60), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P3B_uux_uux_d60h0l1
