module     P3B_uux_uux_d16h1l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P3B_uux_
   ! uux/helicity1/d16h1l1.f90
   ! generator: haggies (1.1)
   use P3B_uux_uux_config, only: ki
   use P3B_uux_uux_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P3B_uux_uux_groups, only: &
!           & sign => diagram16_sign, shift => diagram16_shift
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd16h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d16
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2-k4
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d16 = 0.0_ki
      t1 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t4 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t5 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t6 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4))
      t7 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4))
      t10 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4)&
      &)
      t11 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      t12 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t13 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4)&
      &)
      t14 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t15 = (Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4k6(4)&
      &)
      d16 = (t1*abb16n25+t2*abb16n26+t2*t2*abb16n43+t3*abb16n27+t4*abb16n4+t5*ab&
      &b16n41+t6*abb16n47+t7*abb16n5+t8*abb16n5+t9*abb16n6+t1*t10*abb16n40+t1*t2&
      &*abb16n44+t1*t4*abb16n22+t1*t6*abb16n49+t1*t9*abb16n28+t10*t11*abb16n10+t&
      &10*t12*abb16n2+t10*t2*abb16n39+t10*t3*abb16n38+t10*t5*abb16n45+t10*t6*abb&
      &16n62+t10*t7*abb16n11+t11*t2*abb16n17+t12*t2*abb16n12+t13*t2*abb16n9+t2*t&
      &3*abb16n42+t2*t4*abb16n23+t2*t5*abb16n16+t2*t6*abb16n50+t2*t7*abb16n18+t2&
      &*t9*abb16n29+t3*t4*abb16n24+t3*t6*abb16n51+t3*t9*abb16n30+t4*t5*abb16n3+t&
      &4*t6*abb16n48+t5*t6*abb16n52+t5*t9*abb16n7+t6*t7*abb16n51+t6*t8*abb16n51+&
      &t6*t9*abb16n53+t1*t10*t4*abb16n37+t1*t14*t4*abb16n19+t1*t15*t4*abb16n31+t&
      &1*t4*t5*abb16n13+t1*t4*t6*abb16n56+t10*t11*t6*abb16n63+t10*t12*t6*abb16n4&
      &6+t10*t2*t4*abb16n36+t10*t2*t6*abb16n66+t10*t3*t4*abb16n35+t10*t4*t6*abb1&
      &6n61+t10*t5*t6*abb16n64+t10*t6*t7*abb16n65+t13*t4*t5*abb16n8+t13*t4*t6*ab&
      &b16n55+t14*t2*t4*abb16n20+t14*t3*t4*abb16n21+t15*t2*t4*abb16n32+t15*t3*t4&
      &*abb16n33+t2*t4*t5*abb16n14+t2*t5*t6*abb16n60+t2*t6*abb16n58*(Q(1)*spvak5&
      &k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q(4)*spvak5k8(4))+t2*t6*abb16n59*&
      &(Q(1)*spvak7k6(1)-Q(2)*spvak7k6(2)-Q(3)*spvak7k6(3)-Q(4)*spvak7k6(4))+t3*&
      &t4*t5*abb16n15+t3*t4*t6*abb16n57+t4*t6*abb16n34*(Q(1)*spvak4k1(1)-Q(2)*sp&
      &vak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4))+t5*t6*t9*abb16n54+t10*t4*t5*&
      &t6*abb16n67)
      numerator = cmplx(real(d16, ki), aimag(d16), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd16h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d16
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2-k4
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d16 = 0.0_ki
      t1 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t4 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t5 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t6 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4))
      t7 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4))
      t10 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4)&
      &)
      t11 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      t12 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t13 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4)&
      &)
      t14 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t15 = (Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4k6(4)&
      &)
      d16 = (t1*abb16n25+t2*abb16n26+t2*t2*abb16n43+t3*abb16n27+t4*abb16n4+t5*ab&
      &b16n41+t6*abb16n47+t7*abb16n5+t8*abb16n5+t9*abb16n6+t1*t10*abb16n40+t1*t2&
      &*abb16n44+t1*t4*abb16n22+t1*t6*abb16n49+t1*t9*abb16n28+t10*t11*abb16n10+t&
      &10*t12*abb16n2+t10*t2*abb16n39+t10*t3*abb16n38+t10*t5*abb16n45+t10*t6*abb&
      &16n62+t10*t7*abb16n11+t11*t2*abb16n17+t12*t2*abb16n12+t13*t2*abb16n9+t2*t&
      &3*abb16n42+t2*t4*abb16n23+t2*t5*abb16n16+t2*t6*abb16n50+t2*t7*abb16n18+t2&
      &*t9*abb16n29+t3*t4*abb16n24+t3*t6*abb16n51+t3*t9*abb16n30+t4*t5*abb16n3+t&
      &4*t6*abb16n48+t5*t6*abb16n52+t5*t9*abb16n7+t6*t7*abb16n51+t6*t8*abb16n51+&
      &t6*t9*abb16n53+t1*t10*t4*abb16n37+t1*t14*t4*abb16n19+t1*t15*t4*abb16n31+t&
      &1*t4*t5*abb16n13+t1*t4*t6*abb16n56+t10*t11*t6*abb16n63+t10*t12*t6*abb16n4&
      &6+t10*t2*t4*abb16n36+t10*t2*t6*abb16n66+t10*t3*t4*abb16n35+t10*t4*t6*abb1&
      &6n61+t10*t5*t6*abb16n64+t10*t6*t7*abb16n65+t13*t4*t5*abb16n8+t13*t4*t6*ab&
      &b16n55+t14*t2*t4*abb16n20+t14*t3*t4*abb16n21+t15*t2*t4*abb16n32+t15*t3*t4&
      &*abb16n33+t2*t4*t5*abb16n14+t2*t5*t6*abb16n60+t2*t6*abb16n58*(Q(1)*spvak5&
      &k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q(4)*spvak5k8(4))+t2*t6*abb16n59*&
      &(Q(1)*spvak7k6(1)-Q(2)*spvak7k6(2)-Q(3)*spvak7k6(3)-Q(4)*spvak7k6(4))+t3*&
      &t4*t5*abb16n15+t3*t4*t6*abb16n57+t4*t6*abb16n34*(Q(1)*spvak4k1(1)-Q(2)*sp&
      &vak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4))+t5*t6*t9*abb16n54+t10*t4*t5*&
      &t6*abb16n67)

      numerator = cmplx(real(d16, ki), aimag(d16), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P3B_uux_uux_d16h1l1
