module     P3B_uux_uux_d21h1l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P3B_uux_
   ! uux/helicity1/d21h1l1.f90
   ! generator: haggies (1.1)
   use P3B_uux_uux_config, only: ki
   use P3B_uux_uux_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P3B_uux_uux_groups, only: &
!           & sign => diagram21_sign, shift => diagram21_shift
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd21h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d21
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k6-k5
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d21 = 0.0_ki
      t1 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t2 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4))
      t6 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4))
      t7 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4))
      t8 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t9 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4))
      t10 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t11 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t12 = t2*abb21n29
      t13 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t14 = t3*abb21n30
      t15 = t4*abb21n33
      t16 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      t17 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t18 = (Q(1)*spvak7k6(1)-Q(2)*spvak7k6(2)-Q(3)*spvak7k6(3)-Q(4)*spvak7k6(4)&
      &)
      t19 = (Q(1)*spvak5k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q(4)*spvak5k8(4)&
      &)
      t20 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      d21 = (t1*abb21n14+t11*t12+t11*t14+t11*t15+t12*t13+t13*t14+t13*t15+t14*t4+&
      &t2*abb21n26+t3*abb21n27+t3*t3*abb21n31+t4*abb21n28+t5*abb21n3+t6*abb21n52&
      &+t7*abb21n8+t8*abb21n9+t1*t10*abb21n13+t1*t11*abb21n5+t1*t13*abb21n5+t1*t&
      &16*abb21n7+t1*t3*abb21n18+t1*t6*abb21n55+t1*t9*abb21n10+t10*t2*abb21n36+t&
      &10*t3*abb21n35+t10*t4*abb21n34+t10*t5*abb21n2+t10*t6*abb21n61+t10*t7*abb2&
      &1n4+t10*t8*abb21n6+t11*t6*abb21n60+t13*t6*abb21n60+t16*t2*abb21n40+t16*t3&
      &*abb21n39+t16*t4*abb21n37+t16*t6*abb21n62+t17*t6*abb21n38+t2*t3*abb21n32+&
      &t2*t9*abb21n41+t3*t5*abb21n12+t3*t6*abb21n59+t3*t7*abb21n17+t3*t8*abb21n1&
      &9+t3*t9*abb21n42+t4*t9*abb21n43+t5*t6*abb21n15+t6*t7*abb21n51+t6*t8*abb21&
      &n56+t6*t9*abb21n66+t1*t10*t6*abb21n57+t1*t11*t6*abb21n54+t1*t13*t6*abb21n&
      &54+t1*t16*t9*abb21n11+t1*t2*t9*abb21n20+t1*t20*t6*abb21n69+t1*t3*t6*abb21&
      &n53+t1*t3*t9*abb21n21+t1*t4*t9*abb21n22+t10*t2*t9*abb21n47+t10*t3*t6*abb2&
      &1n64+t10*t3*t9*abb21n48+t10*t4*t9*abb21n49+t10*t5*t6*abb21n16+t10*t6*t7*a&
      &bb21n58+t10*t6*t8*abb21n63+t10*t6*t9*abb21n67+t16*t6*t9*abb21n68+t17*t6*t&
      &9*abb21n50+t18*t2*t9*abb21n25+t18*t3*t9*abb21n24+t18*t4*t9*abb21n23+t19*t&
      &2*t9*abb21n44+t19*t3*t9*abb21n45+t19*t4*t9*abb21n46+t2*t6*t9*abb21n72+t20&
      &*t3*t6*abb21n70+t3*t6*abb21n65*(Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*sp&
      &vak4k6(3)-Q(4)*spvak4k6(4))+t4*t6*t9*abb21n71+t1*t10*t6*t9*abb21n73)
      numerator = cmplx(real(d21, ki), aimag(d21), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd21h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d21
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k6-k5
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d21 = 0.0_ki
      t1 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t2 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4))
      t6 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4))
      t7 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4))
      t8 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t9 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4))
      t10 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t11 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t12 = t2*abb21n29
      t13 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t14 = t3*abb21n30
      t15 = t4*abb21n33
      t16 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      t17 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t18 = (Q(1)*spvak7k6(1)-Q(2)*spvak7k6(2)-Q(3)*spvak7k6(3)-Q(4)*spvak7k6(4)&
      &)
      t19 = (Q(1)*spvak5k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q(4)*spvak5k8(4)&
      &)
      t20 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      d21 = (t1*abb21n14+t11*t12+t11*t14+t11*t15+t12*t13+t13*t14+t13*t15+t14*t4+&
      &t2*abb21n26+t3*abb21n27+t3*t3*abb21n31+t4*abb21n28+t5*abb21n3+t6*abb21n52&
      &+t7*abb21n8+t8*abb21n9+t1*t10*abb21n13+t1*t11*abb21n5+t1*t13*abb21n5+t1*t&
      &16*abb21n7+t1*t3*abb21n18+t1*t6*abb21n55+t1*t9*abb21n10+t10*t2*abb21n36+t&
      &10*t3*abb21n35+t10*t4*abb21n34+t10*t5*abb21n2+t10*t6*abb21n61+t10*t7*abb2&
      &1n4+t10*t8*abb21n6+t11*t6*abb21n60+t13*t6*abb21n60+t16*t2*abb21n40+t16*t3&
      &*abb21n39+t16*t4*abb21n37+t16*t6*abb21n62+t17*t6*abb21n38+t2*t3*abb21n32+&
      &t2*t9*abb21n41+t3*t5*abb21n12+t3*t6*abb21n59+t3*t7*abb21n17+t3*t8*abb21n1&
      &9+t3*t9*abb21n42+t4*t9*abb21n43+t5*t6*abb21n15+t6*t7*abb21n51+t6*t8*abb21&
      &n56+t6*t9*abb21n66+t1*t10*t6*abb21n57+t1*t11*t6*abb21n54+t1*t13*t6*abb21n&
      &54+t1*t16*t9*abb21n11+t1*t2*t9*abb21n20+t1*t20*t6*abb21n69+t1*t3*t6*abb21&
      &n53+t1*t3*t9*abb21n21+t1*t4*t9*abb21n22+t10*t2*t9*abb21n47+t10*t3*t6*abb2&
      &1n64+t10*t3*t9*abb21n48+t10*t4*t9*abb21n49+t10*t5*t6*abb21n16+t10*t6*t7*a&
      &bb21n58+t10*t6*t8*abb21n63+t10*t6*t9*abb21n67+t16*t6*t9*abb21n68+t17*t6*t&
      &9*abb21n50+t18*t2*t9*abb21n25+t18*t3*t9*abb21n24+t18*t4*t9*abb21n23+t19*t&
      &2*t9*abb21n44+t19*t3*t9*abb21n45+t19*t4*t9*abb21n46+t2*t6*t9*abb21n72+t20&
      &*t3*t6*abb21n70+t3*t6*abb21n65*(Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*sp&
      &vak4k6(3)-Q(4)*spvak4k6(4))+t4*t6*t9*abb21n71+t1*t10*t6*t9*abb21n73)

      numerator = cmplx(real(d21, ki), aimag(d21), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P3B_uux_uux_d21h1l1
