module     P3B_uux_uux_d54h1l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P3B_uux_
   ! uux/helicity1/d54h1l1.f90
   ! generator: haggies (1.1)
   use P3B_uux_uux_config, only: ki
   use P3B_uux_uux_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P3B_uux_uux_groups, only: &
!           & sign => diagram54_sign, shift => diagram54_shift
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd54h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d54
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2-k4
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d54 = 0.0_ki
      t1 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t4 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4))
      t5 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t6 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t7 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t8 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t9 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t10 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4)&
      &)
      t11 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t12 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t13 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t14 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      t15 = (Q(1)*spvak6k3(1)-Q(2)*spvak6k3(2)-Q(3)*spvak6k3(3)-Q(4)*spvak6k3(4)&
      &)
      t16 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4)&
      &)
      t17 = (Q(1)*spvak8k3(1)-Q(2)*spvak8k3(2)-Q(3)*spvak8k3(3)-Q(4)*spvak8k3(4)&
      &)
      t18 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4)&
      &)
      t19 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4)&
      &)
      t20 = (Q(1)*spvak1k5(1)-Q(2)*spvak1k5(2)-Q(3)*spvak1k5(3)-Q(4)*spvak1k5(4)&
      &)
      t21 = (Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4)&
      &)
      t22 = (Q(1)*spvak1k7(1)-Q(2)*spvak1k7(2)-Q(3)*spvak1k7(3)-Q(4)*spvak1k7(4)&
      &)
      t23 = (Q(1)*spvak1k8(1)-Q(2)*spvak1k8(2)-Q(3)*spvak1k8(3)-Q(4)*spvak1k8(4)&
      &)
      t24 = t2*abb54n7
      t25 = t2*abb54n8
      d54 = (t1*abb54n15+t11*t25+t12*t24+t13*t24+t2*abb54n41+t2*abb54n6+t25*t9+t&
      &3*abb54n42+t4*abb54n59+t1*t18*abb54n46+t10*t11*abb54n16+t10*t12*abb54n17+&
      &t10*t13*abb54n17+t10*t5*abb54n18+t10*t7*abb54n19+t10*t9*abb54n16+t11*t19*&
      &abb54n48+t12*t19*abb54n47+t13*t19*abb54n47+t14*t18*abb54n33+t14*t6*abb54n&
      &21+t14*t8*abb54n20+t15*t18*abb54n32+t15*t6*abb54n23+t15*t8*abb54n22+t16*t&
      &18*abb54n35+t16*t6*abb54n24+t16*t8*abb54n25+t17*t18*abb54n34+t17*t6*abb54&
      &n26+t17*t8*abb54n27+t18*t2*abb54n45+t18*t20*abb54n63+t18*t21*abb54n64+t18&
      &*t22*abb54n65+t18*t23*abb54n66+t18*t3*abb54n44+t18*t4*abb54n67+t18*t6*abb&
      &54n40+t18*t8*abb54n39+t19*t5*abb54n49+t19*t7*abb54n50+t19*t9*abb54n48+t2*&
      &t4*abb54n60+t2*t5*abb54n10+t2*t7*abb54n13+t2*abb54n28*(Q(1)*spvak5k2(1)-Q&
      &(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))+t2*abb54n29*(Q(1)*spva&
      &k6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4))+t2*abb54n30*(&
      &Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4))+t2*a&
      &bb54n31*(Q(1)*spvak8k2(1)-Q(2)*spvak8k2(2)-Q(3)*spvak8k2(3)-Q(4)*spvak8k2&
      &(4))+t2*abb54n36*(Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(4)&
      &*spvak4k5(4))+t2*abb54n37*(Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k&
      &6(3)-Q(4)*spvak4k6(4))+t2*abb54n38*(Q(1)*spvak4k7(1)-Q(2)*spvak4k7(2)-Q(3&
      &)*spvak4k7(3)-Q(4)*spvak4k7(4))+t2*abb54n43*(Q(1)*spvak4k8(1)-Q(2)*spvak4&
      &k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4))+t20*t6*abb54n51+t20*t8*abb54n52+&
      &t21*t6*abb54n53+t21*t8*abb54n54+t22*t6*abb54n56+t22*t8*abb54n55+t23*t6*ab&
      &b54n58+t23*t8*abb54n57+t4*t6*abb54n61+t4*t8*abb54n62+t5*t6*abb54n11+t5*t8&
      &*abb54n9+t6*t7*abb54n12+t7*t8*abb54n14+t11*t18*t4*abb54n69+t12*t18*t4*abb&
      &54n68+t13*t18*t4*abb54n68+t18*t4*t5*abb54n70+t18*t4*t7*abb54n71+t18*t4*t9&
      &*abb54n69)
      numerator = cmplx(real(d54, ki), aimag(d54), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd54h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d54
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2-k4
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d54 = 0.0_ki
      t1 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t4 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4))
      t5 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t6 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t7 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t8 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t9 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t10 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4)&
      &)
      t11 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t12 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t13 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t14 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      t15 = (Q(1)*spvak6k3(1)-Q(2)*spvak6k3(2)-Q(3)*spvak6k3(3)-Q(4)*spvak6k3(4)&
      &)
      t16 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4)&
      &)
      t17 = (Q(1)*spvak8k3(1)-Q(2)*spvak8k3(2)-Q(3)*spvak8k3(3)-Q(4)*spvak8k3(4)&
      &)
      t18 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4)&
      &)
      t19 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4)&
      &)
      t20 = (Q(1)*spvak1k5(1)-Q(2)*spvak1k5(2)-Q(3)*spvak1k5(3)-Q(4)*spvak1k5(4)&
      &)
      t21 = (Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4)&
      &)
      t22 = (Q(1)*spvak1k7(1)-Q(2)*spvak1k7(2)-Q(3)*spvak1k7(3)-Q(4)*spvak1k7(4)&
      &)
      t23 = (Q(1)*spvak1k8(1)-Q(2)*spvak1k8(2)-Q(3)*spvak1k8(3)-Q(4)*spvak1k8(4)&
      &)
      t24 = t2*abb54n7
      t25 = t2*abb54n8
      d54 = (t1*abb54n15+t11*t25+t12*t24+t13*t24+t2*abb54n41+t2*abb54n6+t25*t9+t&
      &3*abb54n42+t4*abb54n59+t1*t18*abb54n46+t10*t11*abb54n16+t10*t12*abb54n17+&
      &t10*t13*abb54n17+t10*t5*abb54n18+t10*t7*abb54n19+t10*t9*abb54n16+t11*t19*&
      &abb54n48+t12*t19*abb54n47+t13*t19*abb54n47+t14*t18*abb54n33+t14*t6*abb54n&
      &21+t14*t8*abb54n20+t15*t18*abb54n32+t15*t6*abb54n23+t15*t8*abb54n22+t16*t&
      &18*abb54n35+t16*t6*abb54n24+t16*t8*abb54n25+t17*t18*abb54n34+t17*t6*abb54&
      &n26+t17*t8*abb54n27+t18*t2*abb54n45+t18*t20*abb54n63+t18*t21*abb54n64+t18&
      &*t22*abb54n65+t18*t23*abb54n66+t18*t3*abb54n44+t18*t4*abb54n67+t18*t6*abb&
      &54n40+t18*t8*abb54n39+t19*t5*abb54n49+t19*t7*abb54n50+t19*t9*abb54n48+t2*&
      &t4*abb54n60+t2*t5*abb54n10+t2*t7*abb54n13+t2*abb54n28*(Q(1)*spvak5k2(1)-Q&
      &(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))+t2*abb54n29*(Q(1)*spva&
      &k6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4))+t2*abb54n30*(&
      &Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4))+t2*a&
      &bb54n31*(Q(1)*spvak8k2(1)-Q(2)*spvak8k2(2)-Q(3)*spvak8k2(3)-Q(4)*spvak8k2&
      &(4))+t2*abb54n36*(Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(4)&
      &*spvak4k5(4))+t2*abb54n37*(Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k&
      &6(3)-Q(4)*spvak4k6(4))+t2*abb54n38*(Q(1)*spvak4k7(1)-Q(2)*spvak4k7(2)-Q(3&
      &)*spvak4k7(3)-Q(4)*spvak4k7(4))+t2*abb54n43*(Q(1)*spvak4k8(1)-Q(2)*spvak4&
      &k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4))+t20*t6*abb54n51+t20*t8*abb54n52+&
      &t21*t6*abb54n53+t21*t8*abb54n54+t22*t6*abb54n56+t22*t8*abb54n55+t23*t6*ab&
      &b54n58+t23*t8*abb54n57+t4*t6*abb54n61+t4*t8*abb54n62+t5*t6*abb54n11+t5*t8&
      &*abb54n9+t6*t7*abb54n12+t7*t8*abb54n14+t11*t18*t4*abb54n69+t12*t18*t4*abb&
      &54n68+t13*t18*t4*abb54n68+t18*t4*t5*abb54n70+t18*t4*t7*abb54n71+t18*t4*t9&
      &*abb54n69)

      numerator = cmplx(real(d54, ki), aimag(d54), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P3B_uux_uux_d54h1l1
