module     P3B_uux_uux_d55h1l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P3B_uux_
   ! uux/helicity1/d55h1l1.f90
   ! generator: haggies (1.1)
   use P3B_uux_uux_config, only: ki
   use P3B_uux_uux_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P3B_uux_uux_groups, only: &
!           & sign => diagram55_sign, shift => diagram55_shift
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd55h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d55
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2-k4
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d55 = 0.0_ki
      t1 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4))
      t2 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t5 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4))
      t6 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t7 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t8 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t9 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t10 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t11 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t12 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t13 = t3*abb55n18
      t14 = t3*abb55n19
      t15 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t16 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t17 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t18 = (Q(1)*spvak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4)&
      &)
      t19 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4)&
      &)
      t20 = (Q(1)*spvak8k2(1)-Q(2)*spvak8k2(2)-Q(3)*spvak8k2(3)-Q(4)*spvak8k2(4)&
      &)
      t21 = (Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(4)*spvak4k5(4)&
      &)
      t22 = (Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4k6(4)&
      &)
      t23 = (Q(1)*spvak4k7(1)-Q(2)*spvak4k7(2)-Q(3)*spvak4k7(3)-Q(4)*spvak4k7(4)&
      &)
      t24 = (Q(1)*spvak4k8(1)-Q(2)*spvak4k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4)&
      &)
      t25 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4)&
      &)
      d55 = (t1*abb55n12+t10*t14+t11*t13+t12*t13+t14*t8+t2*abb55n13+t3*abb55n47+&
      &t3*abb55n6+t4*abb55n7+t1*t15*abb55n53+t1*t16*abb55n51+t1*t25*abb55n67+t1*&
      &t3*abb55n52+t10*t5*abb55n9+t10*t9*abb55n14+t11*t5*abb55n8+t11*t9*abb55n15&
      &+t12*t5*abb55n8+t12*t9*abb55n15+t15*t17*abb55n28+t15*t18*abb55n31+t15*t19&
      &*abb55n32+t15*t20*abb55n35+t15*t21*abb55n38+t15*t22*abb55n41+t15*t23*abb5&
      &5n46+t15*t24*abb55n50+t15*t25*abb55n58+t15*t6*abb55n20+t15*t7*abb55n25+t1&
      &6*t17*abb55n26+t16*t18*abb55n29+t16*t19*abb55n34+t16*t20*abb55n37+t16*t21&
      &*abb55n40+t16*t22*abb55n43+t16*t23*abb55n44+t16*t24*abb55n48+t16*t25*abb5&
      &5n60+t16*t6*abb55n22+t16*t7*abb55n23+t17*t25*abb55n64+t17*t3*abb55n27+t18&
      &*t25*abb55n63+t18*t3*abb55n30+t19*t25*abb55n66+t19*t3*abb55n33+t2*t25*abb&
      &55n62+t20*t25*abb55n65+t20*t3*abb55n36+t21*t25*abb55n54+t21*t3*abb55n39+t&
      &22*t25*abb55n55+t22*t3*abb55n42+t23*t25*abb55n56+t23*t3*abb55n45+t24*t25*&
      &abb55n57+t24*t3*abb55n49+t25*t3*abb55n59+t25*t4*abb55n61+t3*t6*abb55n21+t&
      &3*t7*abb55n24+t5*t6*abb55n10+t5*t7*abb55n11+t5*t8*abb55n9+t6*t9*abb55n16+&
      &t7*t9*abb55n17+t8*t9*abb55n14+t1*t10*t25*abb55n69+t1*t11*t25*abb55n68+t1*&
      &t12*t25*abb55n68+t1*t25*t6*abb55n70+t1*t25*t7*abb55n71+t1*t25*t8*abb55n69&
      &)
      numerator = cmplx(real(d55, ki), aimag(d55), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd55h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d55
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2-k4
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d55 = 0.0_ki
      t1 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4))
      t2 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t5 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4))
      t6 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t7 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t8 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t9 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t10 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t11 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t12 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t13 = t3*abb55n18
      t14 = t3*abb55n19
      t15 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t16 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t17 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t18 = (Q(1)*spvak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4)&
      &)
      t19 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4)&
      &)
      t20 = (Q(1)*spvak8k2(1)-Q(2)*spvak8k2(2)-Q(3)*spvak8k2(3)-Q(4)*spvak8k2(4)&
      &)
      t21 = (Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(4)*spvak4k5(4)&
      &)
      t22 = (Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4k6(4)&
      &)
      t23 = (Q(1)*spvak4k7(1)-Q(2)*spvak4k7(2)-Q(3)*spvak4k7(3)-Q(4)*spvak4k7(4)&
      &)
      t24 = (Q(1)*spvak4k8(1)-Q(2)*spvak4k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4)&
      &)
      t25 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4)&
      &)
      d55 = (t1*abb55n12+t10*t14+t11*t13+t12*t13+t14*t8+t2*abb55n13+t3*abb55n47+&
      &t3*abb55n6+t4*abb55n7+t1*t15*abb55n53+t1*t16*abb55n51+t1*t25*abb55n67+t1*&
      &t3*abb55n52+t10*t5*abb55n9+t10*t9*abb55n14+t11*t5*abb55n8+t11*t9*abb55n15&
      &+t12*t5*abb55n8+t12*t9*abb55n15+t15*t17*abb55n28+t15*t18*abb55n31+t15*t19&
      &*abb55n32+t15*t20*abb55n35+t15*t21*abb55n38+t15*t22*abb55n41+t15*t23*abb5&
      &5n46+t15*t24*abb55n50+t15*t25*abb55n58+t15*t6*abb55n20+t15*t7*abb55n25+t1&
      &6*t17*abb55n26+t16*t18*abb55n29+t16*t19*abb55n34+t16*t20*abb55n37+t16*t21&
      &*abb55n40+t16*t22*abb55n43+t16*t23*abb55n44+t16*t24*abb55n48+t16*t25*abb5&
      &5n60+t16*t6*abb55n22+t16*t7*abb55n23+t17*t25*abb55n64+t17*t3*abb55n27+t18&
      &*t25*abb55n63+t18*t3*abb55n30+t19*t25*abb55n66+t19*t3*abb55n33+t2*t25*abb&
      &55n62+t20*t25*abb55n65+t20*t3*abb55n36+t21*t25*abb55n54+t21*t3*abb55n39+t&
      &22*t25*abb55n55+t22*t3*abb55n42+t23*t25*abb55n56+t23*t3*abb55n45+t24*t25*&
      &abb55n57+t24*t3*abb55n49+t25*t3*abb55n59+t25*t4*abb55n61+t3*t6*abb55n21+t&
      &3*t7*abb55n24+t5*t6*abb55n10+t5*t7*abb55n11+t5*t8*abb55n9+t6*t9*abb55n16+&
      &t7*t9*abb55n17+t8*t9*abb55n14+t1*t10*t25*abb55n69+t1*t11*t25*abb55n68+t1*&
      &t12*t25*abb55n68+t1*t25*t6*abb55n70+t1*t25*t7*abb55n71+t1*t25*t8*abb55n69&
      &)

      numerator = cmplx(real(d55, ki), aimag(d55), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P3B_uux_uux_d55h1l1
