module     P3B_uux_uux_d58h1l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P3B_uux_
   ! uux/helicity1/d58h1l1.f90
   ! generator: haggies (1.1)
   use P3B_uux_uux_config, only: ki
   use P3B_uux_uux_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P3B_uux_uux_groups, only: &
!           & sign => diagram58_sign, shift => diagram58_shift
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd58h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d58
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2-k4
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d58 = 0.0_ki
      t1 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4))
      t6 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t7 = t2*abb58n14
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t10 = t2*abb58n15
      t11 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t12 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t13 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t14 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t15 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t16 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4)&
      &)
      t17 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      t18 = (Q(1)*spvak6k3(1)-Q(2)*spvak6k3(2)-Q(3)*spvak6k3(3)-Q(4)*spvak6k3(4)&
      &)
      t19 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4)&
      &)
      t20 = (Q(1)*spvak8k3(1)-Q(2)*spvak8k3(2)-Q(3)*spvak8k3(3)-Q(4)*spvak8k3(4)&
      &)
      t21 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t22 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4)&
      &)
      t23 = (Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4k6(4)&
      &)
      t24 = (Q(1)*spvak4k8(1)-Q(2)*spvak4k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4)&
      &)
      t25 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4)&
      &)
      t26 = (Q(1)*spvak1k5(1)-Q(2)*spvak1k5(2)-Q(3)*spvak1k5(3)-Q(4)*spvak1k5(4)&
      &)
      t27 = (Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4)&
      &)
      t28 = (Q(1)*spvak1k7(1)-Q(2)*spvak1k7(2)-Q(3)*spvak1k7(3)-Q(4)*spvak1k7(4)&
      &)
      t29 = (Q(1)*spvak1k8(1)-Q(2)*spvak1k8(2)-Q(3)*spvak1k8(3)-Q(4)*spvak1k8(4)&
      &)
      d58 = (t1*abb58n12+t1*abb58n83+t10*t11+t10*t9+t2*abb58n13+t2*abb58n22+t2*a&
      &bb58n69+t3*abb58n36+t4*abb58n68+t6*t7+t7*t8+t1*t12*abb58n30+t1*t14*abb58n&
      &29+t1*t2*abb58n28+t1*t5*abb58n11+t1*t5*abb58n31+t11*t16*abb58n38+t11*t25*&
      &abb58n72+t12*t13*abb58n16+t12*t15*abb58n21+t12*t17*abb58n42+t12*t18*abb58&
      &n44+t12*t19*abb58n45+t12*t20*abb58n47+t12*t21*abb58n50+t12*t22*abb58n56+t&
      &12*t23*abb58n62+t12*t24*abb58n67+t12*t26*abb58n76+t12*t27*abb58n78+t12*t2&
      &8*abb58n79+t12*t29*abb58n81+t12*t5*abb58n23+t13*t14*abb58n18+t13*t16*abb5&
      &8n39+t13*t2*abb58n17+t13*t25*abb58n73+t14*t15*abb58n19+t14*t17*abb58n41+t&
      &14*t18*abb58n43+t14*t19*abb58n46+t14*t20*abb58n48+t14*t21*abb58n52+t14*t2&
      &2*abb58n54+t14*t23*abb58n63+t14*t24*abb58n66+t14*t26*abb58n75+t14*t27*abb&
      &58n77+t14*t28*abb58n80+t14*t29*abb58n82+t14*t5*abb58n24+t15*t16*abb58n40+&
      &t15*t2*abb58n20+t15*t25*abb58n74+t16*t6*abb58n37+t16*t8*abb58n37+t16*t9*a&
      &bb58n38+t17*t5*abb58n58+t18*t5*abb58n57+t19*t5*abb58n60+t2*t21*abb58n51+t&
      &2*t22*abb58n55+t2*t23*abb58n64+t2*t24*abb58n70+t2*t5*abb58n26+t2*abb58n49&
      &*(Q(1)*spvak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4))+t2&
      &*abb58n53*(Q(1)*spvak8k2(1)-Q(2)*spvak8k2(2)-Q(3)*spvak8k2(3)-Q(4)*spvak8&
      &k2(4))+t2*abb58n61*(Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(&
      &4)*spvak4k5(4))+t2*abb58n65*(Q(1)*spvak4k7(1)-Q(2)*spvak4k7(2)-Q(3)*spvak&
      &4k7(3)-Q(4)*spvak4k7(4))+t20*t5*abb58n59+t25*t6*abb58n71+t25*t8*abb58n71+&
      &t25*t9*abb58n72+t26*t5*abb58n84+t27*t5*abb58n85+t28*t5*abb58n86+t29*t5*ab&
      &b58n87+t3*t5*abb58n25+t4*t5*abb58n27+t1*t11*t5*abb58n33+t1*t13*t5*abb58n3&
      &4+t1*t15*t5*abb58n35+t1*t5*t6*abb58n32+t1*t5*t8*abb58n32+t1*t5*t9*abb58n3&
      &3)
      numerator = cmplx(real(d58, ki), aimag(d58), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd58h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d58
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2-k4
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d58 = 0.0_ki
      t1 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4))
      t6 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t7 = t2*abb58n14
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t10 = t2*abb58n15
      t11 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t12 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t13 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t14 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t15 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t16 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4)&
      &)
      t17 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      t18 = (Q(1)*spvak6k3(1)-Q(2)*spvak6k3(2)-Q(3)*spvak6k3(3)-Q(4)*spvak6k3(4)&
      &)
      t19 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4)&
      &)
      t20 = (Q(1)*spvak8k3(1)-Q(2)*spvak8k3(2)-Q(3)*spvak8k3(3)-Q(4)*spvak8k3(4)&
      &)
      t21 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t22 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4)&
      &)
      t23 = (Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4k6(4)&
      &)
      t24 = (Q(1)*spvak4k8(1)-Q(2)*spvak4k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4)&
      &)
      t25 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4)&
      &)
      t26 = (Q(1)*spvak1k5(1)-Q(2)*spvak1k5(2)-Q(3)*spvak1k5(3)-Q(4)*spvak1k5(4)&
      &)
      t27 = (Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4)&
      &)
      t28 = (Q(1)*spvak1k7(1)-Q(2)*spvak1k7(2)-Q(3)*spvak1k7(3)-Q(4)*spvak1k7(4)&
      &)
      t29 = (Q(1)*spvak1k8(1)-Q(2)*spvak1k8(2)-Q(3)*spvak1k8(3)-Q(4)*spvak1k8(4)&
      &)
      d58 = (t1*abb58n12+t1*abb58n83+t10*t11+t10*t9+t2*abb58n13+t2*abb58n22+t2*a&
      &bb58n69+t3*abb58n36+t4*abb58n68+t6*t7+t7*t8+t1*t12*abb58n30+t1*t14*abb58n&
      &29+t1*t2*abb58n28+t1*t5*abb58n11+t1*t5*abb58n31+t11*t16*abb58n38+t11*t25*&
      &abb58n72+t12*t13*abb58n16+t12*t15*abb58n21+t12*t17*abb58n42+t12*t18*abb58&
      &n44+t12*t19*abb58n45+t12*t20*abb58n47+t12*t21*abb58n50+t12*t22*abb58n56+t&
      &12*t23*abb58n62+t12*t24*abb58n67+t12*t26*abb58n76+t12*t27*abb58n78+t12*t2&
      &8*abb58n79+t12*t29*abb58n81+t12*t5*abb58n23+t13*t14*abb58n18+t13*t16*abb5&
      &8n39+t13*t2*abb58n17+t13*t25*abb58n73+t14*t15*abb58n19+t14*t17*abb58n41+t&
      &14*t18*abb58n43+t14*t19*abb58n46+t14*t20*abb58n48+t14*t21*abb58n52+t14*t2&
      &2*abb58n54+t14*t23*abb58n63+t14*t24*abb58n66+t14*t26*abb58n75+t14*t27*abb&
      &58n77+t14*t28*abb58n80+t14*t29*abb58n82+t14*t5*abb58n24+t15*t16*abb58n40+&
      &t15*t2*abb58n20+t15*t25*abb58n74+t16*t6*abb58n37+t16*t8*abb58n37+t16*t9*a&
      &bb58n38+t17*t5*abb58n58+t18*t5*abb58n57+t19*t5*abb58n60+t2*t21*abb58n51+t&
      &2*t22*abb58n55+t2*t23*abb58n64+t2*t24*abb58n70+t2*t5*abb58n26+t2*abb58n49&
      &*(Q(1)*spvak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4))+t2&
      &*abb58n53*(Q(1)*spvak8k2(1)-Q(2)*spvak8k2(2)-Q(3)*spvak8k2(3)-Q(4)*spvak8&
      &k2(4))+t2*abb58n61*(Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(&
      &4)*spvak4k5(4))+t2*abb58n65*(Q(1)*spvak4k7(1)-Q(2)*spvak4k7(2)-Q(3)*spvak&
      &4k7(3)-Q(4)*spvak4k7(4))+t20*t5*abb58n59+t25*t6*abb58n71+t25*t8*abb58n71+&
      &t25*t9*abb58n72+t26*t5*abb58n84+t27*t5*abb58n85+t28*t5*abb58n86+t29*t5*ab&
      &b58n87+t3*t5*abb58n25+t4*t5*abb58n27+t1*t11*t5*abb58n33+t1*t13*t5*abb58n3&
      &4+t1*t15*t5*abb58n35+t1*t5*t6*abb58n32+t1*t5*t8*abb58n32+t1*t5*t9*abb58n3&
      &3)

      numerator = cmplx(real(d58, ki), aimag(d58), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P3B_uux_uux_d58h1l1
