module     P3B_uux_uux_d63h1l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P3B_uux_
   ! uux/helicity1/d63h1l1.f90
   ! generator: haggies (1.1)
   use P3B_uux_uux_config, only: ki
   use P3B_uux_uux_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P3B_uux_uux_groups, only: &
!           & sign => diagram63_sign, shift => diagram63_shift
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd63h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d63
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2-k4
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d63 = 0.0_ki
      t1 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t4 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t5 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4))
      t6 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t7 = t2*abb63n14
      t8 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t9 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t10 = t2*abb63n15
      t11 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t12 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t13 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t14 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t15 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t16 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4)&
      &)
      t17 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4)&
      &)
      t18 = (Q(1)*spvak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4)&
      &)
      t19 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t20 = (Q(1)*spvak8k2(1)-Q(2)*spvak8k2(2)-Q(3)*spvak8k2(3)-Q(4)*spvak8k2(4)&
      &)
      t21 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4)&
      &)
      t22 = (Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(4)*spvak4k5(4)&
      &)
      t23 = (Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4k6(4)&
      &)
      t24 = (Q(1)*spvak4k7(1)-Q(2)*spvak4k7(2)-Q(3)*spvak4k7(3)-Q(4)*spvak4k7(4)&
      &)
      t25 = (Q(1)*spvak4k8(1)-Q(2)*spvak4k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4)&
      &)
      d63 = (t1*abb63n11+t1*abb63n38+t10*t11+t10*t9+t2*abb63n12+t2*abb63n22+t2*a&
      &bb63n65+t3*abb63n33+t4*abb63n39+t6*t7+t7*t8+t1*t12*abb63n25+t1*t14*abb63n&
      &23+t1*t2*abb63n24+t1*t5*abb63n13+t1*t5*abb63n79+t11*t16*abb63n35+t11*t17*&
      &abb63n41+t12*t13*abb63n16+t12*t15*abb63n21+t12*t18*abb63n44+t12*t19*abb63&
      &n49+t12*t20*abb63n52+t12*t21*abb63n53+t12*t22*abb63n56+t12*t23*abb63n59+t&
      &12*t24*abb63n64+t12*t25*abb63n68+t12*t5*abb63n26+t13*t14*abb63n18+t13*t16&
      &*abb63n36+t13*t17*abb63n42+t13*t2*abb63n17+t14*t15*abb63n19+t14*t18*abb63&
      &n46+t14*t19*abb63n47+t14*t20*abb63n50+t14*t21*abb63n55+t14*t22*abb63n58+t&
      &14*t23*abb63n61+t14*t24*abb63n62+t14*t25*abb63n66+t14*t5*abb63n28+t15*t16&
      &*abb63n37+t15*t17*abb63n43+t15*t2*abb63n20+t16*t6*abb63n34+t16*t8*abb63n3&
      &4+t16*t9*abb63n35+t17*t6*abb63n40+t17*t8*abb63n40+t17*t9*abb63n41+t18*t2*&
      &abb63n45+t18*t5*abb63n75+t19*t2*abb63n48+t19*t5*abb63n76+t2*t20*abb63n51+&
      &t2*t21*abb63n54+t2*t22*abb63n57+t2*t23*abb63n60+t2*t24*abb63n63+t2*t25*ab&
      &b63n67+t2*t5*abb63n27+t20*t5*abb63n77+t21*t5*abb63n78+t22*t5*abb63n69+t23&
      &*t5*abb63n70+t24*t5*abb63n71+t25*t5*abb63n72+t3*t5*abb63n73+t4*t5*abb63n7&
      &4+t1*t11*t5*abb63n30+t1*t13*t5*abb63n31+t1*t15*t5*abb63n32+t1*t5*t6*abb63&
      &n29+t1*t5*t8*abb63n29+t1*t5*t9*abb63n30)
      numerator = cmplx(real(d63, ki), aimag(d63), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd63h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d63
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2-k4
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d63 = 0.0_ki
      t1 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t4 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t5 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4))
      t6 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t7 = t2*abb63n14
      t8 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t9 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t10 = t2*abb63n15
      t11 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t12 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t13 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t14 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t15 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t16 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4)&
      &)
      t17 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4)&
      &)
      t18 = (Q(1)*spvak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4)&
      &)
      t19 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t20 = (Q(1)*spvak8k2(1)-Q(2)*spvak8k2(2)-Q(3)*spvak8k2(3)-Q(4)*spvak8k2(4)&
      &)
      t21 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4)&
      &)
      t22 = (Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(4)*spvak4k5(4)&
      &)
      t23 = (Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4k6(4)&
      &)
      t24 = (Q(1)*spvak4k7(1)-Q(2)*spvak4k7(2)-Q(3)*spvak4k7(3)-Q(4)*spvak4k7(4)&
      &)
      t25 = (Q(1)*spvak4k8(1)-Q(2)*spvak4k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4)&
      &)
      d63 = (t1*abb63n11+t1*abb63n38+t10*t11+t10*t9+t2*abb63n12+t2*abb63n22+t2*a&
      &bb63n65+t3*abb63n33+t4*abb63n39+t6*t7+t7*t8+t1*t12*abb63n25+t1*t14*abb63n&
      &23+t1*t2*abb63n24+t1*t5*abb63n13+t1*t5*abb63n79+t11*t16*abb63n35+t11*t17*&
      &abb63n41+t12*t13*abb63n16+t12*t15*abb63n21+t12*t18*abb63n44+t12*t19*abb63&
      &n49+t12*t20*abb63n52+t12*t21*abb63n53+t12*t22*abb63n56+t12*t23*abb63n59+t&
      &12*t24*abb63n64+t12*t25*abb63n68+t12*t5*abb63n26+t13*t14*abb63n18+t13*t16&
      &*abb63n36+t13*t17*abb63n42+t13*t2*abb63n17+t14*t15*abb63n19+t14*t18*abb63&
      &n46+t14*t19*abb63n47+t14*t20*abb63n50+t14*t21*abb63n55+t14*t22*abb63n58+t&
      &14*t23*abb63n61+t14*t24*abb63n62+t14*t25*abb63n66+t14*t5*abb63n28+t15*t16&
      &*abb63n37+t15*t17*abb63n43+t15*t2*abb63n20+t16*t6*abb63n34+t16*t8*abb63n3&
      &4+t16*t9*abb63n35+t17*t6*abb63n40+t17*t8*abb63n40+t17*t9*abb63n41+t18*t2*&
      &abb63n45+t18*t5*abb63n75+t19*t2*abb63n48+t19*t5*abb63n76+t2*t20*abb63n51+&
      &t2*t21*abb63n54+t2*t22*abb63n57+t2*t23*abb63n60+t2*t24*abb63n63+t2*t25*ab&
      &b63n67+t2*t5*abb63n27+t20*t5*abb63n77+t21*t5*abb63n78+t22*t5*abb63n69+t23&
      &*t5*abb63n70+t24*t5*abb63n71+t25*t5*abb63n72+t3*t5*abb63n73+t4*t5*abb63n7&
      &4+t1*t11*t5*abb63n30+t1*t13*t5*abb63n31+t1*t15*t5*abb63n32+t1*t5*t6*abb63&
      &n29+t1*t5*t8*abb63n29+t1*t5*t9*abb63n30)

      numerator = cmplx(real(d63, ki), aimag(d63), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P3B_uux_uux_d63h1l1
