module     P3B_uux_uux_d11h2l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P3B_uux_
   ! uux/helicity2/d11h2l1.f90
   ! generator: haggies (1.1)
   use P3B_uux_uux_config, only: ki
   use P3B_uux_uux_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P3B_uux_uux_groups, only: &
!           & sign => diagram11_sign, shift => diagram11_shift
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd11h2
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d11
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k6-k5-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d11 = 0.0_ki
      t1 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t2 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t6 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4))
      t7 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t8 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4))
      t9 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t10 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t11 = t3*abb11n32
      t12 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t13 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t14 = t4*abb11n34
      t15 = t5*abb11n34
      t16 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t17 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t18 = (Q(1)*spvak7k6(1)-Q(2)*spvak7k6(2)-Q(3)*spvak7k6(3)-Q(4)*spvak7k6(4)&
      &)
      t19 = (Q(1)*spvak5k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q(4)*spvak5k8(4)&
      &)
      d11 = (t1*abb11n10+t11*t12+t11*t13+t11*t4+t11*t5+t12*t14+t12*t15+t13*t14+t&
      &13*t15+t2*abb11n14+t3*abb11n26+t3*t3*abb11n33+t4*abb11n27+t5*abb11n27+t6*&
      &abb11n3+t7*abb11n45+t8*abb11n5+t1*t3*abb11n21+t1*t7*abb11n56+t1*t9*abb11n&
      &7+t10*t2*abb11n9+t10*t3*abb11n28+t10*t4*abb11n29+t10*t5*abb11n29+t10*t7*a&
      &bb11n46+t12*t2*abb11n6+t12*t7*abb11n43+t13*t2*abb11n6+t13*t7*abb11n43+t16&
      &*t2*abb11n8+t16*t3*abb11n39+t16*t4*abb11n37+t16*t5*abb11n37+t16*t7*abb11n&
      &48+t17*t7*abb11n38+t2*t3*abb11n20+t2*t7*abb11n54+t2*t9*abb11n13+t3*t6*abb&
      &11n12+t3*t7*abb11n55+t3*t8*abb11n17+t3*t9*abb11n25+t4*t9*abb11n24+t5*t9*a&
      &bb11n24+t6*t7*abb11n15+t6*t9*abb11n2+t7*t8*abb11n41+t7*t9*abb11n44+t8*t9*&
      &abb11n4+t1*t7*t9*abb11n58+t10*t16*t2*abb11n11+t10*t16*t7*abb11n49+t10*t17&
      &*t7*abb11n40+t10*t18*t3*abb11n23+t10*t18*t4*abb11n22+t10*t18*t5*abb11n22+&
      &t10*t19*t3*abb11n30+t10*t19*t4*abb11n31+t10*t19*t5*abb11n31+t10*t2*t3*abb&
      &11n18+t10*t2*t4*abb11n19+t10*t2*t5*abb11n19+t10*t3*t9*abb11n35+t10*t4*t7*&
      &abb11n61+t10*t4*t9*abb11n36+t10*t5*t7*abb11n61+t10*t5*t9*abb11n36+t10*t7*&
      &t9*abb11n47+t12*t2*t7*abb11n51+t13*t2*t7*abb11n51+t2*t3*t7*abb11n50+t2*t7&
      &*t9*abb11n57+t2*t7*abb11n52*(Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak&
      &5k4(3)-Q(4)*spvak5k4(4))+t3*t7*t9*abb11n59+t3*t7*abb11n53*(Q(1)*spvak7k4(&
      &1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4))+t3*t7*abb11n60*(Q(&
      &1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4))+t6*t7*&
      &t9*abb11n16+t7*t8*t9*abb11n42+t10*t2*t7*t9*abb11n62)
      numerator = cmplx(real(d11, ki), aimag(d11), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd11h2
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d11
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k6-k5-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d11 = 0.0_ki
      t1 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t2 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t6 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4))
      t7 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t8 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4))
      t9 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t10 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t11 = t3*abb11n32
      t12 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t13 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t14 = t4*abb11n34
      t15 = t5*abb11n34
      t16 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t17 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t18 = (Q(1)*spvak7k6(1)-Q(2)*spvak7k6(2)-Q(3)*spvak7k6(3)-Q(4)*spvak7k6(4)&
      &)
      t19 = (Q(1)*spvak5k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q(4)*spvak5k8(4)&
      &)
      d11 = (t1*abb11n10+t11*t12+t11*t13+t11*t4+t11*t5+t12*t14+t12*t15+t13*t14+t&
      &13*t15+t2*abb11n14+t3*abb11n26+t3*t3*abb11n33+t4*abb11n27+t5*abb11n27+t6*&
      &abb11n3+t7*abb11n45+t8*abb11n5+t1*t3*abb11n21+t1*t7*abb11n56+t1*t9*abb11n&
      &7+t10*t2*abb11n9+t10*t3*abb11n28+t10*t4*abb11n29+t10*t5*abb11n29+t10*t7*a&
      &bb11n46+t12*t2*abb11n6+t12*t7*abb11n43+t13*t2*abb11n6+t13*t7*abb11n43+t16&
      &*t2*abb11n8+t16*t3*abb11n39+t16*t4*abb11n37+t16*t5*abb11n37+t16*t7*abb11n&
      &48+t17*t7*abb11n38+t2*t3*abb11n20+t2*t7*abb11n54+t2*t9*abb11n13+t3*t6*abb&
      &11n12+t3*t7*abb11n55+t3*t8*abb11n17+t3*t9*abb11n25+t4*t9*abb11n24+t5*t9*a&
      &bb11n24+t6*t7*abb11n15+t6*t9*abb11n2+t7*t8*abb11n41+t7*t9*abb11n44+t8*t9*&
      &abb11n4+t1*t7*t9*abb11n58+t10*t16*t2*abb11n11+t10*t16*t7*abb11n49+t10*t17&
      &*t7*abb11n40+t10*t18*t3*abb11n23+t10*t18*t4*abb11n22+t10*t18*t5*abb11n22+&
      &t10*t19*t3*abb11n30+t10*t19*t4*abb11n31+t10*t19*t5*abb11n31+t10*t2*t3*abb&
      &11n18+t10*t2*t4*abb11n19+t10*t2*t5*abb11n19+t10*t3*t9*abb11n35+t10*t4*t7*&
      &abb11n61+t10*t4*t9*abb11n36+t10*t5*t7*abb11n61+t10*t5*t9*abb11n36+t10*t7*&
      &t9*abb11n47+t12*t2*t7*abb11n51+t13*t2*t7*abb11n51+t2*t3*t7*abb11n50+t2*t7&
      &*t9*abb11n57+t2*t7*abb11n52*(Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak&
      &5k4(3)-Q(4)*spvak5k4(4))+t3*t7*t9*abb11n59+t3*t7*abb11n53*(Q(1)*spvak7k4(&
      &1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4))+t3*t7*abb11n60*(Q(&
      &1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4))+t6*t7*&
      &t9*abb11n16+t7*t8*t9*abb11n42+t10*t2*t7*t9*abb11n62)

      numerator = cmplx(real(d11, ki), aimag(d11), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P3B_uux_uux_d11h2l1
