module     P3B_uux_uux_d38h2l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P3B_uux_
   ! uux/helicity2/d38h2l1.f90
   ! generator: haggies (1.1)
   use P3B_uux_uux_config, only: ki
   use P3B_uux_uux_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P3B_uux_uux_groups, only: &
!           & sign => diagram38_sign, shift => diagram38_shift
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd38h2
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d38
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d38 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t5 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t6 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t7 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t8 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t9 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4))
      t10 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t11 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t12 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t13 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t14 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t15 = (Q(1)*spvak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4)&
      &)
      t16 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4)&
      &)
      t17 = (Q(1)*spvak8k2(1)-Q(2)*spvak8k2(2)-Q(3)*spvak8k2(3)-Q(4)*spvak8k2(4)&
      &)
      t18 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t19 = (Q(1)*spvak1k4(1)-Q(2)*spvak1k4(2)-Q(3)*spvak1k4(3)-Q(4)*spvak1k4(4)&
      &)
      t20 = (Q(1)*spvak1k5(1)-Q(2)*spvak1k5(2)-Q(3)*spvak1k5(3)-Q(4)*spvak1k5(4)&
      &)
      t21 = (Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4)&
      &)
      t22 = (Q(1)*spvak1k7(1)-Q(2)*spvak1k7(2)-Q(3)*spvak1k7(3)-Q(4)*spvak1k7(4)&
      &)
      t23 = (Q(1)*spvak1k8(1)-Q(2)*spvak1k8(2)-Q(3)*spvak1k8(3)-Q(4)*spvak1k8(4)&
      &)
      t24 = t3*abb38n5
      t25 = t3*abb38n6
      d38 = (t1*abb38n14+t10*t25+t11*t24+t12*t24+t2*abb38n32+t25*t8+t3*abb38n33+&
      &t4*abb38n37+t1*t18*abb38n35+t10*t19*abb38n39+t10*t9*abb38n16+t11*t19*abb3&
      &8n38+t11*t9*abb38n17+t12*t19*abb38n38+t12*t9*abb38n17+t13*t19*abb38n40+t1&
      &3*t3*abb38n8+t13*t5*abb38n7+t13*t7*abb38n7+t13*t9*abb38n18+t14*t18*abb38n&
      &25+t14*t5*abb38n20+t14*t7*abb38n20+t15*t18*abb38n24+t15*t5*abb38n21+t15*t&
      &7*abb38n21+t16*t18*abb38n27+t16*t5*abb38n22+t16*t7*abb38n22+t17*t18*abb38&
      &n26+t17*t5*abb38n23+t17*t7*abb38n23+t18*t2*abb38n35+t18*t20*abb38n46+t18*&
      &t21*abb38n47+t18*t22*abb38n48+t18*t23*abb38n49+t18*t3*abb38n36+t18*t4*abb&
      &38n52+t18*t5*abb38n31+t18*t7*abb38n31+t19*t6*abb38n41+t19*t8*abb38n39+t20&
      &*t5*abb38n42+t20*t7*abb38n42+t21*t5*abb38n43+t21*t7*abb38n43+t22*t5*abb38&
      &n44+t22*t7*abb38n44+t23*t5*abb38n45+t23*t7*abb38n45+t3*t4*abb38n50+t3*t6*&
      &abb38n9+t3*abb38n11*(Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q&
      &(4)*spvak5k4(4))+t3*abb38n12*(Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q(3)*spva&
      &k6k4(3)-Q(4)*spvak6k4(4))+t3*abb38n13*(Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-&
      &Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4))+t3*abb38n15*(Q(1)*spvak8k4(1)-Q(2)*spv&
      &ak8k4(2)-Q(3)*spvak8k4(3)-Q(4)*spvak8k4(4))+t3*abb38n28*(Q(1)*spvak3k5(1)&
      &-Q(2)*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4))+t3*abb38n29*(Q(1)*sp&
      &vak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))+t3*abb38n30&
      &*(Q(1)*spvak3k7(1)-Q(2)*spvak3k7(2)-Q(3)*spvak3k7(3)-Q(4)*spvak3k7(4))+t3&
      &*abb38n34*(Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3&
      &k8(4))+t4*t5*abb38n51+t4*t7*abb38n51+t5*t6*abb38n10+t6*t7*abb38n10+t6*t9*&
      &abb38n19+t8*t9*abb38n16+t10*t18*t4*abb38n53+t11*t18*t4*abb38n54+t12*t18*t&
      &4*abb38n54+t13*t18*t4*abb38n55+t18*t4*t6*abb38n56+t18*t4*t8*abb38n53)
      numerator = cmplx(real(d38, ki), aimag(d38), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd38h2
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d38
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d38 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t5 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t6 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t7 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t8 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t9 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4))
      t10 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t11 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t12 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t13 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t14 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t15 = (Q(1)*spvak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4)&
      &)
      t16 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4)&
      &)
      t17 = (Q(1)*spvak8k2(1)-Q(2)*spvak8k2(2)-Q(3)*spvak8k2(3)-Q(4)*spvak8k2(4)&
      &)
      t18 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t19 = (Q(1)*spvak1k4(1)-Q(2)*spvak1k4(2)-Q(3)*spvak1k4(3)-Q(4)*spvak1k4(4)&
      &)
      t20 = (Q(1)*spvak1k5(1)-Q(2)*spvak1k5(2)-Q(3)*spvak1k5(3)-Q(4)*spvak1k5(4)&
      &)
      t21 = (Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4)&
      &)
      t22 = (Q(1)*spvak1k7(1)-Q(2)*spvak1k7(2)-Q(3)*spvak1k7(3)-Q(4)*spvak1k7(4)&
      &)
      t23 = (Q(1)*spvak1k8(1)-Q(2)*spvak1k8(2)-Q(3)*spvak1k8(3)-Q(4)*spvak1k8(4)&
      &)
      t24 = t3*abb38n5
      t25 = t3*abb38n6
      d38 = (t1*abb38n14+t10*t25+t11*t24+t12*t24+t2*abb38n32+t25*t8+t3*abb38n33+&
      &t4*abb38n37+t1*t18*abb38n35+t10*t19*abb38n39+t10*t9*abb38n16+t11*t19*abb3&
      &8n38+t11*t9*abb38n17+t12*t19*abb38n38+t12*t9*abb38n17+t13*t19*abb38n40+t1&
      &3*t3*abb38n8+t13*t5*abb38n7+t13*t7*abb38n7+t13*t9*abb38n18+t14*t18*abb38n&
      &25+t14*t5*abb38n20+t14*t7*abb38n20+t15*t18*abb38n24+t15*t5*abb38n21+t15*t&
      &7*abb38n21+t16*t18*abb38n27+t16*t5*abb38n22+t16*t7*abb38n22+t17*t18*abb38&
      &n26+t17*t5*abb38n23+t17*t7*abb38n23+t18*t2*abb38n35+t18*t20*abb38n46+t18*&
      &t21*abb38n47+t18*t22*abb38n48+t18*t23*abb38n49+t18*t3*abb38n36+t18*t4*abb&
      &38n52+t18*t5*abb38n31+t18*t7*abb38n31+t19*t6*abb38n41+t19*t8*abb38n39+t20&
      &*t5*abb38n42+t20*t7*abb38n42+t21*t5*abb38n43+t21*t7*abb38n43+t22*t5*abb38&
      &n44+t22*t7*abb38n44+t23*t5*abb38n45+t23*t7*abb38n45+t3*t4*abb38n50+t3*t6*&
      &abb38n9+t3*abb38n11*(Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q&
      &(4)*spvak5k4(4))+t3*abb38n12*(Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q(3)*spva&
      &k6k4(3)-Q(4)*spvak6k4(4))+t3*abb38n13*(Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-&
      &Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4))+t3*abb38n15*(Q(1)*spvak8k4(1)-Q(2)*spv&
      &ak8k4(2)-Q(3)*spvak8k4(3)-Q(4)*spvak8k4(4))+t3*abb38n28*(Q(1)*spvak3k5(1)&
      &-Q(2)*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4))+t3*abb38n29*(Q(1)*sp&
      &vak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))+t3*abb38n30&
      &*(Q(1)*spvak3k7(1)-Q(2)*spvak3k7(2)-Q(3)*spvak3k7(3)-Q(4)*spvak3k7(4))+t3&
      &*abb38n34*(Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3&
      &k8(4))+t4*t5*abb38n51+t4*t7*abb38n51+t5*t6*abb38n10+t6*t7*abb38n10+t6*t9*&
      &abb38n19+t8*t9*abb38n16+t10*t18*t4*abb38n53+t11*t18*t4*abb38n54+t12*t18*t&
      &4*abb38n54+t13*t18*t4*abb38n55+t18*t4*t6*abb38n56+t18*t4*t8*abb38n53)

      numerator = cmplx(real(d38, ki), aimag(d38), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P3B_uux_uux_d38h2l1
