module     P3B_uux_uux_d46h2l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P3B_uux_
   ! uux/helicity2/d46h2l1.f90
   ! generator: haggies (1.1)
   use P3B_uux_uux_config, only: ki
   use P3B_uux_uux_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P3B_uux_uux_groups, only: &
!           & sign => diagram46_sign, shift => diagram46_shift
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd46h2
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d46
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d46 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t3 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t4 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t5 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t6 = t1*abb46n11
      t7 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t8 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t9 = t1*abb46n12
      t10 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t11 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t12 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t13 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t14 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t15 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t16 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t17 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      t18 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4)&
      &)
      t19 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t20 = (Q(1)*spvak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4)&
      &)
      t21 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4)&
      &)
      t22 = (Q(1)*spvak8k2(1)-Q(2)*spvak8k2(2)-Q(3)*spvak8k2(3)-Q(4)*spvak8k2(4)&
      &)
      t23 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)&
      &)
      t24 = (Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4)&
      &)
      t25 = (Q(1)*spvak1k4(1)-Q(2)*spvak1k4(2)-Q(3)*spvak1k4(3)-Q(4)*spvak1k4(4)&
      &)
      t26 = (Q(1)*spvak1k5(1)-Q(2)*spvak1k5(2)-Q(3)*spvak1k5(3)-Q(4)*spvak1k5(4)&
      &)
      t27 = (Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4)&
      &)
      t28 = (Q(1)*spvak1k7(1)-Q(2)*spvak1k7(2)-Q(3)*spvak1k7(3)-Q(4)*spvak1k7(4)&
      &)
      t29 = (Q(1)*spvak1k8(1)-Q(2)*spvak1k8(2)-Q(3)*spvak1k8(3)-Q(4)*spvak1k8(4)&
      &)
      d46 = (t1*abb46n10+t1*abb46n51+t1*abb46n8+t10*t9+t2*abb46n30+t3*abb46n52+t&
      &4*abb46n54+t4*abb46n9+t5*t6+t6*t7+t8*t9+t1*t11*abb46n13+t1*t14*abb46n16+t&
      &1*t15*abb46n18+t1*t16*abb46n29+t1*t17*abb46n32+t1*t23*abb46n48+t1*t24*abb&
      &46n53+t1*t4*abb46n20+t1*abb46n27*(Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q(3)*&
      &spvak6k4(3)-Q(4)*spvak6k4(4))+t1*abb46n31*(Q(1)*spvak8k4(1)-Q(2)*spvak8k4&
      &(2)-Q(3)*spvak8k4(3)-Q(4)*spvak8k4(4))+t1*abb46n46*(Q(1)*spvak3k5(1)-Q(2)&
      &*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4))+t1*abb46n49*(Q(1)*spvak3k&
      &7(1)-Q(2)*spvak3k7(2)-Q(3)*spvak3k7(3)-Q(4)*spvak3k7(4))+t10*t18*abb46n35&
      &+t10*t25*abb46n56+t11*t12*abb46n14+t11*t13*abb46n14+t11*t18*abb46n36+t11*&
      &t25*abb46n57+t12*t14*abb46n15+t12*t15*abb46n17+t12*t16*abb46n28+t12*t17*a&
      &bb46n33+t12*t19*abb46n38+t12*t20*abb46n39+t12*t21*abb46n40+t12*t22*abb46n&
      &41+t12*t23*abb46n47+t12*t24*abb46n50+t12*t26*abb46n59+t12*t27*abb46n60+t1&
      &2*t28*abb46n61+t12*t29*abb46n62+t12*t4*abb46n21+t13*t14*abb46n15+t13*t15*&
      &abb46n17+t13*t16*abb46n28+t13*t17*abb46n33+t13*t19*abb46n38+t13*t20*abb46&
      &n39+t13*t21*abb46n40+t13*t22*abb46n41+t13*t23*abb46n47+t13*t24*abb46n50+t&
      &13*t26*abb46n59+t13*t27*abb46n60+t13*t28*abb46n61+t13*t29*abb46n62+t13*t4&
      &*abb46n21+t14*t18*abb46n37+t14*t25*abb46n58+t15*t19*abb46n43+t15*t2*abb46&
      &n19+t15*t20*abb46n42+t15*t21*abb46n45+t15*t22*abb46n44+t15*t26*abb46n63+t&
      &15*t27*abb46n64+t15*t28*abb46n65+t15*t29*abb46n66+t15*t3*abb46n19+t15*t4*&
      &abb46n22+t18*t5*abb46n34+t18*t7*abb46n34+t18*t8*abb46n35+t25*t5*abb46n55+&
      &t25*t7*abb46n55+t25*t8*abb46n56+t10*t15*t4*abb46n23+t11*t15*t4*abb46n25+t&
      &14*t15*t4*abb46n26+t15*t4*t5*abb46n24+t15*t4*t7*abb46n24+t15*t4*t8*abb46n&
      &23)
      numerator = cmplx(real(d46, ki), aimag(d46), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd46h2
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d46
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d46 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t3 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t4 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t5 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t6 = t1*abb46n11
      t7 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t8 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t9 = t1*abb46n12
      t10 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t11 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t12 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t13 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t14 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t15 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t16 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t17 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      t18 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4)&
      &)
      t19 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t20 = (Q(1)*spvak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4)&
      &)
      t21 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4)&
      &)
      t22 = (Q(1)*spvak8k2(1)-Q(2)*spvak8k2(2)-Q(3)*spvak8k2(3)-Q(4)*spvak8k2(4)&
      &)
      t23 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)&
      &)
      t24 = (Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4)&
      &)
      t25 = (Q(1)*spvak1k4(1)-Q(2)*spvak1k4(2)-Q(3)*spvak1k4(3)-Q(4)*spvak1k4(4)&
      &)
      t26 = (Q(1)*spvak1k5(1)-Q(2)*spvak1k5(2)-Q(3)*spvak1k5(3)-Q(4)*spvak1k5(4)&
      &)
      t27 = (Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4)&
      &)
      t28 = (Q(1)*spvak1k7(1)-Q(2)*spvak1k7(2)-Q(3)*spvak1k7(3)-Q(4)*spvak1k7(4)&
      &)
      t29 = (Q(1)*spvak1k8(1)-Q(2)*spvak1k8(2)-Q(3)*spvak1k8(3)-Q(4)*spvak1k8(4)&
      &)
      d46 = (t1*abb46n10+t1*abb46n51+t1*abb46n8+t10*t9+t2*abb46n30+t3*abb46n52+t&
      &4*abb46n54+t4*abb46n9+t5*t6+t6*t7+t8*t9+t1*t11*abb46n13+t1*t14*abb46n16+t&
      &1*t15*abb46n18+t1*t16*abb46n29+t1*t17*abb46n32+t1*t23*abb46n48+t1*t24*abb&
      &46n53+t1*t4*abb46n20+t1*abb46n27*(Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q(3)*&
      &spvak6k4(3)-Q(4)*spvak6k4(4))+t1*abb46n31*(Q(1)*spvak8k4(1)-Q(2)*spvak8k4&
      &(2)-Q(3)*spvak8k4(3)-Q(4)*spvak8k4(4))+t1*abb46n46*(Q(1)*spvak3k5(1)-Q(2)&
      &*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4))+t1*abb46n49*(Q(1)*spvak3k&
      &7(1)-Q(2)*spvak3k7(2)-Q(3)*spvak3k7(3)-Q(4)*spvak3k7(4))+t10*t18*abb46n35&
      &+t10*t25*abb46n56+t11*t12*abb46n14+t11*t13*abb46n14+t11*t18*abb46n36+t11*&
      &t25*abb46n57+t12*t14*abb46n15+t12*t15*abb46n17+t12*t16*abb46n28+t12*t17*a&
      &bb46n33+t12*t19*abb46n38+t12*t20*abb46n39+t12*t21*abb46n40+t12*t22*abb46n&
      &41+t12*t23*abb46n47+t12*t24*abb46n50+t12*t26*abb46n59+t12*t27*abb46n60+t1&
      &2*t28*abb46n61+t12*t29*abb46n62+t12*t4*abb46n21+t13*t14*abb46n15+t13*t15*&
      &abb46n17+t13*t16*abb46n28+t13*t17*abb46n33+t13*t19*abb46n38+t13*t20*abb46&
      &n39+t13*t21*abb46n40+t13*t22*abb46n41+t13*t23*abb46n47+t13*t24*abb46n50+t&
      &13*t26*abb46n59+t13*t27*abb46n60+t13*t28*abb46n61+t13*t29*abb46n62+t13*t4&
      &*abb46n21+t14*t18*abb46n37+t14*t25*abb46n58+t15*t19*abb46n43+t15*t2*abb46&
      &n19+t15*t20*abb46n42+t15*t21*abb46n45+t15*t22*abb46n44+t15*t26*abb46n63+t&
      &15*t27*abb46n64+t15*t28*abb46n65+t15*t29*abb46n66+t15*t3*abb46n19+t15*t4*&
      &abb46n22+t18*t5*abb46n34+t18*t7*abb46n34+t18*t8*abb46n35+t25*t5*abb46n55+&
      &t25*t7*abb46n55+t25*t8*abb46n56+t10*t15*t4*abb46n23+t11*t15*t4*abb46n25+t&
      &14*t15*t4*abb46n26+t15*t4*t5*abb46n24+t15*t4*t7*abb46n24+t15*t4*t8*abb46n&
      &23)

      numerator = cmplx(real(d46, ki), aimag(d46), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P3B_uux_uux_d46h2l1
