module     P3B_uux_uux_d47h2l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P3B_uux_
   ! uux/helicity2/d47h2l1.f90
   ! generator: haggies (1.1)
   use P3B_uux_uux_config, only: ki
   use P3B_uux_uux_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P3B_uux_uux_groups, only: &
!           & sign => diagram47_sign, shift => diagram47_shift
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd47h2
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d47
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d47 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t3 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t4 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t5 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t6 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t7 = t1*abb47n12
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t10 = t1*abb47n13
      t11 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t12 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t13 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t14 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t15 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t16 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4)&
      &)
      t17 = (Q(1)*spvak1k4(1)-Q(2)*spvak1k4(2)-Q(3)*spvak1k4(3)-Q(4)*spvak1k4(4)&
      &)
      t18 = (Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q(3)*spvak6k4(3)-Q(4)*spvak6k4(4)&
      &)
      t19 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t20 = (Q(1)*spvak8k4(1)-Q(2)*spvak8k4(2)-Q(3)*spvak8k4(3)-Q(4)*spvak8k4(4)&
      &)
      t21 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      t22 = (Q(1)*spvak3k5(1)-Q(2)*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4)&
      &)
      t23 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)&
      &)
      t24 = (Q(1)*spvak3k7(1)-Q(2)*spvak3k7(2)-Q(3)*spvak3k7(3)-Q(4)*spvak3k7(4)&
      &)
      t25 = (Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4)&
      &)
      d47 = (t1*abb47n11+t1*abb47n51+t1*abb47n9+t10*t11+t10*t9+t2*abb47n26+t3*ab&
      &b47n31+t4*abb47n36+t4*abb47n8+t6*t7+t7*t8+t1*t13*abb47n15+t1*t15*abb47n16&
      &+t1*t18*abb47n37+t1*t19*abb47n40+t1*t20*abb47n42+t1*t21*abb47n43+t1*t22*a&
      &bb47n46+t1*t23*abb47n48+t1*t24*abb47n49+t1*t25*abb47n52+t1*t4*abb47n19+t1&
      &*t5*abb47n20+t11*t16*abb47n27+t11*t17*abb47n32+t12*t13*abb47n14+t12*t15*a&
      &bb47n17+t12*t18*abb47n38+t12*t19*abb47n39+t12*t20*abb47n41+t12*t21*abb47n&
      &44+t12*t22*abb47n45+t12*t23*abb47n47+t12*t24*abb47n50+t12*t25*abb47n53+t1&
      &2*t4*abb47n18+t12*t5*abb47n21+t13*t14*abb47n14+t13*t16*abb47n29+t13*t17*a&
      &bb47n34+t14*t15*abb47n17+t14*t18*abb47n38+t14*t19*abb47n39+t14*t20*abb47n&
      &41+t14*t21*abb47n44+t14*t22*abb47n45+t14*t23*abb47n47+t14*t24*abb47n50+t1&
      &4*t25*abb47n53+t14*t4*abb47n18+t14*t5*abb47n21+t15*t16*abb47n30+t15*t17*a&
      &bb47n35+t16*t6*abb47n28+t16*t8*abb47n28+t16*t9*abb47n27+t17*t6*abb47n33+t&
      &17*t8*abb47n33+t17*t9*abb47n32+t18*t5*abb47n54+t19*t5*abb47n55+t2*t5*abb4&
      &7n62+t20*t5*abb47n56+t21*t5*abb47n57+t22*t5*abb47n58+t23*t5*abb47n59+t24*&
      &t5*abb47n60+t25*t5*abb47n61+t3*t5*abb47n63+t4*t5*abb47n10+t4*t5*abb47n64+&
      &t11*t4*t5*abb47n22+t13*t4*t5*abb47n24+t15*t4*t5*abb47n25+t4*t5*t6*abb47n2&
      &3+t4*t5*t8*abb47n23+t4*t5*t9*abb47n22)
      numerator = cmplx(real(d47, ki), aimag(d47), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd47h2
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d47
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d47 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t3 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t4 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t5 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t6 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t7 = t1*abb47n12
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t10 = t1*abb47n13
      t11 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t12 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t13 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t14 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t15 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t16 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4)&
      &)
      t17 = (Q(1)*spvak1k4(1)-Q(2)*spvak1k4(2)-Q(3)*spvak1k4(3)-Q(4)*spvak1k4(4)&
      &)
      t18 = (Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q(3)*spvak6k4(3)-Q(4)*spvak6k4(4)&
      &)
      t19 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t20 = (Q(1)*spvak8k4(1)-Q(2)*spvak8k4(2)-Q(3)*spvak8k4(3)-Q(4)*spvak8k4(4)&
      &)
      t21 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      t22 = (Q(1)*spvak3k5(1)-Q(2)*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4)&
      &)
      t23 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)&
      &)
      t24 = (Q(1)*spvak3k7(1)-Q(2)*spvak3k7(2)-Q(3)*spvak3k7(3)-Q(4)*spvak3k7(4)&
      &)
      t25 = (Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4)&
      &)
      d47 = (t1*abb47n11+t1*abb47n51+t1*abb47n9+t10*t11+t10*t9+t2*abb47n26+t3*ab&
      &b47n31+t4*abb47n36+t4*abb47n8+t6*t7+t7*t8+t1*t13*abb47n15+t1*t15*abb47n16&
      &+t1*t18*abb47n37+t1*t19*abb47n40+t1*t20*abb47n42+t1*t21*abb47n43+t1*t22*a&
      &bb47n46+t1*t23*abb47n48+t1*t24*abb47n49+t1*t25*abb47n52+t1*t4*abb47n19+t1&
      &*t5*abb47n20+t11*t16*abb47n27+t11*t17*abb47n32+t12*t13*abb47n14+t12*t15*a&
      &bb47n17+t12*t18*abb47n38+t12*t19*abb47n39+t12*t20*abb47n41+t12*t21*abb47n&
      &44+t12*t22*abb47n45+t12*t23*abb47n47+t12*t24*abb47n50+t12*t25*abb47n53+t1&
      &2*t4*abb47n18+t12*t5*abb47n21+t13*t14*abb47n14+t13*t16*abb47n29+t13*t17*a&
      &bb47n34+t14*t15*abb47n17+t14*t18*abb47n38+t14*t19*abb47n39+t14*t20*abb47n&
      &41+t14*t21*abb47n44+t14*t22*abb47n45+t14*t23*abb47n47+t14*t24*abb47n50+t1&
      &4*t25*abb47n53+t14*t4*abb47n18+t14*t5*abb47n21+t15*t16*abb47n30+t15*t17*a&
      &bb47n35+t16*t6*abb47n28+t16*t8*abb47n28+t16*t9*abb47n27+t17*t6*abb47n33+t&
      &17*t8*abb47n33+t17*t9*abb47n32+t18*t5*abb47n54+t19*t5*abb47n55+t2*t5*abb4&
      &7n62+t20*t5*abb47n56+t21*t5*abb47n57+t22*t5*abb47n58+t23*t5*abb47n59+t24*&
      &t5*abb47n60+t25*t5*abb47n61+t3*t5*abb47n63+t4*t5*abb47n10+t4*t5*abb47n64+&
      &t11*t4*t5*abb47n22+t13*t4*t5*abb47n24+t15*t4*t5*abb47n25+t4*t5*t6*abb47n2&
      &3+t4*t5*t8*abb47n23+t4*t5*t9*abb47n22)

      numerator = cmplx(real(d47, ki), aimag(d47), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P3B_uux_uux_d47h2l1
