module     P3B_uux_uux_d40h3l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P3B_uux_
   ! uux/helicity3/d40h3l1.f90
   ! generator: haggies (1.1)
   use P3B_uux_uux_config, only: ki
   use P3B_uux_uux_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P3B_uux_uux_groups, only: &
!           & sign => diagram40_sign, shift => diagram40_shift
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd40h3
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d40
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d40 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t4 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t5 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t6 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t7 = (Q(1)*spvak2k3(1)-Q(2)*spvak2k3(2)-Q(3)*spvak2k3(3)-Q(4)*spvak2k3(4))
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t10 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t11 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t12 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t13 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4)&
      &)
      t14 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t15 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t16 = (Q(1)*spvak2k7(1)-Q(2)*spvak2k7(2)-Q(3)*spvak2k7(3)-Q(4)*spvak2k7(4)&
      &)
      t17 = (Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4)&
      &)
      t18 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4)&
      &)
      t19 = (Q(1)*spvak4k1(1)-Q(2)*spvak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4)&
      &)
      t20 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t21 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)&
      &)
      t22 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4)&
      &)
      t23 = (Q(1)*spvak8k1(1)-Q(2)*spvak8k1(2)-Q(3)*spvak8k1(3)-Q(4)*spvak8k1(4)&
      &)
      t24 = t2*abb40n5
      t25 = t2*abb40n6
      d40 = (t1*abb40n14+t10*t24+t2*abb40n31+t24*t9+t25*t6+t25*t8+t3*abb40n32+t4&
      &*abb40n37+t1*t18*abb40n36+t10*t19*abb40n38+t10*t7*abb40n17+t11*t12*abb40n&
      &8+t11*t14*abb40n8+t11*t19*abb40n40+t11*t2*abb40n7+t11*t7*abb40n18+t12*t13&
      &*abb40n20+t12*t15*abb40n21+t12*t16*abb40n22+t12*t17*abb40n23+t12*t18*abb4&
      &0n34+t12*t20*abb40n42+t12*t21*abb40n43+t12*t22*abb40n44+t12*t23*abb40n45+&
      &t12*t4*abb40n51+t12*t5*abb40n9+t13*t14*abb40n20+t13*t18*abb40n24+t14*t15*&
      &abb40n21+t14*t16*abb40n22+t14*t17*abb40n23+t14*t18*abb40n34+t14*t20*abb40&
      &n42+t14*t21*abb40n43+t14*t22*abb40n44+t14*t23*abb40n45+t14*t4*abb40n51+t1&
      &4*t5*abb40n9+t15*t18*abb40n25+t16*t18*abb40n26+t17*t18*abb40n27+t18*t2*ab&
      &b40n35+t18*t20*abb40n47+t18*t21*abb40n46+t18*t22*abb40n49+t18*t23*abb40n4&
      &8+t18*t3*abb40n36+t18*t4*abb40n52+t19*t5*abb40n41+t19*t6*abb40n39+t19*t8*&
      &abb40n39+t19*t9*abb40n38+t2*t4*abb40n50+t2*t5*abb40n10+t2*abb40n11*(Q(1)*&
      &spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(4)*spvak4k5(4))+t2*abb40n&
      &12*(Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4k6(4))+&
      &t2*abb40n13*(Q(1)*spvak4k7(1)-Q(2)*spvak4k7(2)-Q(3)*spvak4k7(3)-Q(4)*spva&
      &k4k7(4))+t2*abb40n15*(Q(1)*spvak4k8(1)-Q(2)*spvak4k8(2)-Q(3)*spvak4k8(3)-&
      &Q(4)*spvak4k8(4))+t2*abb40n28*(Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spv&
      &ak5k3(3)-Q(4)*spvak5k3(4))+t2*abb40n29*(Q(1)*spvak6k3(1)-Q(2)*spvak6k3(2)&
      &-Q(3)*spvak6k3(3)-Q(4)*spvak6k3(4))+t2*abb40n30*(Q(1)*spvak7k3(1)-Q(2)*sp&
      &vak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4))+t2*abb40n33*(Q(1)*spvak8k3(1&
      &)-Q(2)*spvak8k3(2)-Q(3)*spvak8k3(3)-Q(4)*spvak8k3(4))+t5*t7*abb40n19+t6*t&
      &7*abb40n16+t7*t8*abb40n16+t7*t9*abb40n17+t10*t18*t4*abb40n54+t11*t18*t4*a&
      &bb40n55+t18*t4*t5*abb40n56+t18*t4*t6*abb40n53+t18*t4*t8*abb40n53+t18*t4*t&
      &9*abb40n54)
      numerator = cmplx(real(d40, ki), aimag(d40), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd40h3
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d40
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d40 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t4 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t5 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t6 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t7 = (Q(1)*spvak2k3(1)-Q(2)*spvak2k3(2)-Q(3)*spvak2k3(3)-Q(4)*spvak2k3(4))
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t10 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t11 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t12 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t13 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4)&
      &)
      t14 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t15 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t16 = (Q(1)*spvak2k7(1)-Q(2)*spvak2k7(2)-Q(3)*spvak2k7(3)-Q(4)*spvak2k7(4)&
      &)
      t17 = (Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4)&
      &)
      t18 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4)&
      &)
      t19 = (Q(1)*spvak4k1(1)-Q(2)*spvak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4)&
      &)
      t20 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t21 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)&
      &)
      t22 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4)&
      &)
      t23 = (Q(1)*spvak8k1(1)-Q(2)*spvak8k1(2)-Q(3)*spvak8k1(3)-Q(4)*spvak8k1(4)&
      &)
      t24 = t2*abb40n5
      t25 = t2*abb40n6
      d40 = (t1*abb40n14+t10*t24+t2*abb40n31+t24*t9+t25*t6+t25*t8+t3*abb40n32+t4&
      &*abb40n37+t1*t18*abb40n36+t10*t19*abb40n38+t10*t7*abb40n17+t11*t12*abb40n&
      &8+t11*t14*abb40n8+t11*t19*abb40n40+t11*t2*abb40n7+t11*t7*abb40n18+t12*t13&
      &*abb40n20+t12*t15*abb40n21+t12*t16*abb40n22+t12*t17*abb40n23+t12*t18*abb4&
      &0n34+t12*t20*abb40n42+t12*t21*abb40n43+t12*t22*abb40n44+t12*t23*abb40n45+&
      &t12*t4*abb40n51+t12*t5*abb40n9+t13*t14*abb40n20+t13*t18*abb40n24+t14*t15*&
      &abb40n21+t14*t16*abb40n22+t14*t17*abb40n23+t14*t18*abb40n34+t14*t20*abb40&
      &n42+t14*t21*abb40n43+t14*t22*abb40n44+t14*t23*abb40n45+t14*t4*abb40n51+t1&
      &4*t5*abb40n9+t15*t18*abb40n25+t16*t18*abb40n26+t17*t18*abb40n27+t18*t2*ab&
      &b40n35+t18*t20*abb40n47+t18*t21*abb40n46+t18*t22*abb40n49+t18*t23*abb40n4&
      &8+t18*t3*abb40n36+t18*t4*abb40n52+t19*t5*abb40n41+t19*t6*abb40n39+t19*t8*&
      &abb40n39+t19*t9*abb40n38+t2*t4*abb40n50+t2*t5*abb40n10+t2*abb40n11*(Q(1)*&
      &spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(4)*spvak4k5(4))+t2*abb40n&
      &12*(Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4k6(4))+&
      &t2*abb40n13*(Q(1)*spvak4k7(1)-Q(2)*spvak4k7(2)-Q(3)*spvak4k7(3)-Q(4)*spva&
      &k4k7(4))+t2*abb40n15*(Q(1)*spvak4k8(1)-Q(2)*spvak4k8(2)-Q(3)*spvak4k8(3)-&
      &Q(4)*spvak4k8(4))+t2*abb40n28*(Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spv&
      &ak5k3(3)-Q(4)*spvak5k3(4))+t2*abb40n29*(Q(1)*spvak6k3(1)-Q(2)*spvak6k3(2)&
      &-Q(3)*spvak6k3(3)-Q(4)*spvak6k3(4))+t2*abb40n30*(Q(1)*spvak7k3(1)-Q(2)*sp&
      &vak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4))+t2*abb40n33*(Q(1)*spvak8k3(1&
      &)-Q(2)*spvak8k3(2)-Q(3)*spvak8k3(3)-Q(4)*spvak8k3(4))+t5*t7*abb40n19+t6*t&
      &7*abb40n16+t7*t8*abb40n16+t7*t9*abb40n17+t10*t18*t4*abb40n54+t11*t18*t4*a&
      &bb40n55+t18*t4*t5*abb40n56+t18*t4*t6*abb40n53+t18*t4*t8*abb40n53+t18*t4*t&
      &9*abb40n54)

      numerator = cmplx(real(d40, ki), aimag(d40), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P3B_uux_uux_d40h3l1
