module     P3B_uux_uux_d43h3l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P3B_uux_
   ! uux/helicity3/d43h3l1.f90
   ! generator: haggies (1.1)
   use P3B_uux_uux_config, only: ki
   use P3B_uux_uux_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P3B_uux_uux_groups, only: &
!           & sign => diagram43_sign, shift => diagram43_shift
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd43h3
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d43
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d43 = 0.0_ki
      t1 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t4 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t5 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t6 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t7 = t2*abb43n13
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t10 = t2*abb43n14
      t11 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t12 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t13 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t14 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t15 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t16 = (Q(1)*spvak4k1(1)-Q(2)*spvak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4)&
      &)
      t17 = (Q(1)*spvak2k3(1)-Q(2)*spvak2k3(2)-Q(3)*spvak2k3(3)-Q(4)*spvak2k3(4)&
      &)
      t18 = (Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(4)*spvak4k5(4)&
      &)
      t19 = (Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4k6(4)&
      &)
      t20 = (Q(1)*spvak4k7(1)-Q(2)*spvak4k7(2)-Q(3)*spvak4k7(3)-Q(4)*spvak4k7(4)&
      &)
      t21 = (Q(1)*spvak4k8(1)-Q(2)*spvak4k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4)&
      &)
      t22 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t23 = (Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4)&
      &)
      t24 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      t25 = (Q(1)*spvak6k3(1)-Q(2)*spvak6k3(2)-Q(3)*spvak6k3(3)-Q(4)*spvak6k3(4)&
      &)
      t26 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4)&
      &)
      t27 = (Q(1)*spvak8k3(1)-Q(2)*spvak8k3(2)-Q(3)*spvak8k3(3)-Q(4)*spvak8k3(4)&
      &)
      t28 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t29 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4)&
      &)
      d43 = (t1*abb43n10+t1*abb43n32+t10*t11+t10*t9+t2*abb43n12+t2*abb43n56+t2*a&
      &bb43n9+t3*abb43n27+t4*abb43n33+t6*t7+t7*t8+t1*t12*abb43n19+t1*t14*abb43n1&
      &9+t1*t2*abb43n20+t1*t5*abb43n11+t1*t5*abb43n73+t11*t16*abb43n29+t11*t17*a&
      &bb43n35+t12*t13*abb43n15+t12*t15*abb43n18+t12*t18*abb43n38+t12*t19*abb43n&
      &40+t12*t20*abb43n43+t12*t21*abb43n45+t12*t22*abb43n47+t12*t23*abb43n48+t1&
      &2*t24*abb43n51+t12*t25*abb43n53+t12*t26*abb43n54+t12*t27*abb43n57+t12*t28&
      &*abb43n67+t12*t29*abb43n70+t12*t5*abb43n22+t13*t14*abb43n15+t13*t16*abb43&
      &n30+t13*t17*abb43n36+t13*t2*abb43n16+t14*t15*abb43n18+t14*t18*abb43n38+t1&
      &4*t19*abb43n40+t14*t20*abb43n43+t14*t21*abb43n45+t14*t22*abb43n47+t14*t23&
      &*abb43n48+t14*t24*abb43n51+t14*t25*abb43n53+t14*t26*abb43n54+t14*t27*abb4&
      &3n57+t14*t28*abb43n67+t14*t29*abb43n70+t14*t5*abb43n22+t15*t16*abb43n31+t&
      &15*t17*abb43n37+t15*t2*abb43n17+t16*t6*abb43n28+t16*t8*abb43n28+t16*t9*ab&
      &b43n29+t17*t6*abb43n34+t17*t8*abb43n34+t17*t9*abb43n35+t18*t2*abb43n39+t1&
      &8*t5*abb43n59+t19*t2*abb43n41+t19*t5*abb43n60+t2*t20*abb43n42+t2*t21*abb4&
      &3n44+t2*t22*abb43n46+t2*t23*abb43n49+t2*t24*abb43n50+t2*t25*abb43n52+t2*t&
      &26*abb43n55+t2*t27*abb43n58+t2*t28*abb43n68+t2*t29*abb43n69+t2*t5*abb43n2&
      &1+t20*t5*abb43n61+t21*t5*abb43n62+t24*t5*abb43n64+t25*t5*abb43n63+t26*t5*&
      &abb43n66+t27*t5*abb43n65+t3*t5*abb43n71+t4*t5*abb43n72+t1*t11*t5*abb43n23&
      &+t1*t13*t5*abb43n25+t1*t15*t5*abb43n26+t1*t5*t6*abb43n24+t1*t5*t8*abb43n2&
      &4+t1*t5*t9*abb43n23)
      numerator = cmplx(real(d43, ki), aimag(d43), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd43h3
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d43
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d43 = 0.0_ki
      t1 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t4 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t5 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t6 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t7 = t2*abb43n13
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t10 = t2*abb43n14
      t11 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t12 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t13 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t14 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t15 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t16 = (Q(1)*spvak4k1(1)-Q(2)*spvak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4)&
      &)
      t17 = (Q(1)*spvak2k3(1)-Q(2)*spvak2k3(2)-Q(3)*spvak2k3(3)-Q(4)*spvak2k3(4)&
      &)
      t18 = (Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(4)*spvak4k5(4)&
      &)
      t19 = (Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4k6(4)&
      &)
      t20 = (Q(1)*spvak4k7(1)-Q(2)*spvak4k7(2)-Q(3)*spvak4k7(3)-Q(4)*spvak4k7(4)&
      &)
      t21 = (Q(1)*spvak4k8(1)-Q(2)*spvak4k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4)&
      &)
      t22 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t23 = (Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4)&
      &)
      t24 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      t25 = (Q(1)*spvak6k3(1)-Q(2)*spvak6k3(2)-Q(3)*spvak6k3(3)-Q(4)*spvak6k3(4)&
      &)
      t26 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4)&
      &)
      t27 = (Q(1)*spvak8k3(1)-Q(2)*spvak8k3(2)-Q(3)*spvak8k3(3)-Q(4)*spvak8k3(4)&
      &)
      t28 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t29 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4)&
      &)
      d43 = (t1*abb43n10+t1*abb43n32+t10*t11+t10*t9+t2*abb43n12+t2*abb43n56+t2*a&
      &bb43n9+t3*abb43n27+t4*abb43n33+t6*t7+t7*t8+t1*t12*abb43n19+t1*t14*abb43n1&
      &9+t1*t2*abb43n20+t1*t5*abb43n11+t1*t5*abb43n73+t11*t16*abb43n29+t11*t17*a&
      &bb43n35+t12*t13*abb43n15+t12*t15*abb43n18+t12*t18*abb43n38+t12*t19*abb43n&
      &40+t12*t20*abb43n43+t12*t21*abb43n45+t12*t22*abb43n47+t12*t23*abb43n48+t1&
      &2*t24*abb43n51+t12*t25*abb43n53+t12*t26*abb43n54+t12*t27*abb43n57+t12*t28&
      &*abb43n67+t12*t29*abb43n70+t12*t5*abb43n22+t13*t14*abb43n15+t13*t16*abb43&
      &n30+t13*t17*abb43n36+t13*t2*abb43n16+t14*t15*abb43n18+t14*t18*abb43n38+t1&
      &4*t19*abb43n40+t14*t20*abb43n43+t14*t21*abb43n45+t14*t22*abb43n47+t14*t23&
      &*abb43n48+t14*t24*abb43n51+t14*t25*abb43n53+t14*t26*abb43n54+t14*t27*abb4&
      &3n57+t14*t28*abb43n67+t14*t29*abb43n70+t14*t5*abb43n22+t15*t16*abb43n31+t&
      &15*t17*abb43n37+t15*t2*abb43n17+t16*t6*abb43n28+t16*t8*abb43n28+t16*t9*ab&
      &b43n29+t17*t6*abb43n34+t17*t8*abb43n34+t17*t9*abb43n35+t18*t2*abb43n39+t1&
      &8*t5*abb43n59+t19*t2*abb43n41+t19*t5*abb43n60+t2*t20*abb43n42+t2*t21*abb4&
      &3n44+t2*t22*abb43n46+t2*t23*abb43n49+t2*t24*abb43n50+t2*t25*abb43n52+t2*t&
      &26*abb43n55+t2*t27*abb43n58+t2*t28*abb43n68+t2*t29*abb43n69+t2*t5*abb43n2&
      &1+t20*t5*abb43n61+t21*t5*abb43n62+t24*t5*abb43n64+t25*t5*abb43n63+t26*t5*&
      &abb43n66+t27*t5*abb43n65+t3*t5*abb43n71+t4*t5*abb43n72+t1*t11*t5*abb43n23&
      &+t1*t13*t5*abb43n25+t1*t15*t5*abb43n26+t1*t5*t6*abb43n24+t1*t5*t8*abb43n2&
      &4+t1*t5*t9*abb43n23)

      numerator = cmplx(real(d43, ki), aimag(d43), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P3B_uux_uux_d43h3l1
