module     P3B_uux_uux_d4h3l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P3B_uux_
   ! uux/helicity3/d4h3l1.f90
   ! generator: haggies (1.1)
   use P3B_uux_uux_config, only: ki
   use P3B_uux_uux_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P3B_uux_uux_groups, only: &
!           & sign => diagram4_sign, shift => diagram4_shift
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd4h3
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d4
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d4 = 0.0_ki
      t1 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t2 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t5 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t6 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t7 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4))
      t10 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4)&
      &)
      t11 = (Q(1)*spvak4k1(1)-Q(2)*spvak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4)&
      &)
      t12 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t13 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t14 = t3*abb4n34
      t15 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      d4 = (t1*t14+t1*abb4n16+t14*t2+t2*abb4n16+t3*abb4n17+t3*t3*abb4n33+t4*abb4&
      &n20+t5*abb4n3+t6*abb4n36+t7*abb4n4+t8*abb4n4+t9*abb4n5+t1*t10*abb4n32+t1*&
      &t5*abb4n14+t1*t6*abb4n46+t1*t9*abb4n18+t10*t12*abb4n8+t10*t13*abb4n9+t10*&
      &t2*abb4n32+t10*t3*abb4n31+t10*t4*abb4n35+t10*t6*abb4n40+t10*t7*abb4n10+t1&
      &1*t3*abb4n11+t12*t3*abb4n25+t13*t3*abb4n26+t2*t5*abb4n14+t2*t6*abb4n46+t2&
      &*t9*abb4n18+t3*t4*abb4n24+t3*t5*abb4n15+t3*t6*abb4n45+t3*t7*abb4n27+t3*t9&
      &*abb4n19+t4*t5*abb4n2+t4*t6*abb4n47+t4*t9*abb4n6+t5*t6*abb4n43+t6*t7*abb4&
      &n44+t6*t8*abb4n44+t6*t9*abb4n48+t1*t10*t5*abb4n29+t1*t12*t5*abb4n37+t1*t1&
      &5*t5*abb4n22+t1*t4*t5*abb4n13+t1*t5*t6*abb4n50+t10*t12*t6*abb4n30+t10*t13&
      &*t6*abb4n42+t10*t2*t5*abb4n29+t10*t3*t5*abb4n28+t10*t3*t6*abb4n56+t10*t4*&
      &t6*abb4n54+t10*t5*t6*abb4n39+t10*t6*t7*abb4n55+t11*t4*t5*abb4n7+t11*t5*t6&
      &*abb4n23+t12*t2*t5*abb4n37+t12*t3*t5*abb4n38+t15*t2*t5*abb4n22+t15*t3*t5*&
      &abb4n21+t2*t4*t5*abb4n13+t2*t5*t6*abb4n50+t3*t4*t5*abb4n12+t3*t4*t6*abb4n&
      &53+t3*t6*abb4n51*(Q(1)*spvak5k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q(4)&
      &*spvak5k8(4))+t3*t6*abb4n52*(Q(1)*spvak7k6(1)-Q(2)*spvak7k6(2)-Q(3)*spvak&
      &7k6(3)-Q(4)*spvak7k6(4))+t4*t6*t9*abb4n49+t5*t6*abb4n41*(Q(1)*spvak4k2(1)&
      &-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4))+t10*t4*t5*t6*abb4n57&
      &)
      numerator = cmplx(real(d4, ki), aimag(d4), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd4h3
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d4
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d4 = 0.0_ki
      t1 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t2 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t5 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t6 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t7 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4))
      t10 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4)&
      &)
      t11 = (Q(1)*spvak4k1(1)-Q(2)*spvak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4)&
      &)
      t12 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t13 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t14 = t3*abb4n34
      t15 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      d4 = (t1*t14+t1*abb4n16+t14*t2+t2*abb4n16+t3*abb4n17+t3*t3*abb4n33+t4*abb4&
      &n20+t5*abb4n3+t6*abb4n36+t7*abb4n4+t8*abb4n4+t9*abb4n5+t1*t10*abb4n32+t1*&
      &t5*abb4n14+t1*t6*abb4n46+t1*t9*abb4n18+t10*t12*abb4n8+t10*t13*abb4n9+t10*&
      &t2*abb4n32+t10*t3*abb4n31+t10*t4*abb4n35+t10*t6*abb4n40+t10*t7*abb4n10+t1&
      &1*t3*abb4n11+t12*t3*abb4n25+t13*t3*abb4n26+t2*t5*abb4n14+t2*t6*abb4n46+t2&
      &*t9*abb4n18+t3*t4*abb4n24+t3*t5*abb4n15+t3*t6*abb4n45+t3*t7*abb4n27+t3*t9&
      &*abb4n19+t4*t5*abb4n2+t4*t6*abb4n47+t4*t9*abb4n6+t5*t6*abb4n43+t6*t7*abb4&
      &n44+t6*t8*abb4n44+t6*t9*abb4n48+t1*t10*t5*abb4n29+t1*t12*t5*abb4n37+t1*t1&
      &5*t5*abb4n22+t1*t4*t5*abb4n13+t1*t5*t6*abb4n50+t10*t12*t6*abb4n30+t10*t13&
      &*t6*abb4n42+t10*t2*t5*abb4n29+t10*t3*t5*abb4n28+t10*t3*t6*abb4n56+t10*t4*&
      &t6*abb4n54+t10*t5*t6*abb4n39+t10*t6*t7*abb4n55+t11*t4*t5*abb4n7+t11*t5*t6&
      &*abb4n23+t12*t2*t5*abb4n37+t12*t3*t5*abb4n38+t15*t2*t5*abb4n22+t15*t3*t5*&
      &abb4n21+t2*t4*t5*abb4n13+t2*t5*t6*abb4n50+t3*t4*t5*abb4n12+t3*t4*t6*abb4n&
      &53+t3*t6*abb4n51*(Q(1)*spvak5k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q(4)&
      &*spvak5k8(4))+t3*t6*abb4n52*(Q(1)*spvak7k6(1)-Q(2)*spvak7k6(2)-Q(3)*spvak&
      &7k6(3)-Q(4)*spvak7k6(4))+t4*t6*t9*abb4n49+t5*t6*abb4n41*(Q(1)*spvak4k2(1)&
      &-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4))+t10*t4*t5*t6*abb4n57&
      &)

      numerator = cmplx(real(d4, ki), aimag(d4), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P3B_uux_uux_d4h3l1
