module     P3B_uux_uux_d21h4l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P3B_uux_
   ! uux/helicity4/d21h4l1.f90
   ! generator: haggies (1.1)
   use P3B_uux_uux_config, only: ki
   use P3B_uux_uux_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P3B_uux_uux_groups, only: &
!           & sign => diagram21_sign, shift => diagram21_shift
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd21h4
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d21
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k6-k5
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d21 = 0.0_ki
      t1 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4))
      t2 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t3 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t4 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t5 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t6 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t7 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4))
      t8 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t9 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t10 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t11 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t12 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t13 = t4*abb21n36
      t14 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t15 = t5*abb21n37
      t16 = t6*abb21n40
      t17 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      t18 = (Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4)&
      &)
      d21 = (t1*abb21n12+t12*t13+t12*t15+t12*t16+t13*t14+t14*t15+t14*t16+t15*t6+&
      &t2*abb21n13+t3*abb21n16+t4*abb21n20+t5*abb21n21+t5*t5*abb21n38+t6*abb21n2&
      &2+t7*abb21n3+t8*abb21n57+t1*t11*abb21n8+t1*t5*abb21n35+t1*t8*abb21n45+t10&
      &*t3*abb21n11+t10*t4*abb21n26+t10*t5*abb21n27+t10*t6*abb21n28+t10*t8*abb21&
      &n67+t11*t2*abb21n9+t11*t3*abb21n15+t11*t4*abb21n19+t11*t5*abb21n18+t11*t6&
      &*abb21n17+t11*t7*abb21n2+t11*t8*abb21n56+t12*t3*abb21n7+t12*t8*abb21n47+t&
      &14*t3*abb21n7+t14*t8*abb21n47+t17*t8*abb21n49+t2*t5*abb21n41+t2*t8*abb21n&
      &60+t3*t5*abb21n34+t3*t8*abb21n58+t3*t9*abb21n10+t4*t5*abb21n39+t4*t9*abb2&
      &1n51+t5*t7*abb21n4+t5*t8*abb21n59+t5*t9*abb21n50+t6*t9*abb21n48+t7*t8*abb&
      &21n5+t8*t9*abb21n32+t1*t11*t8*abb21n46+t10*t11*t4*abb21n42+t10*t11*t5*abb&
      &21n43+t10*t11*t6*abb21n44+t10*t11*t8*abb21n68+t10*t17*t8*abb21n69+t10*t18&
      &*t4*abb21n29+t10*t18*t5*abb21n30+t10*t18*t6*abb21n31+t10*t3*t4*abb21n23+t&
      &10*t3*t5*abb21n24+t10*t3*t6*abb21n25+t10*t3*t9*abb21n14+t10*t4*t7*abb21n6&
      &6+t10*t4*t8*abb21n72+t10*t5*t7*abb21n65+t10*t6*t7*abb21n64+t10*t6*t8*abb2&
      &1n71+t10*t8*t9*abb21n33+t11*t2*t8*abb21n62+t11*t3*t8*abb21n61+t11*t5*t8*a&
      &bb21n63+t11*t7*t8*abb21n6+t12*t3*t8*abb21n53+t14*t3*t8*abb21n53+t3*t5*t8*&
      &abb21n52+t3*t8*abb21n54*(Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(&
      &3)-Q(4)*spvak5k4(4))+t5*t8*abb21n55*(Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(&
      &3)*spvak7k4(3)-Q(4)*spvak7k4(4))+t5*t8*abb21n70*(Q(1)*spvak2k8(1)-Q(2)*sp&
      &vak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4))+t10*t11*t3*t8*abb21n73)
      numerator = cmplx(real(d21, ki), aimag(d21), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd21h4
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d21
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k6-k5
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d21 = 0.0_ki
      t1 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4))
      t2 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t3 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t4 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t5 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t6 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t7 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4))
      t8 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t9 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t10 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t11 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t12 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t13 = t4*abb21n36
      t14 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t15 = t5*abb21n37
      t16 = t6*abb21n40
      t17 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      t18 = (Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4)&
      &)
      d21 = (t1*abb21n12+t12*t13+t12*t15+t12*t16+t13*t14+t14*t15+t14*t16+t15*t6+&
      &t2*abb21n13+t3*abb21n16+t4*abb21n20+t5*abb21n21+t5*t5*abb21n38+t6*abb21n2&
      &2+t7*abb21n3+t8*abb21n57+t1*t11*abb21n8+t1*t5*abb21n35+t1*t8*abb21n45+t10&
      &*t3*abb21n11+t10*t4*abb21n26+t10*t5*abb21n27+t10*t6*abb21n28+t10*t8*abb21&
      &n67+t11*t2*abb21n9+t11*t3*abb21n15+t11*t4*abb21n19+t11*t5*abb21n18+t11*t6&
      &*abb21n17+t11*t7*abb21n2+t11*t8*abb21n56+t12*t3*abb21n7+t12*t8*abb21n47+t&
      &14*t3*abb21n7+t14*t8*abb21n47+t17*t8*abb21n49+t2*t5*abb21n41+t2*t8*abb21n&
      &60+t3*t5*abb21n34+t3*t8*abb21n58+t3*t9*abb21n10+t4*t5*abb21n39+t4*t9*abb2&
      &1n51+t5*t7*abb21n4+t5*t8*abb21n59+t5*t9*abb21n50+t6*t9*abb21n48+t7*t8*abb&
      &21n5+t8*t9*abb21n32+t1*t11*t8*abb21n46+t10*t11*t4*abb21n42+t10*t11*t5*abb&
      &21n43+t10*t11*t6*abb21n44+t10*t11*t8*abb21n68+t10*t17*t8*abb21n69+t10*t18&
      &*t4*abb21n29+t10*t18*t5*abb21n30+t10*t18*t6*abb21n31+t10*t3*t4*abb21n23+t&
      &10*t3*t5*abb21n24+t10*t3*t6*abb21n25+t10*t3*t9*abb21n14+t10*t4*t7*abb21n6&
      &6+t10*t4*t8*abb21n72+t10*t5*t7*abb21n65+t10*t6*t7*abb21n64+t10*t6*t8*abb2&
      &1n71+t10*t8*t9*abb21n33+t11*t2*t8*abb21n62+t11*t3*t8*abb21n61+t11*t5*t8*a&
      &bb21n63+t11*t7*t8*abb21n6+t12*t3*t8*abb21n53+t14*t3*t8*abb21n53+t3*t5*t8*&
      &abb21n52+t3*t8*abb21n54*(Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(&
      &3)-Q(4)*spvak5k4(4))+t5*t8*abb21n55*(Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(&
      &3)*spvak7k4(3)-Q(4)*spvak7k4(4))+t5*t8*abb21n70*(Q(1)*spvak2k8(1)-Q(2)*sp&
      &vak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4))+t10*t11*t3*t8*abb21n73)

      numerator = cmplx(real(d21, ki), aimag(d21), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P3B_uux_uux_d21h4l1
