module     P3B_uux_uux_d13h5l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P3B_uux_
   ! uux/helicity5/d13h5l1.f90
   ! generator: haggies (1.1)
   use P3B_uux_uux_config, only: ki
   use P3B_uux_uux_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P3B_uux_uux_groups, only: &
!           & sign => diagram13_sign, shift => diagram13_shift
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd13h5
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d13
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2-k4
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d13 = 0.0_ki
      t1 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t2 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t3 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4))
      t4 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t5 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t6 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t7 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t8 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t9 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t10 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t11 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t12 = t4*abb13n28
      t13 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t14 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t15 = (Q(1)*spvak5k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q(4)*spvak5k8(4)&
      &)
      t16 = (Q(1)*spvak7k6(1)-Q(2)*spvak7k6(2)-Q(3)*spvak7k6(3)-Q(4)*spvak7k6(4)&
      &)
      d13 = (t1*abb13n11+t10*abb13n6+t11*abb13n7+t12*t7+t12*t8+t12*t9+t2*abb13n1&
      &4+t3*abb13n17+t4*abb13n23+t4*t4*abb13n29+t5*abb13n3+t6*abb13n4+t7*abb13n5&
      &+t8*abb13n5+t9*abb13n5+t1*t10*abb13n12+t1*t11*abb13n13+t1*t3*abb13n22+t1*&
      &t4*abb13n48+t1*t5*abb13n10+t10*t13*abb13n41+t10*t2*abb13n9+t11*t13*abb13n&
      &43+t11*t2*abb13n8+t13*t14*abb13n37+t13*t2*abb13n35+t13*t3*abb13n56+t13*t4&
      &*abb13n42+t13*t5*abb13n32+t13*t6*abb13n33+t13*t7*abb13n34+t13*t8*abb13n34&
      &+t13*t9*abb13n34+t2*t3*abb13n31+t2*t4*abb13n27+t2*t5*abb13n2+t3*t4*abb13n&
      &19+t3*t5*abb13n25+t3*t6*abb13n18+t3*t7*abb13n20+t3*t8*abb13n20+t3*t9*abb1&
      &3n20+t4*t5*abb13n24+t4*t6*abb13n30+t1*t3*t5*abb13n21+t1*t4*t5*abb13n38+t1&
      &0*t13*t15*abb13n46+t10*t13*t16*abb13n49+t10*t13*t2*abb13n54+t10*t13*t3*ab&
      &b13n60+t10*t13*t5*abb13n40+t11*t13*t15*abb13n44+t11*t13*t16*abb13n51+t11*&
      &t13*t2*abb13n52+t11*t13*t3*abb13n62+t11*t13*t5*abb13n39+t13*t14*t3*abb13n&
      &47+t13*t14*t5*abb13n36+t13*t15*t3*abb13n58+t13*t15*t4*abb13n45+t13*t16*t4&
      &*abb13n50+t13*t2*t3*abb13n64+t13*t2*t4*abb13n53+t13*t3*t4*abb13n61+t13*t3&
      &*t5*abb13n55+t13*t3*t6*abb13n63+t13*t3*t7*abb13n59+t13*t3*t8*abb13n59+t13&
      &*t3*t9*abb13n59+t13*t3*abb13n57*(Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*s&
      &pvak5k4(3)-Q(4)*spvak5k4(4))+t2*t4*t5*abb13n15+t3*t4*t5*abb13n26+t4*t5*ab&
      &b13n16*(Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(&
      &4))+t13*t2*t3*t5*abb13n65)
      numerator = cmplx(real(d13, ki), aimag(d13), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P3B_uux_uux_globalsl1, only: epspow
      use P3B_uux_uux_kinematics
      use P3B_uux_uux_abbrevd13h5
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d13
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2-k4
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d13 = 0.0_ki
      t1 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t2 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t3 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4))
      t4 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t5 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t6 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t7 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t8 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t9 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t10 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t11 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t12 = t4*abb13n28
      t13 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t14 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t15 = (Q(1)*spvak5k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q(4)*spvak5k8(4)&
      &)
      t16 = (Q(1)*spvak7k6(1)-Q(2)*spvak7k6(2)-Q(3)*spvak7k6(3)-Q(4)*spvak7k6(4)&
      &)
      d13 = (t1*abb13n11+t10*abb13n6+t11*abb13n7+t12*t7+t12*t8+t12*t9+t2*abb13n1&
      &4+t3*abb13n17+t4*abb13n23+t4*t4*abb13n29+t5*abb13n3+t6*abb13n4+t7*abb13n5&
      &+t8*abb13n5+t9*abb13n5+t1*t10*abb13n12+t1*t11*abb13n13+t1*t3*abb13n22+t1*&
      &t4*abb13n48+t1*t5*abb13n10+t10*t13*abb13n41+t10*t2*abb13n9+t11*t13*abb13n&
      &43+t11*t2*abb13n8+t13*t14*abb13n37+t13*t2*abb13n35+t13*t3*abb13n56+t13*t4&
      &*abb13n42+t13*t5*abb13n32+t13*t6*abb13n33+t13*t7*abb13n34+t13*t8*abb13n34&
      &+t13*t9*abb13n34+t2*t3*abb13n31+t2*t4*abb13n27+t2*t5*abb13n2+t3*t4*abb13n&
      &19+t3*t5*abb13n25+t3*t6*abb13n18+t3*t7*abb13n20+t3*t8*abb13n20+t3*t9*abb1&
      &3n20+t4*t5*abb13n24+t4*t6*abb13n30+t1*t3*t5*abb13n21+t1*t4*t5*abb13n38+t1&
      &0*t13*t15*abb13n46+t10*t13*t16*abb13n49+t10*t13*t2*abb13n54+t10*t13*t3*ab&
      &b13n60+t10*t13*t5*abb13n40+t11*t13*t15*abb13n44+t11*t13*t16*abb13n51+t11*&
      &t13*t2*abb13n52+t11*t13*t3*abb13n62+t11*t13*t5*abb13n39+t13*t14*t3*abb13n&
      &47+t13*t14*t5*abb13n36+t13*t15*t3*abb13n58+t13*t15*t4*abb13n45+t13*t16*t4&
      &*abb13n50+t13*t2*t3*abb13n64+t13*t2*t4*abb13n53+t13*t3*t4*abb13n61+t13*t3&
      &*t5*abb13n55+t13*t3*t6*abb13n63+t13*t3*t7*abb13n59+t13*t3*t8*abb13n59+t13&
      &*t3*t9*abb13n59+t13*t3*abb13n57*(Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*s&
      &pvak5k4(3)-Q(4)*spvak5k4(4))+t2*t4*t5*abb13n15+t3*t4*t5*abb13n26+t4*t5*ab&
      &b13n16*(Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(&
      &4))+t13*t2*t3*t5*abb13n65)

      numerator = cmplx(real(d13, ki), aimag(d13), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P3B_uux_uux_d13h5l1
