module     P3B_uux_uux_samuraih5
   ! This file has been generated for samurai version 2.0
   use precision, only: ki_sam => ki
   use P3B_uux_uux_config, only: ki
   use P3B_uux_uux_scalar_cache
   implicit none
   private
   public :: reduce_group0
   public :: reduce_group1
   public :: reduce_group2
   public :: reduce_group3
   public :: reduce_group4
   public :: reduce_group5
contains
!---#[ grouped numerators for samurai:
!-----#[ function numeval_group0:
function     numeval_group0(icut, Q, mu2) result(num)
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P3B_uux_uux_model
   use P3B_uux_uux_d21h5l1, only: numerator_d21 => numerator_samurai
   use P3B_uux_uux_d22h5l1, only: numerator_d22 => numerator_samurai
   use P3B_uux_uux_d23h5l1, only: numerator_d23 => numerator_samurai
   use P3B_uux_uux_d24h5l1, only: numerator_d24 => numerator_samurai
   implicit none
   integer, intent(in) :: icut
   complex(ki_sam), dimension(4), intent(in) :: Q
   real(ki_sam), intent(in) :: mu2
   complex(ki_sam) :: num

   logical, dimension(0:4-1) :: nonzero
   real(ki_sam), dimension(0:3) :: R
   complex(ki_sam) :: Q2
   complex(ki_sam) ::denom1,denom2,denom3,denom4

   nonzero(:) = .true.
   Q2 = Q(4)*Q(4) - Q(1)*Q(1) - Q(2)*Q(2) - Q(3)*Q(3) - mu2

   select case(icut)
   case default
      R = real(-k2+k7+k8+k4, ki_sam)
      denom1 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      R = real(-k2+k4, ki_sam)
      denom2 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      denom3 = Q2
      R = real(-k6-k5, ki_sam)
      denom4 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
   end select

   num = (0.0_ki_sam, 0.0_ki_sam)
   !-------#[ Diagram 21:
   if(nonzero(0)) then
      num = num + Nfrat * numerator_d21(icut, Q, mu2)
   end if
   !-------#] Diagram 21:
   !-------#[ Diagram 22:
   if(nonzero(1)) then
      num = num + Nfrat * numerator_d22(icut, Q, mu2)
   end if
   !-------#] Diagram 22:
   !-------#[ Diagram 23:
   if(nonzero(2)) then
      num = num + Nfrat * numerator_d23(icut, Q, mu2)
   end if
   !-------#] Diagram 23:
   !-------#[ Diagram 24:
   if(nonzero(3)) then
      num = num + Nfrat * numerator_d24(icut, Q, mu2)
   end if
   !-------#] Diagram 24:
end function numeval_group0
!-----#] function numeval_group0:
!-----#[ function numeval_group1:
function     numeval_group1(icut, Q, mu2) result(num)
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P3B_uux_uux_model
   use P3B_uux_uux_d17h5l1, only: numerator_d17 => numerator_samurai
   use P3B_uux_uux_d18h5l1, only: numerator_d18 => numerator_samurai
   use P3B_uux_uux_d19h5l1, only: numerator_d19 => numerator_samurai
   use P3B_uux_uux_d20h5l1, only: numerator_d20 => numerator_samurai
   use P3B_uux_uux_d49h5l1, only: numerator_d49 => numerator_samurai
   use P3B_uux_uux_d50h5l1, only: numerator_d50 => numerator_samurai
   use P3B_uux_uux_d51h5l1, only: numerator_d51 => numerator_samurai
   use P3B_uux_uux_d52h5l1, only: numerator_d52 => numerator_samurai
   use P3B_uux_uux_d53h5l1, only: numerator_d53 => numerator_samurai
   use P3B_uux_uux_d54h5l1, only: numerator_d54 => numerator_samurai
   use P3B_uux_uux_d55h5l1, only: numerator_d55 => numerator_samurai
   use P3B_uux_uux_d56h5l1, only: numerator_d56 => numerator_samurai
   use P3B_uux_uux_d57h5l1, only: numerator_d57 => numerator_samurai
   use P3B_uux_uux_d58h5l1, only: numerator_d58 => numerator_samurai
   use P3B_uux_uux_d59h5l1, only: numerator_d59 => numerator_samurai
   use P3B_uux_uux_d60h5l1, only: numerator_d60 => numerator_samurai
   use P3B_uux_uux_d61h5l1, only: numerator_d61 => numerator_samurai
   use P3B_uux_uux_d62h5l1, only: numerator_d62 => numerator_samurai
   use P3B_uux_uux_d63h5l1, only: numerator_d63 => numerator_samurai
   use P3B_uux_uux_d64h5l1, only: numerator_d64 => numerator_samurai
   implicit none
   integer, intent(in) :: icut
   complex(ki_sam), dimension(4), intent(in) :: Q
   real(ki_sam), intent(in) :: mu2
   complex(ki_sam) :: num

   logical, dimension(0:20-1) :: nonzero
   real(ki_sam), dimension(0:3) :: R
   complex(ki_sam) :: Q2
   complex(ki_sam) ::denom1,denom2,denom3,denom4

   nonzero(:) = .true.
   Q2 = Q(4)*Q(4) - Q(1)*Q(1) - Q(2)*Q(2) - Q(3)*Q(3) - mu2

   select case(icut)
   case(1)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      R = real(-k7-k8-k5-k6, ki_sam)
      denom1 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      denom2 = 0.0_ki
      denom3 = Q2
      R = real(-k2+k4, ki_sam)
      denom4 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
   case(10)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      denom1 = 0.0_ki
      denom2 = 0.0_ki
      denom3 = Q2
      R = real(-k2+k4, ki_sam)
      denom4 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
   case(21)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      R = real(-k7-k8-k5-k6, ki_sam)
      denom1 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      denom2 = 0.0_ki
      denom3 = 0.0_ki
      R = real(-k2+k4, ki_sam)
      denom4 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
   case(210)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      denom1 = 0.0_ki
      denom2 = 0.0_ki
      denom3 = 0.0_ki
      R = real(-k2+k4, ki_sam)
      denom4 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
   case(31)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      R = real(-k7-k8-k5-k6, ki_sam)
      denom1 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      denom2 = 0.0_ki
      denom3 = Q2
      denom4 = 0.0_ki
   case(310)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      denom1 = 0.0_ki
      denom2 = 0.0_ki
      denom3 = Q2
      denom4 = 0.0_ki
   case(321)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      R = real(-k7-k8-k5-k6, ki_sam)
      denom1 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      denom2 = 0.0_ki
      denom3 = 0.0_ki
      denom4 = 0.0_ki
   case(3210)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      denom1 = 0.0_ki
      denom2 = 0.0_ki
      denom3 = 0.0_ki
      denom4 = 0.0_ki
   case default
      R = real(-k7-k8-k5-k6, ki_sam)
      denom1 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      R = real(-k6-k5, ki_sam)
      denom2 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      denom3 = Q2
      R = real(-k2+k4, ki_sam)
      denom4 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
   end select

   num = (0.0_ki_sam, 0.0_ki_sam)
   !-------#[ Diagram 17:
   if(nonzero(0)) then
      num = num + Nfrat * numerator_d17(icut, Q, mu2)
   end if
   !-------#] Diagram 17:
   !-------#[ Diagram 18:
   if(nonzero(1)) then
      num = num + Nfrat * numerator_d18(icut, Q, mu2)
   end if
   !-------#] Diagram 18:
   !-------#[ Diagram 19:
   if(nonzero(2)) then
      num = num + Nfrat * numerator_d19(icut, Q, mu2)
   end if
   !-------#] Diagram 19:
   !-------#[ Diagram 20:
   if(nonzero(3)) then
      num = num + Nfrat * numerator_d20(icut, Q, mu2)
   end if
   !-------#] Diagram 20:
   !-------#[ Diagram 49:
   if(nonzero(4)) then
      num = num + Nfrat * numerator_d49(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 49:
   !-------#[ Diagram 50:
   if(nonzero(5)) then
      num = num + Nfrat * numerator_d50(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 50:
   !-------#[ Diagram 51:
   if(nonzero(6)) then
      num = num + Nfrat * numerator_d51(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 51:
   !-------#[ Diagram 52:
   if(nonzero(7)) then
      num = num + Nfrat * numerator_d52(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 52:
   !-------#[ Diagram 53:
   if(nonzero(8)) then
      num = num + Nfrat * numerator_d53(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 53:
   !-------#[ Diagram 54:
   if(nonzero(9)) then
      num = num + Nfrat * numerator_d54(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 54:
   !-------#[ Diagram 55:
   if(nonzero(10)) then
      num = num + Nfrat * numerator_d55(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 55:
   !-------#[ Diagram 56:
   if(nonzero(11)) then
      num = num + Nfrat * numerator_d56(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 56:
   !-------#[ Diagram 57:
   if(nonzero(12)) then
      num = num + Nfrat * numerator_d57(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 57:
   !-------#[ Diagram 58:
   if(nonzero(13)) then
      num = num + Nfrat * numerator_d58(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 58:
   !-------#[ Diagram 59:
   if(nonzero(14)) then
      num = num + Nfrat * numerator_d59(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 59:
   !-------#[ Diagram 60:
   if(nonzero(15)) then
      num = num + Nfrat * numerator_d60(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 60:
   !-------#[ Diagram 61:
   if(nonzero(16)) then
      num = num + Nfrat * numerator_d61(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 61:
   !-------#[ Diagram 62:
   if(nonzero(17)) then
      num = num + Nfrat * numerator_d62(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 62:
   !-------#[ Diagram 63:
   if(nonzero(18)) then
      num = num + Nfrat * numerator_d63(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 63:
   !-------#[ Diagram 64:
   if(nonzero(19)) then
      num = num + Nfrat * numerator_d64(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 64:
end function numeval_group1
!-----#] function numeval_group1:
!-----#[ function numeval_group2:
function     numeval_group2(icut, Q, mu2) result(num)
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P3B_uux_uux_model
   use P3B_uux_uux_d13h5l1, only: numerator_d13 => numerator_samurai
   use P3B_uux_uux_d14h5l1, only: numerator_d14 => numerator_samurai
   use P3B_uux_uux_d15h5l1, only: numerator_d15 => numerator_samurai
   use P3B_uux_uux_d16h5l1, only: numerator_d16 => numerator_samurai
   implicit none
   integer, intent(in) :: icut
   complex(ki_sam), dimension(4), intent(in) :: Q
   real(ki_sam), intent(in) :: mu2
   complex(ki_sam) :: num

   logical, dimension(0:4-1) :: nonzero
   real(ki_sam), dimension(0:3) :: R
   complex(ki_sam) :: Q2
   complex(ki_sam) ::denom1,denom2,denom3,denom4

   nonzero(:) = .true.
   Q2 = Q(4)*Q(4) - Q(1)*Q(1) - Q(2)*Q(2) - Q(3)*Q(3) - mu2

   select case(icut)
   case default
      R = real(-k7-k8-k5-k6, ki_sam)
      denom1 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      R = real(-k7-k8, ki_sam)
      denom2 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      denom3 = Q2
      R = real(-k2+k4, ki_sam)
      denom4 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
   end select

   num = (0.0_ki_sam, 0.0_ki_sam)
   !-------#[ Diagram 13:
   if(nonzero(0)) then
      num = num + Nfrat * numerator_d13(icut, Q, mu2)
   end if
   !-------#] Diagram 13:
   !-------#[ Diagram 14:
   if(nonzero(1)) then
      num = num + Nfrat * numerator_d14(icut, Q, mu2)
   end if
   !-------#] Diagram 14:
   !-------#[ Diagram 15:
   if(nonzero(2)) then
      num = num + Nfrat * numerator_d15(icut, Q, mu2)
   end if
   !-------#] Diagram 15:
   !-------#[ Diagram 16:
   if(nonzero(3)) then
      num = num + Nfrat * numerator_d16(icut, Q, mu2)
   end if
   !-------#] Diagram 16:
end function numeval_group2
!-----#] function numeval_group2:
!-----#[ function numeval_group3:
function     numeval_group3(icut, Q, mu2) result(num)
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P3B_uux_uux_model
   use P3B_uux_uux_d9h5l1, only: numerator_d9 => numerator_samurai
   use P3B_uux_uux_d10h5l1, only: numerator_d10 => numerator_samurai
   use P3B_uux_uux_d11h5l1, only: numerator_d11 => numerator_samurai
   use P3B_uux_uux_d12h5l1, only: numerator_d12 => numerator_samurai
   implicit none
   integer, intent(in) :: icut
   complex(ki_sam), dimension(4), intent(in) :: Q
   real(ki_sam), intent(in) :: mu2
   complex(ki_sam) :: num

   logical, dimension(0:4-1) :: nonzero
   real(ki_sam), dimension(0:3) :: R
   complex(ki_sam) :: Q2
   complex(ki_sam) ::denom1,denom2,denom3,denom4

   nonzero(:) = .true.
   Q2 = Q(4)*Q(4) - Q(1)*Q(1) - Q(2)*Q(2) - Q(3)*Q(3) - mu2

   select case(icut)
   case default
      R = real(k7+k8, ki_sam)
      denom1 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      denom2 = Q2
      R = real(-k3-k4, ki_sam)
      denom3 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      R = real(-k3-k6-k5-k4, ki_sam)
      denom4 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
   end select

   num = (0.0_ki_sam, 0.0_ki_sam)
   !-------#[ Diagram 9:
   if(nonzero(0)) then
      num = num - Nfrat * numerator_d9(icut, Q, mu2)
   end if
   !-------#] Diagram 9:
   !-------#[ Diagram 10:
   if(nonzero(1)) then
      num = num - Nfrat * numerator_d10(icut, Q, mu2)
   end if
   !-------#] Diagram 10:
   !-------#[ Diagram 11:
   if(nonzero(2)) then
      num = num - Nfrat * numerator_d11(icut, Q, mu2)
   end if
   !-------#] Diagram 11:
   !-------#[ Diagram 12:
   if(nonzero(3)) then
      num = num - Nfrat * numerator_d12(icut, Q, mu2)
   end if
   !-------#] Diagram 12:
end function numeval_group3
!-----#] function numeval_group3:
!-----#[ function numeval_group4:
function     numeval_group4(icut, Q, mu2) result(num)
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P3B_uux_uux_model
   use P3B_uux_uux_d1h5l1, only: numerator_d1 => numerator_samurai
   use P3B_uux_uux_d2h5l1, only: numerator_d2 => numerator_samurai
   use P3B_uux_uux_d3h5l1, only: numerator_d3 => numerator_samurai
   use P3B_uux_uux_d4h5l1, only: numerator_d4 => numerator_samurai
   implicit none
   integer, intent(in) :: icut
   complex(ki_sam), dimension(4), intent(in) :: Q
   real(ki_sam), intent(in) :: mu2
   complex(ki_sam) :: num

   logical, dimension(0:4-1) :: nonzero
   real(ki_sam), dimension(0:3) :: R
   complex(ki_sam) :: Q2
   complex(ki_sam) ::denom1,denom2,denom3,denom4

   nonzero(:) = .true.
   Q2 = Q(4)*Q(4) - Q(1)*Q(1) - Q(2)*Q(2) - Q(3)*Q(3) - mu2

   select case(icut)
   case default
      R = real(k7+k8+k5+k6, ki_sam)
      denom1 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      R = real(k7+k8, ki_sam)
      denom2 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      denom3 = Q2
      R = real(-k3-k4, ki_sam)
      denom4 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
   end select

   num = (0.0_ki_sam, 0.0_ki_sam)
   !-------#[ Diagram 1:
   if(nonzero(0)) then
      num = num - Nfrat * numerator_d1(icut, Q, mu2)
   end if
   !-------#] Diagram 1:
   !-------#[ Diagram 2:
   if(nonzero(1)) then
      num = num - Nfrat * numerator_d2(icut, Q, mu2)
   end if
   !-------#] Diagram 2:
   !-------#[ Diagram 3:
   if(nonzero(2)) then
      num = num - Nfrat * numerator_d3(icut, Q, mu2)
   end if
   !-------#] Diagram 3:
   !-------#[ Diagram 4:
   if(nonzero(3)) then
      num = num - Nfrat * numerator_d4(icut, Q, mu2)
   end if
   !-------#] Diagram 4:
end function numeval_group4
!-----#] function numeval_group4:
!-----#[ function numeval_group5:
function     numeval_group5(icut, Q, mu2) result(num)
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P3B_uux_uux_model
   use P3B_uux_uux_d5h5l1, only: numerator_d5 => numerator_samurai
   use P3B_uux_uux_d6h5l1, only: numerator_d6 => numerator_samurai
   use P3B_uux_uux_d7h5l1, only: numerator_d7 => numerator_samurai
   use P3B_uux_uux_d8h5l1, only: numerator_d8 => numerator_samurai
   use P3B_uux_uux_d33h5l1, only: numerator_d33 => numerator_samurai
   use P3B_uux_uux_d34h5l1, only: numerator_d34 => numerator_samurai
   use P3B_uux_uux_d35h5l1, only: numerator_d35 => numerator_samurai
   use P3B_uux_uux_d36h5l1, only: numerator_d36 => numerator_samurai
   use P3B_uux_uux_d37h5l1, only: numerator_d37 => numerator_samurai
   use P3B_uux_uux_d38h5l1, only: numerator_d38 => numerator_samurai
   use P3B_uux_uux_d39h5l1, only: numerator_d39 => numerator_samurai
   use P3B_uux_uux_d40h5l1, only: numerator_d40 => numerator_samurai
   use P3B_uux_uux_d41h5l1, only: numerator_d41 => numerator_samurai
   use P3B_uux_uux_d42h5l1, only: numerator_d42 => numerator_samurai
   use P3B_uux_uux_d43h5l1, only: numerator_d43 => numerator_samurai
   use P3B_uux_uux_d44h5l1, only: numerator_d44 => numerator_samurai
   use P3B_uux_uux_d45h5l1, only: numerator_d45 => numerator_samurai
   use P3B_uux_uux_d46h5l1, only: numerator_d46 => numerator_samurai
   use P3B_uux_uux_d47h5l1, only: numerator_d47 => numerator_samurai
   use P3B_uux_uux_d48h5l1, only: numerator_d48 => numerator_samurai
   implicit none
   integer, intent(in) :: icut
   complex(ki_sam), dimension(4), intent(in) :: Q
   real(ki_sam), intent(in) :: mu2
   complex(ki_sam) :: num

   logical, dimension(0:20-1) :: nonzero
   real(ki_sam), dimension(0:3) :: R
   complex(ki_sam) :: Q2
   complex(ki_sam) ::denom1,denom2,denom3,denom4

   nonzero(:) = .true.
   Q2 = Q(4)*Q(4) - Q(1)*Q(1) - Q(2)*Q(2) - Q(3)*Q(3) - mu2

   select case(icut)
   case(1)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      R = real(k7+k8+k5+k6, ki_sam)
      denom1 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      denom2 = 0.0_ki
      denom3 = Q2
      R = real(-k3-k4, ki_sam)
      denom4 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
   case(10)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      denom1 = 0.0_ki
      denom2 = 0.0_ki
      denom3 = Q2
      R = real(-k3-k4, ki_sam)
      denom4 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
   case(21)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      R = real(k7+k8+k5+k6, ki_sam)
      denom1 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      denom2 = 0.0_ki
      denom3 = 0.0_ki
      R = real(-k3-k4, ki_sam)
      denom4 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
   case(210)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      denom1 = 0.0_ki
      denom2 = 0.0_ki
      denom3 = 0.0_ki
      R = real(-k3-k4, ki_sam)
      denom4 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
   case(31)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      R = real(k7+k8+k5+k6, ki_sam)
      denom1 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      denom2 = 0.0_ki
      denom3 = Q2
      denom4 = 0.0_ki
   case(310)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      denom1 = 0.0_ki
      denom2 = 0.0_ki
      denom3 = Q2
      denom4 = 0.0_ki
   case(321)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      R = real(k7+k8+k5+k6, ki_sam)
      denom1 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      denom2 = 0.0_ki
      denom3 = 0.0_ki
      denom4 = 0.0_ki
   case(3210)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      denom1 = 0.0_ki
      denom2 = 0.0_ki
      denom3 = 0.0_ki
      denom4 = 0.0_ki
   case default
      R = real(k7+k8+k5+k6, ki_sam)
      denom1 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      R = real(k6+k5, ki_sam)
      denom2 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      denom3 = Q2
      R = real(-k3-k4, ki_sam)
      denom4 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
   end select

   num = (0.0_ki_sam, 0.0_ki_sam)
   !-------#[ Diagram 5:
   if(nonzero(0)) then
      num = num - Nfrat * numerator_d5(icut, Q, mu2)
   end if
   !-------#] Diagram 5:
   !-------#[ Diagram 6:
   if(nonzero(1)) then
      num = num - Nfrat * numerator_d6(icut, Q, mu2)
   end if
   !-------#] Diagram 6:
   !-------#[ Diagram 7:
   if(nonzero(2)) then
      num = num - Nfrat * numerator_d7(icut, Q, mu2)
   end if
   !-------#] Diagram 7:
   !-------#[ Diagram 8:
   if(nonzero(3)) then
      num = num - Nfrat * numerator_d8(icut, Q, mu2)
   end if
   !-------#] Diagram 8:
   !-------#[ Diagram 33:
   if(nonzero(4)) then
      num = num - Nfrat * numerator_d33(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 33:
   !-------#[ Diagram 34:
   if(nonzero(5)) then
      num = num - Nfrat * numerator_d34(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 34:
   !-------#[ Diagram 35:
   if(nonzero(6)) then
      num = num - Nfrat * numerator_d35(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 35:
   !-------#[ Diagram 36:
   if(nonzero(7)) then
      num = num - Nfrat * numerator_d36(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 36:
   !-------#[ Diagram 37:
   if(nonzero(8)) then
      num = num - Nfrat * numerator_d37(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 37:
   !-------#[ Diagram 38:
   if(nonzero(9)) then
      num = num - Nfrat * numerator_d38(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 38:
   !-------#[ Diagram 39:
   if(nonzero(10)) then
      num = num - Nfrat * numerator_d39(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 39:
   !-------#[ Diagram 40:
   if(nonzero(11)) then
      num = num - Nfrat * numerator_d40(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 40:
   !-------#[ Diagram 41:
   if(nonzero(12)) then
      num = num - Nfrat * numerator_d41(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 41:
   !-------#[ Diagram 42:
   if(nonzero(13)) then
      num = num - Nfrat * numerator_d42(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 42:
   !-------#[ Diagram 43:
   if(nonzero(14)) then
      num = num - Nfrat * numerator_d43(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 43:
   !-------#[ Diagram 44:
   if(nonzero(15)) then
      num = num - Nfrat * numerator_d44(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 44:
   !-------#[ Diagram 45:
   if(nonzero(16)) then
      num = num - Nfrat * numerator_d45(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 45:
   !-------#[ Diagram 46:
   if(nonzero(17)) then
      num = num - Nfrat * numerator_d46(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 46:
   !-------#[ Diagram 47:
   if(nonzero(18)) then
      num = num - Nfrat * numerator_d47(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 47:
   !-------#[ Diagram 48:
   if(nonzero(19)) then
      num = num - Nfrat * numerator_d48(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 48:
end function numeval_group5
!-----#] function numeval_group5:
!---#] grouped numerators for samurai:
!---#[ reduce groups with samurai:
!-----#[ subroutine reduce_group0:
subroutine     reduce_group0(scale2,tot,totr,ok)
   use msamurai, only: samurai
   use options, only: samurai_out => iout
   use P3B_uux_uux_config, only: samurai_group_numerators, &
      samurai_verbosity, samurai_istop, debug_nlo_diagrams, logfile
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P3B_uux_uux_model
   use P3B_uux_uux_d21h5l1, only: numerator_diagram21 => numerator_samurai
   use P3B_uux_uux_d22h5l1, only: numerator_diagram22 => numerator_samurai
   use P3B_uux_uux_d23h5l1, only: numerator_diagram23 => numerator_samurai
   use P3B_uux_uux_d24h5l1, only: numerator_diagram24 => numerator_samurai
   use P3B_uux_uux_globalsl1, only: epspow
   implicit none
   real(ki_sam), intent(in) :: scale2
   complex(ki_sam), dimension(-2:0), intent(out) :: tot
   complex(ki_sam), intent(out) :: totr
   logical, intent(out) :: ok

   complex(ki_sam), dimension(-2:0) :: acc
   complex(ki_sam) :: accr
   logical :: acc_ok

   integer, parameter :: effective_group_rank = 4

   real(ki), dimension(4) :: msq
   real(ki), dimension(4,4) :: Vi
   msq(1) = 0.0_ki
   Vi(1,:) = -k2((/2,3,4,1/))+k7((/2,3,4,1/))+k8((/2,3,4,1/))+k4((/2,3,4,1/))
   msq(2) = 0.0_ki
   Vi(2,:) = -k2((/2,3,4,1/))+k4((/2,3,4,1/))
   msq(3) = 0.0_ki
   Vi(3,:) = 0
   msq(4) = 0.0_ki
   Vi(4,:) = -k6((/2,3,4,1/))-k5((/2,3,4,1/))

   if(samurai_group_numerators) then
      !------#[ reduce numerator numeval_group0:
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numeval_group0"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numeval_group0, tot, totr, Vi, msq, 4, &
         & effective_group_rank, samurai_istop, scale2, ok)
      !------#] reduce numerator numeval_group0:
   else
      !------#[ sum over reduction of single diagrams:
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='21'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram21"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram21, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = + Nfrat * acc
      totr = + Nfrat * accr
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='22'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram22"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram22, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='23'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram23"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram23, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='24'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram24"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram24, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      !------#] sum over reduction of single diagrams:
   end if
end subroutine reduce_group0
!-----#] subroutine reduce_group0:
!-----#[ subroutine reduce_group1:
subroutine     reduce_group1(scale2,tot,totr,ok)
   use msamurai, only: samurai
   use options, only: samurai_out => iout
   use P3B_uux_uux_config, only: samurai_group_numerators, &
      samurai_verbosity, samurai_istop, debug_nlo_diagrams, logfile
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P3B_uux_uux_model
   use P3B_uux_uux_d17h5l1, only: numerator_diagram17 => numerator_samurai
   use P3B_uux_uux_d18h5l1, only: numerator_diagram18 => numerator_samurai
   use P3B_uux_uux_d19h5l1, only: numerator_diagram19 => numerator_samurai
   use P3B_uux_uux_d20h5l1, only: numerator_diagram20 => numerator_samurai
   use P3B_uux_uux_d49h5l1, only: numerator_diagram49 => numerator_samurai
   use P3B_uux_uux_d50h5l1, only: numerator_diagram50 => numerator_samurai
   use P3B_uux_uux_d51h5l1, only: numerator_diagram51 => numerator_samurai
   use P3B_uux_uux_d52h5l1, only: numerator_diagram52 => numerator_samurai
   use P3B_uux_uux_d53h5l1, only: numerator_diagram53 => numerator_samurai
   use P3B_uux_uux_d54h5l1, only: numerator_diagram54 => numerator_samurai
   use P3B_uux_uux_d55h5l1, only: numerator_diagram55 => numerator_samurai
   use P3B_uux_uux_d56h5l1, only: numerator_diagram56 => numerator_samurai
   use P3B_uux_uux_d57h5l1, only: numerator_diagram57 => numerator_samurai
   use P3B_uux_uux_d58h5l1, only: numerator_diagram58 => numerator_samurai
   use P3B_uux_uux_d59h5l1, only: numerator_diagram59 => numerator_samurai
   use P3B_uux_uux_d60h5l1, only: numerator_diagram60 => numerator_samurai
   use P3B_uux_uux_d61h5l1, only: numerator_diagram61 => numerator_samurai
   use P3B_uux_uux_d62h5l1, only: numerator_diagram62 => numerator_samurai
   use P3B_uux_uux_d63h5l1, only: numerator_diagram63 => numerator_samurai
   use P3B_uux_uux_d64h5l1, only: numerator_diagram64 => numerator_samurai
   use P3B_uux_uux_globalsl1, only: epspow
   implicit none
   real(ki_sam), intent(in) :: scale2
   complex(ki_sam), dimension(-2:0), intent(out) :: tot
   complex(ki_sam), intent(out) :: totr
   logical, intent(out) :: ok

   complex(ki_sam), dimension(-2:0) :: acc
   complex(ki_sam) :: accr
   logical :: acc_ok

   integer, parameter :: effective_group_rank = 4

   real(ki), dimension(4) :: msq
   real(ki), dimension(4,4) :: Vi
   msq(1) = 0.0_ki
   Vi(1,:) = -k7((/2,3,4,1/))-k8((/2,3,4,1/))-k5((/2,3,4,1/))-k6((/2,3,4,1/))
   msq(2) = 0.0_ki
   Vi(2,:) = -k6((/2,3,4,1/))-k5((/2,3,4,1/))
   msq(3) = 0.0_ki
   Vi(3,:) = 0
   msq(4) = 0.0_ki
   Vi(4,:) = -k2((/2,3,4,1/))+k4((/2,3,4,1/))

   if(samurai_group_numerators) then
      !------#[ reduce numerator numeval_group1:
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numeval_group1"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numeval_group1, tot, totr, Vi, msq, 4, &
         & effective_group_rank, samurai_istop, scale2, ok)
      !------#] reduce numerator numeval_group1:
   else
      !------#[ sum over reduction of single diagrams:
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='17'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram17"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram17, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = + Nfrat * acc
      totr = + Nfrat * accr
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='18'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram18"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram18, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='19'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram19"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram19, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='20'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram20"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram20, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='49'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram49"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram49, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='50'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram50"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram50, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='51'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram51"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram51, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='52'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram52"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram52, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='53'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram53"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram53, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='54'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram54"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram54, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='55'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram55"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram55, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='56'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram56"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram56, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='57'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram57"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram57, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='58'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram58"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram58, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='59'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram59"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram59, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='60'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram60"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram60, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='61'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram61"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram61, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='62'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram62"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram62, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='63'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram63"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram63, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='64'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram64"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram64, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      !------#] sum over reduction of single diagrams:
   end if
end subroutine reduce_group1
!-----#] subroutine reduce_group1:
!-----#[ subroutine reduce_group2:
subroutine     reduce_group2(scale2,tot,totr,ok)
   use msamurai, only: samurai
   use options, only: samurai_out => iout
   use P3B_uux_uux_config, only: samurai_group_numerators, &
      samurai_verbosity, samurai_istop, debug_nlo_diagrams, logfile
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P3B_uux_uux_model
   use P3B_uux_uux_d13h5l1, only: numerator_diagram13 => numerator_samurai
   use P3B_uux_uux_d14h5l1, only: numerator_diagram14 => numerator_samurai
   use P3B_uux_uux_d15h5l1, only: numerator_diagram15 => numerator_samurai
   use P3B_uux_uux_d16h5l1, only: numerator_diagram16 => numerator_samurai
   use P3B_uux_uux_globalsl1, only: epspow
   implicit none
   real(ki_sam), intent(in) :: scale2
   complex(ki_sam), dimension(-2:0), intent(out) :: tot
   complex(ki_sam), intent(out) :: totr
   logical, intent(out) :: ok

   complex(ki_sam), dimension(-2:0) :: acc
   complex(ki_sam) :: accr
   logical :: acc_ok

   integer, parameter :: effective_group_rank = 4

   real(ki), dimension(4) :: msq
   real(ki), dimension(4,4) :: Vi
   msq(1) = 0.0_ki
   Vi(1,:) = -k7((/2,3,4,1/))-k8((/2,3,4,1/))-k5((/2,3,4,1/))-k6((/2,3,4,1/))
   msq(2) = 0.0_ki
   Vi(2,:) = -k7((/2,3,4,1/))-k8((/2,3,4,1/))
   msq(3) = 0.0_ki
   Vi(3,:) = 0
   msq(4) = 0.0_ki
   Vi(4,:) = -k2((/2,3,4,1/))+k4((/2,3,4,1/))

   if(samurai_group_numerators) then
      !------#[ reduce numerator numeval_group2:
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numeval_group2"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numeval_group2, tot, totr, Vi, msq, 4, &
         & effective_group_rank, samurai_istop, scale2, ok)
      !------#] reduce numerator numeval_group2:
   else
      !------#[ sum over reduction of single diagrams:
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='13'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram13"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram13, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = + Nfrat * acc
      totr = + Nfrat * accr
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='14'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram14"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram14, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='15'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram15"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram15, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='16'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram16"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram16, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot + Nfrat * acc
      totr = totr + Nfrat * accr
      ok = ok .and. acc_ok
      !------#] sum over reduction of single diagrams:
   end if
end subroutine reduce_group2
!-----#] subroutine reduce_group2:
!-----#[ subroutine reduce_group3:
subroutine     reduce_group3(scale2,tot,totr,ok)
   use msamurai, only: samurai
   use options, only: samurai_out => iout
   use P3B_uux_uux_config, only: samurai_group_numerators, &
      samurai_verbosity, samurai_istop, debug_nlo_diagrams, logfile
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P3B_uux_uux_model
   use P3B_uux_uux_d9h5l1, only: numerator_diagram9 => numerator_samurai
   use P3B_uux_uux_d10h5l1, only: numerator_diagram10 => numerator_samurai
   use P3B_uux_uux_d11h5l1, only: numerator_diagram11 => numerator_samurai
   use P3B_uux_uux_d12h5l1, only: numerator_diagram12 => numerator_samurai
   use P3B_uux_uux_globalsl1, only: epspow
   implicit none
   real(ki_sam), intent(in) :: scale2
   complex(ki_sam), dimension(-2:0), intent(out) :: tot
   complex(ki_sam), intent(out) :: totr
   logical, intent(out) :: ok

   complex(ki_sam), dimension(-2:0) :: acc
   complex(ki_sam) :: accr
   logical :: acc_ok

   integer, parameter :: effective_group_rank = 4

   real(ki), dimension(4) :: msq
   real(ki), dimension(4,4) :: Vi
   msq(1) = 0.0_ki
   Vi(1,:) = k7((/2,3,4,1/))+k8((/2,3,4,1/))
   msq(2) = 0.0_ki
   Vi(2,:) = 0
   msq(3) = 0.0_ki
   Vi(3,:) = -k3((/2,3,4,1/))-k4((/2,3,4,1/))
   msq(4) = 0.0_ki
   Vi(4,:) = -k3((/2,3,4,1/))-k6((/2,3,4,1/))-k5((/2,3,4,1/))-k4((/2,3,4,1/))

   if(samurai_group_numerators) then
      !------#[ reduce numerator numeval_group3:
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numeval_group3"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numeval_group3, tot, totr, Vi, msq, 4, &
         & effective_group_rank, samurai_istop, scale2, ok)
      !------#] reduce numerator numeval_group3:
   else
      !------#[ sum over reduction of single diagrams:
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='9'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram9"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram9, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = - Nfrat * acc
      totr = - Nfrat * accr
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='10'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram10"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram10, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='11'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram11"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram11, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='12'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram12"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram12, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      !------#] sum over reduction of single diagrams:
   end if
end subroutine reduce_group3
!-----#] subroutine reduce_group3:
!-----#[ subroutine reduce_group4:
subroutine     reduce_group4(scale2,tot,totr,ok)
   use msamurai, only: samurai
   use options, only: samurai_out => iout
   use P3B_uux_uux_config, only: samurai_group_numerators, &
      samurai_verbosity, samurai_istop, debug_nlo_diagrams, logfile
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P3B_uux_uux_model
   use P3B_uux_uux_d1h5l1, only: numerator_diagram1 => numerator_samurai
   use P3B_uux_uux_d2h5l1, only: numerator_diagram2 => numerator_samurai
   use P3B_uux_uux_d3h5l1, only: numerator_diagram3 => numerator_samurai
   use P3B_uux_uux_d4h5l1, only: numerator_diagram4 => numerator_samurai
   use P3B_uux_uux_globalsl1, only: epspow
   implicit none
   real(ki_sam), intent(in) :: scale2
   complex(ki_sam), dimension(-2:0), intent(out) :: tot
   complex(ki_sam), intent(out) :: totr
   logical, intent(out) :: ok

   complex(ki_sam), dimension(-2:0) :: acc
   complex(ki_sam) :: accr
   logical :: acc_ok

   integer, parameter :: effective_group_rank = 4

   real(ki), dimension(4) :: msq
   real(ki), dimension(4,4) :: Vi
   msq(1) = 0.0_ki
   Vi(1,:) = k7((/2,3,4,1/))+k8((/2,3,4,1/))+k5((/2,3,4,1/))+k6((/2,3,4,1/))
   msq(2) = 0.0_ki
   Vi(2,:) = k7((/2,3,4,1/))+k8((/2,3,4,1/))
   msq(3) = 0.0_ki
   Vi(3,:) = 0
   msq(4) = 0.0_ki
   Vi(4,:) = -k3((/2,3,4,1/))-k4((/2,3,4,1/))

   if(samurai_group_numerators) then
      !------#[ reduce numerator numeval_group4:
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numeval_group4"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numeval_group4, tot, totr, Vi, msq, 4, &
         & effective_group_rank, samurai_istop, scale2, ok)
      !------#] reduce numerator numeval_group4:
   else
      !------#[ sum over reduction of single diagrams:
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='1'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram1"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram1, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = - Nfrat * acc
      totr = - Nfrat * accr
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='2'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram2"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram2, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='3'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram3"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram3, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='4'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram4"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram4, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      !------#] sum over reduction of single diagrams:
   end if
end subroutine reduce_group4
!-----#] subroutine reduce_group4:
!-----#[ subroutine reduce_group5:
subroutine     reduce_group5(scale2,tot,totr,ok)
   use msamurai, only: samurai
   use options, only: samurai_out => iout
   use P3B_uux_uux_config, only: samurai_group_numerators, &
      samurai_verbosity, samurai_istop, debug_nlo_diagrams, logfile
   use P3B_uux_uux_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P3B_uux_uux_model
   use P3B_uux_uux_d5h5l1, only: numerator_diagram5 => numerator_samurai
   use P3B_uux_uux_d6h5l1, only: numerator_diagram6 => numerator_samurai
   use P3B_uux_uux_d7h5l1, only: numerator_diagram7 => numerator_samurai
   use P3B_uux_uux_d8h5l1, only: numerator_diagram8 => numerator_samurai
   use P3B_uux_uux_d33h5l1, only: numerator_diagram33 => numerator_samurai
   use P3B_uux_uux_d34h5l1, only: numerator_diagram34 => numerator_samurai
   use P3B_uux_uux_d35h5l1, only: numerator_diagram35 => numerator_samurai
   use P3B_uux_uux_d36h5l1, only: numerator_diagram36 => numerator_samurai
   use P3B_uux_uux_d37h5l1, only: numerator_diagram37 => numerator_samurai
   use P3B_uux_uux_d38h5l1, only: numerator_diagram38 => numerator_samurai
   use P3B_uux_uux_d39h5l1, only: numerator_diagram39 => numerator_samurai
   use P3B_uux_uux_d40h5l1, only: numerator_diagram40 => numerator_samurai
   use P3B_uux_uux_d41h5l1, only: numerator_diagram41 => numerator_samurai
   use P3B_uux_uux_d42h5l1, only: numerator_diagram42 => numerator_samurai
   use P3B_uux_uux_d43h5l1, only: numerator_diagram43 => numerator_samurai
   use P3B_uux_uux_d44h5l1, only: numerator_diagram44 => numerator_samurai
   use P3B_uux_uux_d45h5l1, only: numerator_diagram45 => numerator_samurai
   use P3B_uux_uux_d46h5l1, only: numerator_diagram46 => numerator_samurai
   use P3B_uux_uux_d47h5l1, only: numerator_diagram47 => numerator_samurai
   use P3B_uux_uux_d48h5l1, only: numerator_diagram48 => numerator_samurai
   use P3B_uux_uux_globalsl1, only: epspow
   implicit none
   real(ki_sam), intent(in) :: scale2
   complex(ki_sam), dimension(-2:0), intent(out) :: tot
   complex(ki_sam), intent(out) :: totr
   logical, intent(out) :: ok

   complex(ki_sam), dimension(-2:0) :: acc
   complex(ki_sam) :: accr
   logical :: acc_ok

   integer, parameter :: effective_group_rank = 4

   real(ki), dimension(4) :: msq
   real(ki), dimension(4,4) :: Vi
   msq(1) = 0.0_ki
   Vi(1,:) = k7((/2,3,4,1/))+k8((/2,3,4,1/))+k5((/2,3,4,1/))+k6((/2,3,4,1/))
   msq(2) = 0.0_ki
   Vi(2,:) = k6((/2,3,4,1/))+k5((/2,3,4,1/))
   msq(3) = 0.0_ki
   Vi(3,:) = 0
   msq(4) = 0.0_ki
   Vi(4,:) = -k3((/2,3,4,1/))-k4((/2,3,4,1/))

   if(samurai_group_numerators) then
      !------#[ reduce numerator numeval_group5:
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numeval_group5"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numeval_group5, tot, totr, Vi, msq, 4, &
         & effective_group_rank, samurai_istop, scale2, ok)
      !------#] reduce numerator numeval_group5:
   else
      !------#[ sum over reduction of single diagrams:
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='5'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram5"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram5, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = - Nfrat * acc
      totr = - Nfrat * accr
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='6'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram6"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram6, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='7'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram7"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram7, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='8'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram8"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram8, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='33'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram33"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram33, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='34'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram34"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram34, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='35'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram35"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram35, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='36'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram36"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram36, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='37'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram37"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram37, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='38'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram38"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram38, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='39'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram39"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram39, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='40'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram40"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram40, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='41'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram41"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram41, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='42'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram42"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram42, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='43'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram43"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram43, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='44'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram44"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram44, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='45'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram45"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram45, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='46'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram46"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram46, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='47'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram47"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram47, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='48'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram48"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram48, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      !------#] sum over reduction of single diagrams:
   end if
end subroutine reduce_group5
!-----#] subroutine reduce_group5:
!---#] reduce groups with samurai:
end module P3B_uux_uux_samuraih5
