# vim: ts=3:sw=3:expandtab:syntax=python
#
# This file has been generated automatically.

from golem.topolopy.objects import Diagram, Leg, Propagator, Vertex

generation_info = {
    'program': "qgraf-3.1.2",
    'model': "Standard Model",
    'qgraf.dat': [
       """output = 'topotree.py';""",
       """style = 'topolopy.sty';""",
       """model = 'model';""",
       """in = U[k1], Ubar[k2];""",
       """out = U[k3], Ubar[k4], ne[k5], ep[k6], mum[k7], nmubar[k8];""",
       """loops=0;""",
       """loop_momentum=p;""",
       """options=onshell, notadpole, nosnail;""",
       """true=iprop[chi,phim,phip,H,0,0];""",
       """true=bridge[Wp,Wm,2,200];""",
       """true=bridge[ep,em,mum,mup,ne,nmu,nebar,nmubar,0,0];""",
       """true=vsum[QCD,2,2];"""]
}

diagrams = {}

#---#[ diagrams[1]:
diagrams[1] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "A"),
   Vertex(6, 1, "Wp", "Wm", "A"))
#---#] diagrams[1]:
#---#[ diagrams[2]:
diagrams[2] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 5, 3, "-k1-k2+k3+k4", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "Z"),
   Vertex(6, 1, "Wp", "Wm", "Z"))
#---#] diagrams[2]:
#---#[ diagrams[3]:
diagrams[3] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "A"),
   Vertex(6, 1, "Wp", "Wm", "A"))
#---#] diagrams[3]:
#---#[ diagrams[4]:
diagrams[4] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 5, 3, "-k1-k2+k3+k4", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "Z"),
   Vertex(6, 1, "Wp", "Wm", "Z"))
#---#] diagrams[4]:
#---#[ diagrams[5]:
diagrams[5] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "A"),
   Vertex(6, 1, "Wp", "Wm", "A"))
#---#] diagrams[5]:
#---#[ diagrams[6]:
diagrams[6] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 5, 3, "-k1-k2+k3+k4", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "Z"),
   Vertex(6, 1, "Wp", "Wm", "Z"))
#---#] diagrams[6]:
#---#[ diagrams[7]:
diagrams[7] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "A"),
   Vertex(6, 1, "Wp", "Wm", "A"))
#---#] diagrams[7]:
#---#[ diagrams[8]:
diagrams[8] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 5, 3, "-k1-k2+k3+k4", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "Z"),
   Vertex(6, 1, "Wp", "Wm", "Z"))
#---#] diagrams[8]:
#---#[ diagrams[9]:
diagrams[9] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "A"),
   Vertex(6, 1, "Wp", "Wm", "A"))
#---#] diagrams[9]:
#---#[ diagrams[10]:
diagrams[10] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 5, 3, "-k1-k2+k3+k4", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "Z"),
   Vertex(6, 1, "Wp", "Wm", "Z"))
#---#] diagrams[10]:
#---#[ diagrams[11]:
diagrams[11] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "A"),
   Vertex(6, 1, "Wp", "Wm", "A"))
#---#] diagrams[11]:
#---#[ diagrams[12]:
diagrams[12] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 5, 3, "-k1-k2+k3+k4", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "Z"),
   Vertex(6, 1, "Wp", "Wm", "Z"))
#---#] diagrams[12]:
#---#[ diagrams[13]:
diagrams[13] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "A"),
   Vertex(6, 1, "Wp", "Wm", "A"))
#---#] diagrams[13]:
#---#[ diagrams[14]:
diagrams[14] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 5, 3, "-k1-k2+k3+k4", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "Z"),
   Vertex(6, 1, "Wp", "Wm", "Z"))
#---#] diagrams[14]:
#---#[ diagrams[15]:
diagrams[15] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "A"),
   Vertex(6, 1, "Wp", "Wm", "A"))
#---#] diagrams[15]:
#---#[ diagrams[16]:
diagrams[16] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 5, 3, "-k1-k2+k3+k4", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "Z"),
   Vertex(6, 1, "Wp", "Wm", "Z"))
#---#] diagrams[16]:
#---#[ diagrams[17]:
diagrams[17] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 5, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 6, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 5, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Dbar", "U", "Wm"),
   Vertex(6, 0, "Ubar", "D", "Wp"))
#---#] diagrams[17]:
#---#[ diagrams[18]:
diagrams[18] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 6, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "U", "Wm"))
#---#] diagrams[18]:
#---#[ diagrams[19]:
diagrams[19] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 5, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 6, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 5, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Dbar", "U", "Wm"),
   Vertex(6, 0, "Ubar", "D", "Wp"))
#---#] diagrams[19]:
#---#[ diagrams[20]:
diagrams[20] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 6, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "U", "Wm"))
#---#] diagrams[20]:
#---#[ diagrams[21]:
diagrams[21] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 5, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 6, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 5, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Dbar", "U", "Wm"),
   Vertex(6, 0, "Ubar", "D", "Wp"))
#---#] diagrams[21]:
#---#[ diagrams[22]:
diagrams[22] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 6, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "U", "Wm"))
#---#] diagrams[22]:
#---#[ diagrams[23]:
diagrams[23] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 5, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 6, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 5, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Dbar", "U", "Wm"),
   Vertex(6, 0, "Ubar", "D", "Wp"))
#---#] diagrams[23]:
#---#[ diagrams[24]:
diagrams[24] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 6, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "U", "Wm"))
#---#] diagrams[24]:
#---#[ diagrams[25]:
diagrams[25] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 6, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "D", "g"))
#---#] diagrams[25]:
#---#[ diagrams[26]:
diagrams[26] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 6, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "D", "g"))
#---#] diagrams[26]:
#---#[ diagrams[27]:
diagrams[27] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 6, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "D", "g"))
#---#] diagrams[27]:
#---#[ diagrams[28]:
diagrams[28] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 6, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "D", "g"))
#---#] diagrams[28]:
#-------------------------------------------------------------------
