# vim: ts=3:sw=3:expandtab:syntax=python
#
# This file has been generated automatically.

from golem.topolopy.objects import Diagram, Leg, Propagator, Vertex

generation_info = {
    'program': "qgraf-3.1.2",
    'model': "Standard Model",
    'qgraf.dat': [
       """output = 'topovirt.py';""",
       """style = 'topolopy.sty';""",
       """model = 'model';""",
       """in = U[k1], Ubar[k2];""",
       """out = U[k3], Ubar[k4], ne[k5], ep[k6], mum[k7], nmubar[k8];""",
       """loops=1;""",
       """loop_momentum=p;""",
       """options=onshell, notadpole, nosnail;""",
       """true=iprop[chi,phim,phip,H,0,0];""",
       """true=bridge[Wp,Wm,2,200];""",
       """true=bridge[ep,em,mum,mup,ne,nmu,nebar,nmubar,0,0];""",
       """true=chord[T,B,0,0];""",
       """true=vsum[QCD,4,4];"""]
}

diagrams = {}

#---#[ diagrams[1]:
diagrams[1] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 8, 3, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 7, 2, "-p1+k1+k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "-p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1+k1+k2-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[1]:
#---#[ diagrams[2]:
diagrams[2] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 8, 3, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "D", 5, 1, 6, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 7, 1, 5, 2, "p1-k1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "p1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "p1-k1-k2+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[2]:
#---#[ diagrams[3]:
diagrams[3] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 8, 3, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "C", 6, 1, 5, 2, "-p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(6, "C", 5, 1, 7, 2, "-p1+k1+k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "-p1+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "-p1+k1+k2-k5-k6", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 0, "Cbar", "C", "g"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Sbar", "C", "Wm"),
   Vertex(8, 0, "Cbar", "S", "Wp"))
#---#] diagrams[3]:
#---#[ diagrams[4]:
diagrams[4] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 8, 3, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "S", 5, 1, 6, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "S", 7, 1, 5, 2, "p1-k1-k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "p1-k3-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "C", 8, 1, 7, 2, "p1-k1-k2+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Sbar", "C", "Wm"),
   Vertex(8, 0, "Cbar", "S", "Wp"))
#---#] diagrams[4]:
#---#[ diagrams[5]:
diagrams[5] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 4, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 4, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 4, 3, 8, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "p1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "p1-k1-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "nebar", "em", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "U", "Wm"))
#---#] diagrams[5]:
#---#[ diagrams[6]:
diagrams[6] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 4, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 4, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 4, 3, 8, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "D", 6, 1, 5, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 5, 1, 7, 2, "-p1+k1+k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 6, 2, "-p1+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "-p1+k1+k2-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "nebar", "em", "Wp"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "U", "Wm"))
#---#] diagrams[6]:
#---#[ diagrams[7]:
diagrams[7] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 4, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 4, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 4, 3, 8, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "C", 5, 1, 6, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(6, "C", 7, 1, 5, 2, "p1-k1-k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 6, 1, 8, 2, "p1-k3-k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "p1-k1-k2+k7+k8", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "nebar", "em", "Wp"),
   Vertex(5, 0, "Cbar", "C", "g"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "C", "Wm"))
#---#] diagrams[7]:
#---#[ diagrams[8]:
diagrams[8] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 4, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 4, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 4, 3, 8, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "S", 6, 1, 5, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "S", 5, 1, 7, 2, "-p1+k1+k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 8, 1, 6, 2, "-p1+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "-p1+k1+k2-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "nebar", "em", "Wp"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "C", "Wm"))
#---#] diagrams[8]:
#---#[ diagrams[9]:
diagrams[9] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 8, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "p1-k1-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[9]:
#---#[ diagrams[10]:
diagrams[10] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 8, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "D", 6, 1, 5, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 5, 1, 7, 2, "-p1+k1+k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "-p1+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "-p1+k1+k2-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[10]:
#---#[ diagrams[11]:
diagrams[11] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 8, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "C", 5, 1, 6, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(6, "C", 7, 1, 5, 2, "p1-k1-k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "p1-k5-k6", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "p1-k1-k2+k7+k8", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Cbar", "C", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[11]:
#---#[ diagrams[12]:
diagrams[12] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 8, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "S", 6, 1, 5, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "S", 5, 1, 7, 2, "-p1+k1+k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "-p1+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "-p1+k1+k2-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[12]:
#---#[ diagrams[13]:
diagrams[13] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 8, 3, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 7, 2, "-p1+k1-k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "-p1-k2+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1+k1-k3-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[13]:
#---#[ diagrams[14]:
diagrams[14] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 8, 3, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "D", 5, 1, 6, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 7, 1, 5, 2, "p1-k1+k3", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "p1+k2-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "p1-k1+k3+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[14]:
#---#[ diagrams[15]:
diagrams[15] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 8, 3, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "C", 6, 1, 5, 2, "-p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(6, "C", 5, 1, 7, 2, "-p1+k1-k3", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "-p1-k2+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "-p1+k1-k3-k5-k6", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 0, "Cbar", "C", "g"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Sbar", "C", "Wm"),
   Vertex(8, 0, "Cbar", "S", "Wp"))
#---#] diagrams[15]:
#---#[ diagrams[16]:
diagrams[16] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 8, 3, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "S", 5, 1, 6, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "S", 7, 1, 5, 2, "p1-k1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "p1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "C", 8, 1, 7, 2, "p1-k1+k3+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Sbar", "C", "Wm"),
   Vertex(8, 0, "Cbar", "S", "Wp"))
#---#] diagrams[16]:
#---#[ diagrams[17]:
diagrams[17] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 4, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 4, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 4, 3, 8, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "p1-k1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "p1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "p1-k1+k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "nebar", "em", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "U", "Wm"))
#---#] diagrams[17]:
#---#[ diagrams[18]:
diagrams[18] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 4, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 4, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 4, 3, 8, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "D", 6, 1, 5, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 5, 1, 7, 2, "-p1+k1-k3", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 6, 2, "-p1-k2+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "-p1+k1-k3-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "nebar", "em", "Wp"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "U", "Wm"))
#---#] diagrams[18]:
#---#[ diagrams[19]:
diagrams[19] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 4, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 4, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 4, 3, 8, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "C", 5, 1, 6, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(6, "C", 7, 1, 5, 2, "p1-k1+k3", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 6, 1, 8, 2, "p1+k2-k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "p1-k1+k3+k7+k8", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "nebar", "em", "Wp"),
   Vertex(5, 0, "Cbar", "C", "g"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "C", "Wm"))
#---#] diagrams[19]:
#---#[ diagrams[20]:
diagrams[20] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 4, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 4, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 4, 3, 8, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "S", 6, 1, 5, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "S", 5, 1, 7, 2, "-p1+k1-k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 8, 1, 6, 2, "-p1-k2+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "-p1+k1-k3-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "nebar", "em", "Wp"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "C", "Wm"))
#---#] diagrams[20]:
#---#[ diagrams[21]:
diagrams[21] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 8, 3, 4, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "p1-k1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "p1-k1+k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[21]:
#---#[ diagrams[22]:
diagrams[22] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 8, 3, 4, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "D", 6, 1, 5, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 5, 1, 7, 2, "-p1+k1-k3", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "-p1+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "-p1+k1-k3-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Dbar", "D", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[22]:
#---#[ diagrams[23]:
diagrams[23] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 8, 3, 4, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "C", 5, 1, 6, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(6, "C", 7, 1, 5, 2, "p1-k1+k3", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "p1-k5-k6", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "p1-k1+k3+k7+k8", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Cbar", "C", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[23]:
#---#[ diagrams[24]:
diagrams[24] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 8, 3, 4, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "S", 6, 1, 5, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(6, "S", 5, 1, 7, 2, "-p1+k1-k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "-p1+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "-p1+k1-k3-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Sbar", "S", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[24]:
#---#[ diagrams[25]:
diagrams[25] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 7, 3, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[25]:
#---#[ diagrams[26]:
diagrams[26] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 7, 3, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 6, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[26]:
#---#[ diagrams[27]:
diagrams[27] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 7, 3, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "C", 7, 1, 6, 2, "-p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "-p1-k5-k6", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1+k7+k8", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[27]:
#---#[ diagrams[28]:
diagrams[28] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 7, 3, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 6, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "p1+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[28]:
#---#[ diagrams[29]:
diagrams[29] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 7, 3, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[29]:
#---#[ diagrams[30]:
diagrams[30] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 7, 3, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 6, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[30]:
#---#[ diagrams[31]:
diagrams[31] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 7, 3, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "C", 7, 1, 6, 2, "-p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "-p1-k5-k6", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1+k7+k8", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[31]:
#---#[ diagrams[32]:
diagrams[32] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 7, 3, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 6, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "p1+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[32]:
#---#[ diagrams[33]:
diagrams[33] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "A", 8, 3, 5, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "-p1+k1+k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "A"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[33]:
#---#[ diagrams[34]:
diagrams[34] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "A", 8, 3, 5, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "U", 6, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "A"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[34]:
#---#[ diagrams[35]:
diagrams[35] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "A", 8, 3, 5, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "D", 7, 1, 6, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1+k1+k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "A"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[35]:
#---#[ diagrams[36]:
diagrams[36] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "A", 8, 3, 5, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "D", 6, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 6, 2, "p1-k1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "A"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[36]:
#---#[ diagrams[37]:
diagrams[37] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "A", 8, 3, 5, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "C", 7, 1, 6, 2, "-p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 6, 1, 8, 2, "-p1+k1+k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 8, 1, 7, 2, "-p1+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "A"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "A"))
#---#] diagrams[37]:
#---#[ diagrams[38]:
diagrams[38] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "A", 8, 3, 5, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "C", 6, 1, 7, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "p1-k1-k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k3-k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "A"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "A"))
#---#] diagrams[38]:
#---#[ diagrams[39]:
diagrams[39] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "A", 8, 3, 5, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "S", 7, 1, 6, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "-p1+k1+k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "A"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[39]:
#---#[ diagrams[40]:
diagrams[40] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "A", 8, 3, 5, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "S", 6, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 8, 1, 6, 2, "p1-k1-k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1-k3-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "A"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[40]:
#---#[ diagrams[41]:
diagrams[41] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "Z", 8, 3, 5, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "-p1+k1+k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "Z"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[41]:
#---#[ diagrams[42]:
diagrams[42] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "Z", 8, 3, 5, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "U", 6, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "Z"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[42]:
#---#[ diagrams[43]:
diagrams[43] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "Z", 8, 3, 5, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "D", 7, 1, 6, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1+k1+k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "Z"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[43]:
#---#[ diagrams[44]:
diagrams[44] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "Z", 8, 3, 5, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "D", 6, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 6, 2, "p1-k1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "Z"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[44]:
#---#[ diagrams[45]:
diagrams[45] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "Z", 8, 3, 5, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "C", 7, 1, 6, 2, "-p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 6, 1, 8, 2, "-p1+k1+k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 8, 1, 7, 2, "-p1+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "Z"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "Z"))
#---#] diagrams[45]:
#---#[ diagrams[46]:
diagrams[46] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "Z", 8, 3, 5, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "C", 6, 1, 7, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "p1-k1-k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k3-k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "Z"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "Z"))
#---#] diagrams[46]:
#---#[ diagrams[47]:
diagrams[47] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "Z", 8, 3, 5, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "S", 7, 1, 6, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "-p1+k1+k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "Z"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[47]:
#---#[ diagrams[48]:
diagrams[48] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "Z", 8, 3, 5, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "S", 6, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 8, 1, 6, 2, "p1-k1-k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1-k3-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "Z"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[48]:
#---#[ diagrams[49]:
diagrams[49] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "A", 8, 3, 5, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "-p1+k1-k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1-k2+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "A"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[49]:
#---#[ diagrams[50]:
diagrams[50] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "A", 8, 3, 5, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "U", 6, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1-k1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "A"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[50]:
#---#[ diagrams[51]:
diagrams[51] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "A", 8, 3, 5, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "D", 7, 1, 6, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1+k1-k3", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1-k2+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "A"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[51]:
#---#[ diagrams[52]:
diagrams[52] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "A", 8, 3, 5, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "D", 6, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 6, 2, "p1-k1+k3", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1+k2-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "A"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[52]:
#---#[ diagrams[53]:
diagrams[53] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "A", 8, 3, 5, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "C", 7, 1, 6, 2, "-p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 6, 1, 8, 2, "-p1+k1-k3", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 8, 1, 7, 2, "-p1-k2+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "A"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "A"))
#---#] diagrams[53]:
#---#[ diagrams[54]:
diagrams[54] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "A", 8, 3, 5, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "C", 6, 1, 7, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "p1-k1+k3", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1+k2-k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "A"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "A"))
#---#] diagrams[54]:
#---#[ diagrams[55]:
diagrams[55] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "A", 8, 3, 5, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "S", 7, 1, 6, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "-p1+k1-k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1-k2+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "A"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[55]:
#---#[ diagrams[56]:
diagrams[56] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "A", 8, 3, 5, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "S", 6, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 8, 1, 6, 2, "p1-k1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "A"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[56]:
#---#[ diagrams[57]:
diagrams[57] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "Z", 8, 3, 5, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "-p1+k1-k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1-k2+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "Z"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[57]:
#---#[ diagrams[58]:
diagrams[58] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "Z", 8, 3, 5, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "U", 6, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1-k1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "Z"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[58]:
#---#[ diagrams[59]:
diagrams[59] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "Z", 8, 3, 5, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "D", 7, 1, 6, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1+k1-k3", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1-k2+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "Z"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[59]:
#---#[ diagrams[60]:
diagrams[60] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "Z", 8, 3, 5, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "D", 6, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 6, 2, "p1-k1+k3", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1+k2-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "Z"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[60]:
#---#[ diagrams[61]:
diagrams[61] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "Z", 8, 3, 5, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "C", 7, 1, 6, 2, "-p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 6, 1, 8, 2, "-p1+k1-k3", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 8, 1, 7, 2, "-p1-k2+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "Z"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "Z"))
#---#] diagrams[61]:
#---#[ diagrams[62]:
diagrams[62] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "Z", 8, 3, 5, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "C", 6, 1, 7, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "p1-k1+k3", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1+k2-k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "Z"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "Z"))
#---#] diagrams[62]:
#---#[ diagrams[63]:
diagrams[63] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "Z", 8, 3, 5, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "S", 7, 1, 6, 2, "-p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "-p1+k1-k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1-k2+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "Z"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[63]:
#---#[ diagrams[64]:
diagrams[64] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 5, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 3, 4, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "Z", 8, 3, 5, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "S", 6, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 8, 1, 6, 2, "p1-k1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1+k2-k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 1, "Wp", "Wm", "Z"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[64]:
#---#[ diagrams[65]:
diagrams[65] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 6, 1, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[65]:
#---#[ diagrams[66]:
diagrams[66] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 6, 1, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[66]:
#---#[ diagrams[67]:
diagrams[67] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 6, 1, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "A"))
#---#] diagrams[67]:
#---#[ diagrams[68]:
diagrams[68] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 6, 1, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[68]:
#---#[ diagrams[69]:
diagrams[69] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 6, 1, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[69]:
#---#[ diagrams[70]:
diagrams[70] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 6, 1, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[70]:
#---#[ diagrams[71]:
diagrams[71] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 6, 1, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "Z"))
#---#] diagrams[71]:
#---#[ diagrams[72]:
diagrams[72] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 6, 1, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[72]:
#---#[ diagrams[73]:
diagrams[73] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 6, 1, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[73]:
#---#[ diagrams[74]:
diagrams[74] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 6, 1, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[74]:
#---#[ diagrams[75]:
diagrams[75] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 6, 1, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "A"))
#---#] diagrams[75]:
#---#[ diagrams[76]:
diagrams[76] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 6, 1, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[76]:
#---#[ diagrams[77]:
diagrams[77] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 6, 1, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[77]:
#---#[ diagrams[78]:
diagrams[78] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 6, 1, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[78]:
#---#[ diagrams[79]:
diagrams[79] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 6, 1, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "Z"))
#---#] diagrams[79]:
#---#[ diagrams[80]:
diagrams[80] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 4, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 4, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 5, 1, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "g", 5, 2, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "Wm", 6, 1, 4, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "mup", "nmu", "Wm"),
   Vertex(5, 1, "g", "g", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[80]:
#---#[ diagrams[81]:
diagrams[81] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 6, 1, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 8, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 6, 2, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 7, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 6, 3, 5, 3, "p1+k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 5, 2, "-p1-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[81]:
#---#[ diagrams[82]:
diagrams[82] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 6, 1, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 8, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 6, 2, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 7, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 6, 3, 5, 3, "p1+k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 5, 2, "-p1-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[82]:
#---#[ diagrams[83]:
diagrams[83] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 6, 1, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 8, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 6, 2, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 7, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 6, 3, 5, 3, "p1+k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 5, 2, "-p1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1+k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[83]:
#---#[ diagrams[84]:
diagrams[84] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 6, 1, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 8, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 6, 2, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 7, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 6, 3, 5, 3, "p1-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 5, 2, "-p1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1+k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[84]:
#---#[ diagrams[85]:
diagrams[85] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 6, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 8, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 6, 1, 4, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 7, 2, "p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[85]:
#---#[ diagrams[86]:
diagrams[86] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 6, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 8, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 6, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "-p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "-p1+k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "U", "Wm"))
#---#] diagrams[86]:
#---#[ diagrams[87]:
diagrams[87] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 6, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 8, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 6, 1, 4, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 7, 2, "p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[87]:
#---#[ diagrams[88]:
diagrams[88] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 6, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 8, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 6, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "-p1+k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "U", "Wm"))
#---#] diagrams[88]:
#---#[ diagrams[89]:
diagrams[89] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 6, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 8, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 6, 1, 4, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 7, 2, "p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1+k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[89]:
#---#[ diagrams[90]:
diagrams[90] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 6, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 8, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 6, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "-p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "-p1+k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "U", "Wm"))
#---#] diagrams[90]:
#---#[ diagrams[91]:
diagrams[91] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 6, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 8, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 6, 1, 4, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 7, 2, "p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1+k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[91]:
#---#[ diagrams[92]:
diagrams[92] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 6, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 8, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 6, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "-p1+k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "U", "Wm"))
#---#] diagrams[92]:
#---#[ diagrams[93]:
diagrams[93] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 8, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 6, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "-p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[93]:
#---#[ diagrams[94]:
diagrams[94] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 8, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 6, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[94]:
#---#[ diagrams[95]:
diagrams[95] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 8, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 6, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "-p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1+k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[95]:
#---#[ diagrams[96]:
diagrams[96] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 8, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 6, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1+k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[96]:
#---#[ diagrams[97]:
diagrams[97] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 2, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 8, 1, 4, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 3, 5, 3, "p1+k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 5, 1, 8, 2, "p1+k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[97]:
#---#[ diagrams[98]:
diagrams[98] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 2, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 8, 1, 4, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 3, 5, 3, "p1+k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 5, 1, 8, 2, "p1+k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[98]:
#---#[ diagrams[99]:
diagrams[99] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 2, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 8, 1, 4, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 3, 5, 3, "p1+k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 5, 1, 8, 2, "p1+k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[99]:
#---#[ diagrams[100]:
diagrams[100] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 2, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 8, 1, 4, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 3, 5, 3, "p1+k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 5, 1, 8, 2, "p1+k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[100]:
#---#[ diagrams[101]:
diagrams[101] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 2, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 3, 5, 3, "p1+k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 5, 2, "-p1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[101]:
#---#[ diagrams[102]:
diagrams[102] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 2, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 3, 5, 3, "p1+k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 5, 2, "-p1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[102]:
#---#[ diagrams[103]:
diagrams[103] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 2, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 3, 5, 3, "p1-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 5, 2, "-p1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[103]:
#---#[ diagrams[104]:
diagrams[104] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 7, 2, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 3, 5, 3, "p1-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 5, 2, "-p1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[104]:
#---#[ diagrams[105]:
diagrams[105] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "U", 8, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "p1+k1+k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[105]:
#---#[ diagrams[106]:
diagrams[106] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "U", 8, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 5, 1, 8, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[106]:
#---#[ diagrams[107]:
diagrams[107] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "U", 8, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "p1+k1+k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[107]:
#---#[ diagrams[108]:
diagrams[108] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "U", 8, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 5, 1, 8, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[108]:
#---#[ diagrams[109]:
diagrams[109] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "U", 4, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[109]:
#---#[ diagrams[110]:
diagrams[110] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "U", 4, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 5, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[110]:
#---#[ diagrams[111]:
diagrams[111] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "U", 4, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[111]:
#---#[ diagrams[112]:
diagrams[112] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "U", 4, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 5, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[112]:
#---#[ diagrams[113]:
diagrams[113] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "U", 8, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "p1+k1-k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[113]:
#---#[ diagrams[114]:
diagrams[114] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "U", 8, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 5, 1, 8, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[114]:
#---#[ diagrams[115]:
diagrams[115] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "U", 8, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "p1+k1-k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[115]:
#---#[ diagrams[116]:
diagrams[116] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "U", 8, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 5, 1, 8, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[116]:
#---#[ diagrams[117]:
diagrams[117] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "U", 4, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1-k1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[117]:
#---#[ diagrams[118]:
diagrams[118] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "U", 4, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 5, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[118]:
#---#[ diagrams[119]:
diagrams[119] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "U", 4, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1-k1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[119]:
#---#[ diagrams[120]:
diagrams[120] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "U", 4, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 5, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[120]:
#---#[ diagrams[121]:
diagrams[121] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "U", 4, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1-k2+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[121]:
#---#[ diagrams[122]:
diagrams[122] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "U", 4, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 5, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[122]:
#---#[ diagrams[123]:
diagrams[123] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "U", 4, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1-k2+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[123]:
#---#[ diagrams[124]:
diagrams[124] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "U", 4, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 5, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[124]:
#---#[ diagrams[125]:
diagrams[125] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "U", 8, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "p1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[125]:
#---#[ diagrams[126]:
diagrams[126] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "U", 8, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 5, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[126]:
#---#[ diagrams[127]:
diagrams[127] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "U", 8, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "p1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[127]:
#---#[ diagrams[128]:
diagrams[128] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "U", 8, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 5, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[128]:
#---#[ diagrams[129]:
diagrams[129] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "U", 4, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[129]:
#---#[ diagrams[130]:
diagrams[130] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "U", 4, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 5, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[130]:
#---#[ diagrams[131]:
diagrams[131] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "U", 4, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[131]:
#---#[ diagrams[132]:
diagrams[132] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "U", 4, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 5, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[132]:
#---#[ diagrams[133]:
diagrams[133] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "U", 8, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[133]:
#---#[ diagrams[134]:
diagrams[134] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "U", 8, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 5, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[134]:
#---#[ diagrams[135]:
diagrams[135] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "U", 8, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[135]:
#---#[ diagrams[136]:
diagrams[136] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "U", 8, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 5, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[136]:
#---#[ diagrams[137]:
diagrams[137] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 7, 1, 4, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 8, 2, "p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "p1-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[137]:
#---#[ diagrams[138]:
diagrams[138] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 7, 1, 4, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 8, 2, "p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "p1-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[138]:
#---#[ diagrams[139]:
diagrams[139] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 7, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 8, 1, 5, 2, "-p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "-p1+k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[139]:
#---#[ diagrams[140]:
diagrams[140] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 7, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 8, 1, 5, 2, "-p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "-p1+k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[140]:
#---#[ diagrams[141]:
diagrams[141] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 7, 1, 4, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 8, 2, "p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "p1-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[141]:
#---#[ diagrams[142]:
diagrams[142] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 7, 1, 4, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 8, 2, "p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "p1-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[142]:
#---#[ diagrams[143]:
diagrams[143] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 7, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 8, 1, 5, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "-p1+k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[143]:
#---#[ diagrams[144]:
diagrams[144] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 7, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 8, 1, 5, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "-p1+k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[144]:
#---#[ diagrams[145]:
diagrams[145] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 7, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 8, 1, 5, 2, "-p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "-p1+k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[145]:
#---#[ diagrams[146]:
diagrams[146] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 7, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 8, 1, 5, 2, "-p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "-p1+k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[146]:
#---#[ diagrams[147]:
diagrams[147] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 7, 1, 4, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 8, 2, "p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "p1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[147]:
#---#[ diagrams[148]:
diagrams[148] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 7, 1, 4, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 8, 2, "p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "p1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[148]:
#---#[ diagrams[149]:
diagrams[149] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 7, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 8, 1, 5, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "-p1+k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[149]:
#---#[ diagrams[150]:
diagrams[150] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 7, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 8, 1, 5, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "-p1+k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[150]:
#---#[ diagrams[151]:
diagrams[151] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 7, 1, 4, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 8, 2, "p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "p1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[151]:
#---#[ diagrams[152]:
diagrams[152] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 7, 1, 4, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 8, 2, "p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "p1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[152]:
#---#[ diagrams[153]:
diagrams[153] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[153]:
#---#[ diagrams[154]:
diagrams[154] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[154]:
#---#[ diagrams[155]:
diagrams[155] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[155]:
#---#[ diagrams[156]:
diagrams[156] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[156]:
#---#[ diagrams[157]:
diagrams[157] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1-k1-k2", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[157]:
#---#[ diagrams[158]:
diagrams[158] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 1, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[158]:
#---#[ diagrams[159]:
diagrams[159] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[159]:
#---#[ diagrams[160]:
diagrams[160] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[160]:
#---#[ diagrams[161]:
diagrams[161] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[161]:
#---#[ diagrams[162]:
diagrams[162] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[162]:
#---#[ diagrams[163]:
diagrams[163] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1-k1-k2", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[163]:
#---#[ diagrams[164]:
diagrams[164] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 1, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[164]:
#---#[ diagrams[165]:
diagrams[165] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[165]:
#---#[ diagrams[166]:
diagrams[166] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[166]:
#---#[ diagrams[167]:
diagrams[167] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[167]:
#---#[ diagrams[168]:
diagrams[168] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[168]:
#---#[ diagrams[169]:
diagrams[169] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1-k1-k2", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[169]:
#---#[ diagrams[170]:
diagrams[170] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 1, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[170]:
#---#[ diagrams[171]:
diagrams[171] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[171]:
#---#[ diagrams[172]:
diagrams[172] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[172]:
#---#[ diagrams[173]:
diagrams[173] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[173]:
#---#[ diagrams[174]:
diagrams[174] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[174]:
#---#[ diagrams[175]:
diagrams[175] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1-k1-k2", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[175]:
#---#[ diagrams[176]:
diagrams[176] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 1, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[176]:
#---#[ diagrams[177]:
diagrams[177] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[177]:
#---#[ diagrams[178]:
diagrams[178] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1+k3", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[178]:
#---#[ diagrams[179]:
diagrams[179] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1+k3", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[179]:
#---#[ diagrams[180]:
diagrams[180] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[180]:
#---#[ diagrams[181]:
diagrams[181] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1-k1+k3", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[181]:
#---#[ diagrams[182]:
diagrams[182] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 1, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[182]:
#---#[ diagrams[183]:
diagrams[183] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[183]:
#---#[ diagrams[184]:
diagrams[184] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1+k3", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[184]:
#---#[ diagrams[185]:
diagrams[185] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1+k3", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[185]:
#---#[ diagrams[186]:
diagrams[186] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[186]:
#---#[ diagrams[187]:
diagrams[187] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1-k1+k3", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[187]:
#---#[ diagrams[188]:
diagrams[188] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 1, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[188]:
#---#[ diagrams[189]:
diagrams[189] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[189]:
#---#[ diagrams[190]:
diagrams[190] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1+k3", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[190]:
#---#[ diagrams[191]:
diagrams[191] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1+k3", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[191]:
#---#[ diagrams[192]:
diagrams[192] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[192]:
#---#[ diagrams[193]:
diagrams[193] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1-k1+k3", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[193]:
#---#[ diagrams[194]:
diagrams[194] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 1, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[194]:
#---#[ diagrams[195]:
diagrams[195] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[195]:
#---#[ diagrams[196]:
diagrams[196] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1+k3", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[196]:
#---#[ diagrams[197]:
diagrams[197] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1+k3", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[197]:
#---#[ diagrams[198]:
diagrams[198] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[198]:
#---#[ diagrams[199]:
diagrams[199] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1-k1+k3", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[199]:
#---#[ diagrams[200]:
diagrams[200] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 1, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[200]:
#---#[ diagrams[201]:
diagrams[201] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k2+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[201]:
#---#[ diagrams[202]:
diagrams[202] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k2+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[202]:
#---#[ diagrams[203]:
diagrams[203] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k2+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[203]:
#---#[ diagrams[204]:
diagrams[204] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k2+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[204]:
#---#[ diagrams[205]:
diagrams[205] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1-k2+k4", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[205]:
#---#[ diagrams[206]:
diagrams[206] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 1, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[206]:
#---#[ diagrams[207]:
diagrams[207] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k2+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[207]:
#---#[ diagrams[208]:
diagrams[208] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k2+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[208]:
#---#[ diagrams[209]:
diagrams[209] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k2+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[209]:
#---#[ diagrams[210]:
diagrams[210] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k2+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[210]:
#---#[ diagrams[211]:
diagrams[211] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1-k2+k4", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[211]:
#---#[ diagrams[212]:
diagrams[212] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 1, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[212]:
#---#[ diagrams[213]:
diagrams[213] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k2+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[213]:
#---#[ diagrams[214]:
diagrams[214] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k2+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[214]:
#---#[ diagrams[215]:
diagrams[215] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k2+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[215]:
#---#[ diagrams[216]:
diagrams[216] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k2+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[216]:
#---#[ diagrams[217]:
diagrams[217] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1-k2+k4", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[217]:
#---#[ diagrams[218]:
diagrams[218] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 1, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[218]:
#---#[ diagrams[219]:
diagrams[219] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k2+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[219]:
#---#[ diagrams[220]:
diagrams[220] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k2+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[220]:
#---#[ diagrams[221]:
diagrams[221] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k2+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[221]:
#---#[ diagrams[222]:
diagrams[222] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k2+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[222]:
#---#[ diagrams[223]:
diagrams[223] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1-k2+k4", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[223]:
#---#[ diagrams[224]:
diagrams[224] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 1, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[224]:
#---#[ diagrams[225]:
diagrams[225] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[225]:
#---#[ diagrams[226]:
diagrams[226] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[226]:
#---#[ diagrams[227]:
diagrams[227] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[227]:
#---#[ diagrams[228]:
diagrams[228] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[228]:
#---#[ diagrams[229]:
diagrams[229] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1+k3+k4", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[229]:
#---#[ diagrams[230]:
diagrams[230] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 1, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[230]:
#---#[ diagrams[231]:
diagrams[231] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[231]:
#---#[ diagrams[232]:
diagrams[232] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[232]:
#---#[ diagrams[233]:
diagrams[233] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[233]:
#---#[ diagrams[234]:
diagrams[234] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[234]:
#---#[ diagrams[235]:
diagrams[235] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1+k3+k4", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[235]:
#---#[ diagrams[236]:
diagrams[236] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 1, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[236]:
#---#[ diagrams[237]:
diagrams[237] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[237]:
#---#[ diagrams[238]:
diagrams[238] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[238]:
#---#[ diagrams[239]:
diagrams[239] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[239]:
#---#[ diagrams[240]:
diagrams[240] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[240]:
#---#[ diagrams[241]:
diagrams[241] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1+k3+k4", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[241]:
#---#[ diagrams[242]:
diagrams[242] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 4, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "g", 8, 1, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "A"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[242]:
#---#[ diagrams[243]:
diagrams[243] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[243]:
#---#[ diagrams[244]:
diagrams[244] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[244]:
#---#[ diagrams[245]:
diagrams[245] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[245]:
#---#[ diagrams[246]:
diagrams[246] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[246]:
#---#[ diagrams[247]:
diagrams[247] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1+k3+k4", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[247]:
#---#[ diagrams[248]:
diagrams[248] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 4, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "g", 8, 1, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "Z"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[248]:
#---#[ diagrams[249]:
diagrams[249] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 8, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 6, 1, 7, 2, "p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k5-k6-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[249]:
#---#[ diagrams[250]:
diagrams[250] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 8, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 7, 1, 6, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1+k5+k6+k7+k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[250]:
#---#[ diagrams[251]:
diagrams[251] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 8, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 6, 1, 7, 2, "p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k5-k6-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[251]:
#---#[ diagrams[252]:
diagrams[252] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 8, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 7, 1, 6, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1+k5+k6+k7+k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[252]:
#---#[ diagrams[253]:
diagrams[253] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 8, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 6, 1, 7, 2, "p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k5-k6-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[253]:
#---#[ diagrams[254]:
diagrams[254] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 8, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 7, 1, 6, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1+k5+k6+k7+k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[254]:
#---#[ diagrams[255]:
diagrams[255] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 8, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 6, 1, 7, 2, "p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k5-k6-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[255]:
#---#[ diagrams[256]:
diagrams[256] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 8, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 7, 1, 6, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1+k5+k6+k7+k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[256]:
#---#[ diagrams[257]:
diagrams[257] = Diagram(
   Leg(1, True, "U", 2, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 8, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 7, 1, 6, 2, "-p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1-k1-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[257]:
#---#[ diagrams[258]:
diagrams[258] = Diagram(
   Leg(1, True, "U", 2, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 8, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 7, 1, 6, 2, "-p1-k1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1-k1+k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[258]:
#---#[ diagrams[259]:
diagrams[259] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 8, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 7, 1, 6, 2, "-p1-k2+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1-k2+k4+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[259]:
#---#[ diagrams[260]:
diagrams[260] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 8, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 7, 1, 6, 2, "-p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k3+k4+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[260]:
#---#[ diagrams[261]:
diagrams[261] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 8, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 7, 1, 6, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1-k1-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[261]:
#---#[ diagrams[262]:
diagrams[262] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 8, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 7, 1, 6, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1-k1+k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[262]:
#---#[ diagrams[263]:
diagrams[263] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 8, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 7, 1, 6, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1-k2+k4+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[263]:
#---#[ diagrams[264]:
diagrams[264] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 8, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 7, 1, 6, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k3+k4+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[264]:
#---#[ diagrams[265]:
diagrams[265] = Diagram(
   Leg(1, True, "U", 2, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 8, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 6, 1, 7, 2, "p1+k1+k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1+k1+k2-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[265]:
#---#[ diagrams[266]:
diagrams[266] = Diagram(
   Leg(1, True, "U", 2, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 8, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 6, 1, 7, 2, "p1+k1-k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1+k1-k3-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[266]:
#---#[ diagrams[267]:
diagrams[267] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 8, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 6, 1, 7, 2, "p1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1+k2-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[267]:
#---#[ diagrams[268]:
diagrams[268] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 8, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 6, 1, 7, 2, "p1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k3-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[268]:
#---#[ diagrams[269]:
diagrams[269] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 8, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 6, 1, 7, 2, "p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1+k1+k2-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[269]:
#---#[ diagrams[270]:
diagrams[270] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 8, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 6, 1, 7, 2, "p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1+k1-k3-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[270]:
#---#[ diagrams[271]:
diagrams[271] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 8, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 6, 1, 7, 2, "p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1+k2-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[271]:
#---#[ diagrams[272]:
diagrams[272] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 8, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 6, 1, 7, 2, "p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k3-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[272]:
#---#[ diagrams[273]:
diagrams[273] = Diagram(
   Leg(1, True, "U", 2, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 1, 2, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 8, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 6, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 7, 1, 5, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 8, 1, 7, 2, "p1+k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[273]:
#---#[ diagrams[274]:
diagrams[274] = Diagram(
   Leg(1, True, "U", 2, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 1, 2, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 8, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 6, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 7, 1, 5, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 8, 1, 7, 2, "p1-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[274]:
#---#[ diagrams[275]:
diagrams[275] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 1, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 8, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 6, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 7, 1, 5, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 8, 1, 7, 2, "p1+k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[275]:
#---#[ diagrams[276]:
diagrams[276] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 1, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 8, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 6, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 7, 1, 5, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 8, 1, 7, 2, "p1-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[276]:
#---#[ diagrams[277]:
diagrams[277] = Diagram(
   Leg(1, True, "U", 2, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 1, 2, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 8, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 6, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 7, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[277]:
#---#[ diagrams[278]:
diagrams[278] = Diagram(
   Leg(1, True, "U", 2, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 1, 2, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 8, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 6, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 7, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[278]:
#---#[ diagrams[279]:
diagrams[279] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 1, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 8, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 6, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 7, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1+k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[279]:
#---#[ diagrams[280]:
diagrams[280] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 1, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 8, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 6, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 7, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1+k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[280]:
#---#[ diagrams[281]:
diagrams[281] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 7, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 6, 1, 8, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[281]:
#---#[ diagrams[282]:
diagrams[282] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 6, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 5, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[282]:
#---#[ diagrams[283]:
diagrams[283] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 7, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 6, 1, 8, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[283]:
#---#[ diagrams[284]:
diagrams[284] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 6, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 5, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[284]:
#---#[ diagrams[285]:
diagrams[285] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 7, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 6, 1, 8, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[285]:
#---#[ diagrams[286]:
diagrams[286] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 6, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 5, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[286]:
#---#[ diagrams[287]:
diagrams[287] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 7, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 6, 1, 8, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[287]:
#---#[ diagrams[288]:
diagrams[288] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 6, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 5, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[288]:
#---#[ diagrams[289]:
diagrams[289] = Diagram(
   Leg(1, True, "U", 2, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 7, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 6, 1, 8, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[289]:
#---#[ diagrams[290]:
diagrams[290] = Diagram(
   Leg(1, True, "U", 2, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 7, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 6, 1, 8, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[290]:
#---#[ diagrams[291]:
diagrams[291] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 7, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 6, 1, 8, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[291]:
#---#[ diagrams[292]:
diagrams[292] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 7, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 6, 1, 8, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[292]:
#---#[ diagrams[293]:
diagrams[293] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 7, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 6, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[293]:
#---#[ diagrams[294]:
diagrams[294] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[294]:
#---#[ diagrams[295]:
diagrams[295] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 7, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 6, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1-k1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[295]:
#---#[ diagrams[296]:
diagrams[296] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[296]:
#---#[ diagrams[297]:
diagrams[297] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 7, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 6, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1-k2+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[297]:
#---#[ diagrams[298]:
diagrams[298] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[298]:
#---#[ diagrams[299]:
diagrams[299] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 7, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 6, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[299]:
#---#[ diagrams[300]:
diagrams[300] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[300]:
#---#[ diagrams[301]:
diagrams[301] = Diagram(
   Leg(1, True, "U", 2, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[301]:
#---#[ diagrams[302]:
diagrams[302] = Diagram(
   Leg(1, True, "U", 2, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[302]:
#---#[ diagrams[303]:
diagrams[303] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[303]:
#---#[ diagrams[304]:
diagrams[304] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 6, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[304]:
#---#[ diagrams[305]:
diagrams[305] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1+k1+k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[305]:
#---#[ diagrams[306]:
diagrams[306] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[306]:
#---#[ diagrams[307]:
diagrams[307] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1+k1-k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[307]:
#---#[ diagrams[308]:
diagrams[308] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[308]:
#---#[ diagrams[309]:
diagrams[309] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[309]:
#---#[ diagrams[310]:
diagrams[310] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[310]:
#---#[ diagrams[311]:
diagrams[311] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[311]:
#---#[ diagrams[312]:
diagrams[312] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 7, 2, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[312]:
#---#[ diagrams[313]:
diagrams[313] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[313]:
#---#[ diagrams[314]:
diagrams[314] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[314]:
#---#[ diagrams[315]:
diagrams[315] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[315]:
#---#[ diagrams[316]:
diagrams[316] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[316]:
#---#[ diagrams[317]:
diagrams[317] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1-k1-k2", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[317]:
#---#[ diagrams[318]:
diagrams[318] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 1, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[318]:
#---#[ diagrams[319]:
diagrams[319] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[319]:
#---#[ diagrams[320]:
diagrams[320] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1+k3", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[320]:
#---#[ diagrams[321]:
diagrams[321] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1+k3", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[321]:
#---#[ diagrams[322]:
diagrams[322] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[322]:
#---#[ diagrams[323]:
diagrams[323] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1-k1+k3", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[323]:
#---#[ diagrams[324]:
diagrams[324] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 1, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[324]:
#---#[ diagrams[325]:
diagrams[325] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k2+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[325]:
#---#[ diagrams[326]:
diagrams[326] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k2+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[326]:
#---#[ diagrams[327]:
diagrams[327] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k2+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[327]:
#---#[ diagrams[328]:
diagrams[328] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k2+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[328]:
#---#[ diagrams[329]:
diagrams[329] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1-k2+k4", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[329]:
#---#[ diagrams[330]:
diagrams[330] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 1, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[330]:
#---#[ diagrams[331]:
diagrams[331] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[331]:
#---#[ diagrams[332]:
diagrams[332] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[332]:
#---#[ diagrams[333]:
diagrams[333] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[333]:
#---#[ diagrams[334]:
diagrams[334] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[334]:
#---#[ diagrams[335]:
diagrams[335] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1+k3+k4", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[335]:
#---#[ diagrams[336]:
diagrams[336] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 6, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 1, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[336]:
#---#[ diagrams[337]:
diagrams[337] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[337]:
#---#[ diagrams[338]:
diagrams[338] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[338]:
#---#[ diagrams[339]:
diagrams[339] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[339]:
#---#[ diagrams[340]:
diagrams[340] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[340]:
#---#[ diagrams[341]:
diagrams[341] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1-k1-k2", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[341]:
#---#[ diagrams[342]:
diagrams[342] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 1, 5, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[342]:
#---#[ diagrams[343]:
diagrams[343] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[343]:
#---#[ diagrams[344]:
diagrams[344] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1+k3", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[344]:
#---#[ diagrams[345]:
diagrams[345] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1+k3", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[345]:
#---#[ diagrams[346]:
diagrams[346] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[346]:
#---#[ diagrams[347]:
diagrams[347] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1-k1+k3", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[347]:
#---#[ diagrams[348]:
diagrams[348] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 1, 5, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[348]:
#---#[ diagrams[349]:
diagrams[349] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k2+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[349]:
#---#[ diagrams[350]:
diagrams[350] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k2+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[350]:
#---#[ diagrams[351]:
diagrams[351] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k2+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[351]:
#---#[ diagrams[352]:
diagrams[352] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k2+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[352]:
#---#[ diagrams[353]:
diagrams[353] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1-k2+k4", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[353]:
#---#[ diagrams[354]:
diagrams[354] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 1, 5, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[354]:
#---#[ diagrams[355]:
diagrams[355] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[355]:
#---#[ diagrams[356]:
diagrams[356] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[356]:
#---#[ diagrams[357]:
diagrams[357] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[357]:
#---#[ diagrams[358]:
diagrams[358] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[358]:
#---#[ diagrams[359]:
diagrams[359] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "gh", 8, 1, 7, 2, "p1+k3+k4", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "gh", 7, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 1, "ghbar", "gh", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[359]:
#---#[ diagrams[360]:
diagrams[360] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 7, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 1, 5, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 2, 7, 2, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 1, "g", "g", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[360]:
#---#[ diagrams[361]:
diagrams[361] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[361]:
#---#[ diagrams[362]:
diagrams[362] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 6, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[362]:
#---#[ diagrams[363]:
diagrams[363] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "C", 7, 1, 6, 2, "-p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "-p1-k5-k6", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1+k7+k8", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[363]:
#---#[ diagrams[364]:
diagrams[364] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 6, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "p1+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[364]:
#---#[ diagrams[365]:
diagrams[365] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[365]:
#---#[ diagrams[366]:
diagrams[366] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 6, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[366]:
#---#[ diagrams[367]:
diagrams[367] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "C", 7, 1, 6, 2, "-p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "-p1-k5-k6", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1+k7+k8", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[367]:
#---#[ diagrams[368]:
diagrams[368] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 6, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "p1+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[368]:
#---#[ diagrams[369]:
diagrams[369] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[369]:
#---#[ diagrams[370]:
diagrams[370] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 6, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[370]:
#---#[ diagrams[371]:
diagrams[371] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "C", 7, 1, 6, 2, "-p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "-p1-k5-k6", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1+k7+k8", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[371]:
#---#[ diagrams[372]:
diagrams[372] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 6, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "p1+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[372]:
#---#[ diagrams[373]:
diagrams[373] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[373]:
#---#[ diagrams[374]:
diagrams[374] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 6, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[374]:
#---#[ diagrams[375]:
diagrams[375] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "C", 7, 1, 6, 2, "-p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "-p1-k5-k6", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1+k7+k8", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[375]:
#---#[ diagrams[376]:
diagrams[376] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 6, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "p1+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[376]:
#---#[ diagrams[377]:
diagrams[377] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[377]:
#---#[ diagrams[378]:
diagrams[378] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 6, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[378]:
#---#[ diagrams[379]:
diagrams[379] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "C", 7, 1, 6, 2, "-p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "-p1-k5-k6", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1+k7+k8", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[379]:
#---#[ diagrams[380]:
diagrams[380] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 6, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "p1+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[380]:
#---#[ diagrams[381]:
diagrams[381] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[381]:
#---#[ diagrams[382]:
diagrams[382] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 6, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[382]:
#---#[ diagrams[383]:
diagrams[383] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "C", 7, 1, 6, 2, "-p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "-p1-k5-k6", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1+k7+k8", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[383]:
#---#[ diagrams[384]:
diagrams[384] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 6, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "p1+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[384]:
#---#[ diagrams[385]:
diagrams[385] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[385]:
#---#[ diagrams[386]:
diagrams[386] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 6, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[386]:
#---#[ diagrams[387]:
diagrams[387] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "C", 7, 1, 6, 2, "-p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "-p1-k5-k6", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1+k7+k8", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[387]:
#---#[ diagrams[388]:
diagrams[388] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 6, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "p1+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[388]:
#---#[ diagrams[389]:
diagrams[389] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[389]:
#---#[ diagrams[390]:
diagrams[390] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "D", 6, 1, 7, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "p1+k5+k6", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1-k7-k8", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[390]:
#---#[ diagrams[391]:
diagrams[391] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "C", 7, 1, 6, 2, "-p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "-p1-k5-k6", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 8, 1, 7, 2, "-p1+k7+k8", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[391]:
#---#[ diagrams[392]:
diagrams[392] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 7, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "S", 6, 1, 7, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "C", 8, 1, 6, 2, "p1+k5+k6", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1-k7-k8", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Sbar", "C", "Wm"),
   Vertex(7, 0, "Cbar", "S", "Wp"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[392]:
#---#[ diagrams[393]:
diagrams[393] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[393]:
#---#[ diagrams[394]:
diagrams[394] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[394]:
#---#[ diagrams[395]:
diagrams[395] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 7, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "p1+k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[395]:
#---#[ diagrams[396]:
diagrams[396] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 7, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "p1+k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[396]:
#---#[ diagrams[397]:
diagrams[397] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[397]:
#---#[ diagrams[398]:
diagrams[398] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[398]:
#---#[ diagrams[399]:
diagrams[399] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 7, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "p1+k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[399]:
#---#[ diagrams[400]:
diagrams[400] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 7, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "p1+k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[400]:
#---#[ diagrams[401]:
diagrams[401] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 7, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "p1+k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[401]:
#---#[ diagrams[402]:
diagrams[402] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 7, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "p1+k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[402]:
#---#[ diagrams[403]:
diagrams[403] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[403]:
#---#[ diagrams[404]:
diagrams[404] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[404]:
#---#[ diagrams[405]:
diagrams[405] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 7, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "p1+k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[405]:
#---#[ diagrams[406]:
diagrams[406] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 7, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "p1+k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[406]:
#---#[ diagrams[407]:
diagrams[407] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[407]:
#---#[ diagrams[408]:
diagrams[408] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "-p1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[408]:
#---#[ diagrams[409]:
diagrams[409] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 5, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "A"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[409]:
#---#[ diagrams[410]:
diagrams[410] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 5, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "Z"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[410]:
#---#[ diagrams[411]:
diagrams[411] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 7, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 5, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 7, 1, 8, 2, "-p1+k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "A"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[411]:
#---#[ diagrams[412]:
diagrams[412] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 7, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 5, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 7, 1, 8, 2, "-p1+k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "Z"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[412]:
#---#[ diagrams[413]:
diagrams[413] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 5, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "A"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[413]:
#---#[ diagrams[414]:
diagrams[414] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 5, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "Z"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[414]:
#---#[ diagrams[415]:
diagrams[415] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 7, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 5, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 7, 1, 8, 2, "-p1+k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "A"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[415]:
#---#[ diagrams[416]:
diagrams[416] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 7, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 5, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 7, 1, 8, 2, "-p1+k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "Z"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[416]:
#---#[ diagrams[417]:
diagrams[417] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 7, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 5, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 7, 1, 8, 2, "-p1+k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "A"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[417]:
#---#[ diagrams[418]:
diagrams[418] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 7, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 5, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 7, 1, 8, 2, "-p1+k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "Z"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[418]:
#---#[ diagrams[419]:
diagrams[419] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 5, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "A"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[419]:
#---#[ diagrams[420]:
diagrams[420] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 5, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "Z"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[420]:
#---#[ diagrams[421]:
diagrams[421] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 7, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 5, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 7, 1, 8, 2, "-p1+k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "A"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[421]:
#---#[ diagrams[422]:
diagrams[422] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 7, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 5, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 7, 1, 8, 2, "-p1+k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "Z"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[422]:
#---#[ diagrams[423]:
diagrams[423] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "A", 6, 3, 5, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "A"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[423]:
#---#[ diagrams[424]:
diagrams[424] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "Z", 6, 3, 5, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "Z"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[424]:
#---#[ diagrams[425]:
diagrams[425] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[425]:
#---#[ diagrams[426]:
diagrams[426] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[426]:
#---#[ diagrams[427]:
diagrams[427] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "A"))
#---#] diagrams[427]:
#---#[ diagrams[428]:
diagrams[428] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[428]:
#---#[ diagrams[429]:
diagrams[429] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[429]:
#---#[ diagrams[430]:
diagrams[430] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[430]:
#---#[ diagrams[431]:
diagrams[431] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "Z"))
#---#] diagrams[431]:
#---#[ diagrams[432]:
diagrams[432] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[432]:
#---#[ diagrams[433]:
diagrams[433] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[433]:
#---#[ diagrams[434]:
diagrams[434] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[434]:
#---#[ diagrams[435]:
diagrams[435] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "A"))
#---#] diagrams[435]:
#---#[ diagrams[436]:
diagrams[436] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[436]:
#---#[ diagrams[437]:
diagrams[437] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[437]:
#---#[ diagrams[438]:
diagrams[438] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[438]:
#---#[ diagrams[439]:
diagrams[439] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "Z"))
#---#] diagrams[439]:
#---#[ diagrams[440]:
diagrams[440] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[440]:
#---#[ diagrams[441]:
diagrams[441] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[441]:
#---#[ diagrams[442]:
diagrams[442] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[442]:
#---#[ diagrams[443]:
diagrams[443] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "A"))
#---#] diagrams[443]:
#---#[ diagrams[444]:
diagrams[444] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[444]:
#---#[ diagrams[445]:
diagrams[445] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[445]:
#---#[ diagrams[446]:
diagrams[446] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[446]:
#---#[ diagrams[447]:
diagrams[447] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "Z"))
#---#] diagrams[447]:
#---#[ diagrams[448]:
diagrams[448] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[448]:
#---#[ diagrams[449]:
diagrams[449] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[449]:
#---#[ diagrams[450]:
diagrams[450] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[450]:
#---#[ diagrams[451]:
diagrams[451] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "A"))
#---#] diagrams[451]:
#---#[ diagrams[452]:
diagrams[452] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[452]:
#---#[ diagrams[453]:
diagrams[453] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[453]:
#---#[ diagrams[454]:
diagrams[454] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[454]:
#---#[ diagrams[455]:
diagrams[455] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "Z"))
#---#] diagrams[455]:
#---#[ diagrams[456]:
diagrams[456] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[456]:
#---#[ diagrams[457]:
diagrams[457] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[457]:
#---#[ diagrams[458]:
diagrams[458] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[458]:
#---#[ diagrams[459]:
diagrams[459] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "A"))
#---#] diagrams[459]:
#---#[ diagrams[460]:
diagrams[460] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[460]:
#---#[ diagrams[461]:
diagrams[461] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[461]:
#---#[ diagrams[462]:
diagrams[462] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[462]:
#---#[ diagrams[463]:
diagrams[463] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "Z"))
#---#] diagrams[463]:
#---#[ diagrams[464]:
diagrams[464] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[464]:
#---#[ diagrams[465]:
diagrams[465] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[465]:
#---#[ diagrams[466]:
diagrams[466] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[466]:
#---#[ diagrams[467]:
diagrams[467] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "A"))
#---#] diagrams[467]:
#---#[ diagrams[468]:
diagrams[468] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[468]:
#---#[ diagrams[469]:
diagrams[469] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[469]:
#---#[ diagrams[470]:
diagrams[470] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[470]:
#---#[ diagrams[471]:
diagrams[471] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "Z"))
#---#] diagrams[471]:
#---#[ diagrams[472]:
diagrams[472] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[472]:
#---#[ diagrams[473]:
diagrams[473] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[473]:
#---#[ diagrams[474]:
diagrams[474] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[474]:
#---#[ diagrams[475]:
diagrams[475] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "A"))
#---#] diagrams[475]:
#---#[ diagrams[476]:
diagrams[476] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[476]:
#---#[ diagrams[477]:
diagrams[477] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[477]:
#---#[ diagrams[478]:
diagrams[478] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[478]:
#---#[ diagrams[479]:
diagrams[479] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "Z"))
#---#] diagrams[479]:
#---#[ diagrams[480]:
diagrams[480] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 5, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[480]:
#---#[ diagrams[481]:
diagrams[481] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[481]:
#---#[ diagrams[482]:
diagrams[482] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "A"))
#---#] diagrams[482]:
#---#[ diagrams[483]:
diagrams[483] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "A"))
#---#] diagrams[483]:
#---#[ diagrams[484]:
diagrams[484] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "A", 8, 3, 6, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "A"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "A"))
#---#] diagrams[484]:
#---#[ diagrams[485]:
diagrams[485] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[485]:
#---#[ diagrams[486]:
diagrams[486] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "Z"))
#---#] diagrams[486]:
#---#[ diagrams[487]:
diagrams[487] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "C", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "C", 7, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Cbar", "C", "g"),
   Vertex(8, 0, "Cbar", "C", "Z"))
#---#] diagrams[487]:
#---#[ diagrams[488]:
diagrams[488] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 6, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 1, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 5, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 7, 3, 5, 3, "-k1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "Z", 8, 3, 6, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(7, "S", 8, 1, 7, 2, "p1-k1-k2+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "S", 7, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 1, "Wp", "Wm", "Z"),
   Vertex(7, 0, "Sbar", "S", "g"),
   Vertex(8, 0, "Sbar", "S", "Z"))
#---#] diagrams[488]:
#---#[ diagrams[489]:
diagrams[489] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 5, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 5, 1, 8, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "U", 6, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 8, 1, 6, 2, "p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1-k2+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Dbar", "U", "Wm"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[489]:
#---#[ diagrams[490]:
diagrams[490] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 7, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 8, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[490]:
#---#[ diagrams[491]:
diagrams[491] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 5, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 5, 1, 8, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "U", 6, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 8, 1, 6, 2, "p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1-k2+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Dbar", "U", "Wm"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[491]:
#---#[ diagrams[492]:
diagrams[492] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 7, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 8, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[492]:
#---#[ diagrams[493]:
diagrams[493] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 5, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 5, 1, 8, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "U", 6, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 8, 1, 6, 2, "p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Dbar", "U", "Wm"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[493]:
#---#[ diagrams[494]:
diagrams[494] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 7, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 8, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[494]:
#---#[ diagrams[495]:
diagrams[495] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 5, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 7, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 5, 1, 8, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "U", 6, 1, 7, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 8, 1, 6, 2, "p1+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k2+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Dbar", "U", "Wm"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[495]:
#---#[ diagrams[496]:
diagrams[496] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 7, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 8, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "U", 7, 1, 6, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[496]:
#---#[ diagrams[497]:
diagrams[497] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 8, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 7, 1, 6, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1+k1+k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1+k4+k5+k6", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[497]:
#---#[ diagrams[498]:
diagrams[498] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 8, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 7, 3, 6, 2, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[498]:
#---#[ diagrams[499]:
diagrams[499] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 8, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 7, 1, 6, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1+k1-k3", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1+k4+k5+k6", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[499]:
#---#[ diagrams[500]:
diagrams[500] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 1, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 8, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 7, 3, 6, 2, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "p1-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[500]:
#---#[ diagrams[501]:
diagrams[501] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 8, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 7, 1, 6, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1+k2-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1+k5+k6", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[501]:
#---#[ diagrams[502]:
diagrams[502] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 1, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 8, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 7, 3, 6, 2, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "p1+k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[502]:
#---#[ diagrams[503]:
diagrams[503] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 8, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 7, 1, 6, 2, "-p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "-p1-k3-k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1-k1+k5+k6", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[503]:
#---#[ diagrams[504]:
diagrams[504] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 8, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 7, 3, 6, 2, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "p1+k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[504]:
#---#[ diagrams[505]:
diagrams[505] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "U", 8, 1, 6, 2, "p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[505]:
#---#[ diagrams[506]:
diagrams[506] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 8, 1, 6, 2, "p1-k1-k2", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[506]:
#---#[ diagrams[507]:
diagrams[507] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "C", 8, 1, 6, 2, "p1-k1-k2", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 6, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[507]:
#---#[ diagrams[508]:
diagrams[508] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "S", 8, 1, 6, 2, "p1-k1-k2", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[508]:
#---#[ diagrams[509]:
diagrams[509] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "gh", 8, 1, 6, 2, "p1-k1-k2", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(7, "gh", 6, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 1, "ghbar", "gh", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[509]:
#---#[ diagrams[510]:
diagrams[510] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 1, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 2, 6, 2, "p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 1, 7, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[510]:
#---#[ diagrams[511]:
diagrams[511] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "U", 8, 1, 6, 2, "p1-k1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[511]:
#---#[ diagrams[512]:
diagrams[512] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 8, 1, 6, 2, "p1-k1+k3", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[512]:
#---#[ diagrams[513]:
diagrams[513] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "C", 8, 1, 6, 2, "p1-k1+k3", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 6, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[513]:
#---#[ diagrams[514]:
diagrams[514] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "S", 8, 1, 6, 2, "p1-k1+k3", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[514]:
#---#[ diagrams[515]:
diagrams[515] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "gh", 8, 1, 6, 2, "p1-k1+k3", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(7, "gh", 6, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 1, "ghbar", "gh", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[515]:
#---#[ diagrams[516]:
diagrams[516] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 1, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 2, 6, 2, "p1-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 1, 7, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[516]:
#---#[ diagrams[517]:
diagrams[517] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "U", 8, 1, 6, 2, "p1-k2+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[517]:
#---#[ diagrams[518]:
diagrams[518] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 8, 1, 6, 2, "p1-k2+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[518]:
#---#[ diagrams[519]:
diagrams[519] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "C", 8, 1, 6, 2, "p1-k2+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 6, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[519]:
#---#[ diagrams[520]:
diagrams[520] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "S", 8, 1, 6, 2, "p1-k2+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[520]:
#---#[ diagrams[521]:
diagrams[521] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "gh", 8, 1, 6, 2, "p1-k2+k4", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(7, "gh", 6, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 1, "ghbar", "gh", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[521]:
#---#[ diagrams[522]:
diagrams[522] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 1, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 2, 6, 2, "p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 1, 7, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[522]:
#---#[ diagrams[523]:
diagrams[523] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "U", 8, 1, 6, 2, "p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[523]:
#---#[ diagrams[524]:
diagrams[524] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 8, 1, 6, 2, "p1+k3+k4", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 6, 1, 8, 2, "p1", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[524]:
#---#[ diagrams[525]:
diagrams[525] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "C", 8, 1, 6, 2, "p1+k3+k4", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(7, "C", 6, 1, 8, 2, "p1", "mC", "0", 0, 1, 3,
      "C" == "Cbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Cbar", "C", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Cbar", "C", "g"))
#---#] diagrams[525]:
#---#[ diagrams[526]:
diagrams[526] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "S", 8, 1, 6, 2, "p1+k3+k4", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(7, "S", 6, 1, 8, 2, "p1", "mS", "0", 0, 1, 3,
      "S" == "Sbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Sbar", "S", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Sbar", "S", "g"))
#---#] diagrams[526]:
#---#[ diagrams[527]:
diagrams[527] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "gh", 8, 1, 6, 2, "p1+k3+k4", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(7, "gh", 6, 1, 8, 2, "p1", "0", "0", 0, 0, 8,
      "gh" == "ghbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 1, "ghbar", "gh", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 1, "ghbar", "gh", "g"))
#---#] diagrams[527]:
#---#[ diagrams[528]:
diagrams[528] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 1, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "g", 8, 2, 6, 2, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 1, 7, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 1, "g", "g", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[528]:
#---#[ diagrams[529]:
diagrams[529] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 5, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 6, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 5, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 8, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 7, 1, 8, 2, "-p1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Dbar", "U", "Wm"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[529]:
#---#[ diagrams[530]:
diagrams[530] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 6, 1, 8, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 7, 2, "p1+k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[530]:
#---#[ diagrams[531]:
diagrams[531] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 5, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 6, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 5, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 8, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 7, 1, 8, 2, "-p1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Dbar", "U", "Wm"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[531]:
#---#[ diagrams[532]:
diagrams[532] = Diagram(
   Leg(1, True, "U", 1, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 6, 1, 8, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[532]:
#---#[ diagrams[533]:
diagrams[533] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 5, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 6, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 5, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 8, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 7, 1, 8, 2, "-p1+k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Dbar", "U", "Wm"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[533]:
#---#[ diagrams[534]:
diagrams[534] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 1, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 6, 1, 8, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 7, 2, "p1+k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[534]:
#---#[ diagrams[535]:
diagrams[535] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 2, 3, 5, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 6, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 6, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 5, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 8, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 7, 1, 8, 2, "-p1+k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Dbar", "U", "Wm"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[535]:
#---#[ diagrams[536]:
diagrams[536] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 1, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 1, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "g", 4, 3, 1, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "U", 4, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 6, 1, 8, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "Ubar", "U", "g"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[536]:
#---#[ diagrams[537]:
diagrams[537] = Diagram(
   Leg(1, True, "U", 2, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 5, 3, 2, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 6, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 7, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 6, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[537]:
#---#[ diagrams[538]:
diagrams[538] = Diagram(
   Leg(1, True, "U", 2, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 5, 3, 2, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 6, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 7, 1, 5, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 6, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[538]:
#---#[ diagrams[539]:
diagrams[539] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 5, 3, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 6, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 7, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 6, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[539]:
#---#[ diagrams[540]:
diagrams[540] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 3, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 3, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 5, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 6, 3, 3, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 7, 1, 5, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 6, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 7, 2, "p1-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "mup", "nmu", "Wm"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "D", "Wp"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[540]:
#---#[ diagrams[541]:
diagrams[541] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 6, 1, 8, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 7, 2, "p1+k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[541]:
#---#[ diagrams[542]:
diagrams[542] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 6, 1, 8, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[542]:
#---#[ diagrams[543]:
diagrams[543] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 6, 1, 8, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 7, 2, "p1+k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[543]:
#---#[ diagrams[544]:
diagrams[544] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 4, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 5, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 4, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 7, 1, 5, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 6, 1, 8, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 8, 1, 7, 2, "p1-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Dbar", "U", "Wm"),
   Vertex(5, 0, "Ubar", "D", "Wp"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[544]:
#---#[ diagrams[545]:
diagrams[545] = Diagram(
   Leg(1, True, "U", 2, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 5, 3, 2, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 7, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 8, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 7, 1, 8, 2, "-p1+k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[545]:
#---#[ diagrams[546]:
diagrams[546] = Diagram(
   Leg(1, True, "U", 2, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 5, 3, 2, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 7, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 8, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 7, 1, 8, 2, "-p1+k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[546]:
#---#[ diagrams[547]:
diagrams[547] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 2, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 5, 3, 2, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 7, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 8, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 7, 1, 8, 2, "-p1+k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[547]:
#---#[ diagrams[548]:
diagrams[548] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 2, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 2, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 3, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 3, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "g", 5, 3, 2, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(3, "Wm", 3, 3, 6, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 7, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 8, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 7, 1, 8, 2, "-p1+k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "Ubar", "U", "g"),
   Vertex(3, 0, "nebar", "em", "Wp"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Dbar", "U", "Wm"),
   Vertex(7, 0, "Ubar", "U", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[548]:
#---#[ diagrams[549]:
diagrams[549] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 5, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 5, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 8, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 7, 1, 8, 2, "-p1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Dbar", "U", "Wm"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[549]:
#---#[ diagrams[550]:
diagrams[550] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 5, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 5, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 8, 1, 6, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 7, 1, 8, 2, "-p1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Dbar", "U", "Wm"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[550]:
#---#[ diagrams[551]:
diagrams[551] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 5, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 5, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 8, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 7, 1, 8, 2, "-p1+k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Dbar", "U", "Wm"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[551]:
#---#[ diagrams[552]:
diagrams[552] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 4, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 5, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 6, 3, 3, 3, "k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "D", 6, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "D", 5, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(6, "D", 8, 1, 6, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(7, "D", 7, 1, 8, 2, "-p1+k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Dbar", "U", "Wm"),
   Vertex(6, 0, "Dbar", "D", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[552]:
#---#[ diagrams[553]:
diagrams[553] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 8, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 7, 2, "-p1+k1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "-p1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1+k1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[553]:
#---#[ diagrams[554]:
diagrams[554] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 8, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 7, 2, "-p1+k1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "-p1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1+k1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[554]:
#---#[ diagrams[555]:
diagrams[555] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 8, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 7, 2, "-p1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "-p1-k1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1+k2-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[555]:
#---#[ diagrams[556]:
diagrams[556] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 8, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 7, 2, "-p1+k1+k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "-p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1+k1+k2-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[556]:
#---#[ diagrams[557]:
diagrams[557] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 8, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 7, 2, "-p1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "-p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1-k3-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[557]:
#---#[ diagrams[558]:
diagrams[558] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 8, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 7, 2, "-p1+k1-k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "-p1-k2+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1+k1-k3-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[558]:
#---#[ diagrams[559]:
diagrams[559] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 8, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 7, 2, "-p1+k1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "-p1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1+k1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[559]:
#---#[ diagrams[560]:
diagrams[560] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 8, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 7, 2, "-p1+k1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "-p1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1+k1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "D", "Wp"))
#---#] diagrams[560]:
#---#[ diagrams[561]:
diagrams[561] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "A", 7, 3, 3, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "g", 8, 1, 4, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 2, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 6, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "A"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[561]:
#---#[ diagrams[562]:
diagrams[562] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "A", 7, 3, 3, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 5, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 6, 1, 8, 2, "p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "A"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[562]:
#---#[ diagrams[563]:
diagrams[563] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "Z", 7, 3, 3, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "g", 8, 1, 4, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 2, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 6, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "Z"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[563]:
#---#[ diagrams[564]:
diagrams[564] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "Z", 7, 3, 3, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 5, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 6, 1, 8, 2, "p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "Z"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[564]:
#---#[ diagrams[565]:
diagrams[565] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "A", 7, 3, 3, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "g", 8, 1, 4, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 2, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 6, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "A"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[565]:
#---#[ diagrams[566]:
diagrams[566] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "A", 7, 3, 3, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 5, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 6, 1, 8, 2, "p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "A"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[566]:
#---#[ diagrams[567]:
diagrams[567] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "Z", 7, 3, 3, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "g", 8, 1, 4, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 2, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 6, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "Z"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[567]:
#---#[ diagrams[568]:
diagrams[568] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "Z", 7, 3, 3, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 5, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 6, 1, 8, 2, "p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "Z"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[568]:
#---#[ diagrams[569]:
diagrams[569] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "A", 7, 3, 3, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "g", 8, 1, 4, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 2, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 6, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "A"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[569]:
#---#[ diagrams[570]:
diagrams[570] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "A", 7, 3, 3, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 5, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 6, 1, 8, 2, "p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "A"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[570]:
#---#[ diagrams[571]:
diagrams[571] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "Z", 7, 3, 3, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "g", 8, 1, 4, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 2, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 6, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "Z"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[571]:
#---#[ diagrams[572]:
diagrams[572] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "Z", 7, 3, 3, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 5, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 6, 1, 8, 2, "p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "Z"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[572]:
#---#[ diagrams[573]:
diagrams[573] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "A", 7, 3, 3, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "g", 8, 1, 4, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 2, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 6, 3, "-p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "A"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[573]:
#---#[ diagrams[574]:
diagrams[574] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "A", 7, 3, 3, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 5, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 6, 2, "-p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "A"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[574]:
#---#[ diagrams[575]:
diagrams[575] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "Z", 7, 3, 3, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "g", 8, 1, 4, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 2, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 6, 3, "-p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "Z"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[575]:
#---#[ diagrams[576]:
diagrams[576] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "Z", 7, 3, 3, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 5, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 6, 2, "-p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "Z"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[576]:
#---#[ diagrams[577]:
diagrams[577] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "A", 7, 3, 3, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "g", 8, 1, 4, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 2, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 6, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "A"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[577]:
#---#[ diagrams[578]:
diagrams[578] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "A", 7, 3, 3, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 5, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 6, 1, 8, 2, "p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "A"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[578]:
#---#[ diagrams[579]:
diagrams[579] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "Z", 7, 3, 3, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "g", 8, 1, 4, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 2, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 6, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "Z"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[579]:
#---#[ diagrams[580]:
diagrams[580] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "Z", 7, 3, 3, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 5, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 6, 1, 8, 2, "p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "Z"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[580]:
#---#[ diagrams[581]:
diagrams[581] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "A", 7, 3, 3, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "g", 8, 1, 4, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 2, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 6, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "A"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[581]:
#---#[ diagrams[582]:
diagrams[582] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "A", 7, 3, 3, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 5, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 6, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "A"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[582]:
#---#[ diagrams[583]:
diagrams[583] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "Z", 7, 3, 3, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "g", 8, 1, 4, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 2, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 6, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "Z"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[583]:
#---#[ diagrams[584]:
diagrams[584] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "Z", 7, 3, 3, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 5, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 6, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "Z"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[584]:
#---#[ diagrams[585]:
diagrams[585] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "A", 7, 3, 3, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "g", 8, 1, 4, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 2, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 6, 3, "-p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "A"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[585]:
#---#[ diagrams[586]:
diagrams[586] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "A", 7, 3, 3, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 5, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 6, 2, "-p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "A"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[586]:
#---#[ diagrams[587]:
diagrams[587] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "Z", 7, 3, 3, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "g", 8, 1, 4, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 2, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 6, 3, "-p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "Z"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[587]:
#---#[ diagrams[588]:
diagrams[588] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "Z", 7, 3, 3, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 5, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 6, 2, "-p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "Z"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[588]:
#---#[ diagrams[589]:
diagrams[589] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "A", 7, 3, 3, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "g", 8, 1, 4, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 2, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 6, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "A"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[589]:
#---#[ diagrams[590]:
diagrams[590] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "A", 7, 3, 3, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 5, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 6, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "A"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[590]:
#---#[ diagrams[591]:
diagrams[591] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "Z", 7, 3, 3, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "g", 8, 1, 4, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 2, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 3, 6, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "Z"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[591]:
#---#[ diagrams[592]:
diagrams[592] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "Z", 7, 3, 3, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 5, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 6, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "Z"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[592]:
#---#[ diagrams[593]:
diagrams[593] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1-k1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "A", 7, 3, 6, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 6, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "A"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[593]:
#---#[ diagrams[594]:
diagrams[594] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 4, 3, 3, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 3, 1, 5, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 8, 1, 4, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "A", 7, 3, 6, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 6, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "A"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[594]:
#---#[ diagrams[595]:
diagrams[595] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1-k1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "Z", 7, 3, 6, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 6, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "Z"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[595]:
#---#[ diagrams[596]:
diagrams[596] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 4, 3, 3, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 3, 1, 5, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 8, 1, 4, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "Z", 7, 3, 6, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 6, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "Z"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[596]:
#---#[ diagrams[597]:
diagrams[597] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1+k1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "A", 7, 3, 6, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 8, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "A"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[597]:
#---#[ diagrams[598]:
diagrams[598] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1+k1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "Z", 7, 3, 6, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 8, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "Z"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[598]:
#---#[ diagrams[599]:
diagrams[599] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1+k1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "A", 7, 3, 6, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 8, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "A"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[599]:
#---#[ diagrams[600]:
diagrams[600] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1+k1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "Z", 7, 3, 6, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 8, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "Z"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[600]:
#---#[ diagrams[601]:
diagrams[601] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "A", 7, 3, 6, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 6, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "A"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[601]:
#---#[ diagrams[602]:
diagrams[602] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "Z", 7, 3, 6, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 6, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "Z"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[602]:
#---#[ diagrams[603]:
diagrams[603] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "A", 7, 3, 6, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 8, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "A"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[603]:
#---#[ diagrams[604]:
diagrams[604] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 4, 3, 3, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 3, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 4, 1, 8, 2, "p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "A", 7, 3, 6, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 8, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "A"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[604]:
#---#[ diagrams[605]:
diagrams[605] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "Z", 7, 3, 6, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 8, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "Z"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[605]:
#---#[ diagrams[606]:
diagrams[606] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 4, 3, 3, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 3, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 4, 1, 8, 2, "p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "Z", 7, 3, 6, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 8, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "Z"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[606]:
#---#[ diagrams[607]:
diagrams[607] = Diagram(
   Leg(1, True, "U", 6, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 4, 3, 3, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 3, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 8, 1, 4, 2, "-p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "A", 7, 3, 6, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 6, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "A"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[607]:
#---#[ diagrams[608]:
diagrams[608] = Diagram(
   Leg(1, True, "U", 6, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 4, 3, 3, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 3, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 8, 1, 4, 2, "-p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "Z", 7, 3, 6, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 6, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "Z"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[608]:
#---#[ diagrams[609]:
diagrams[609] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "A", 7, 3, 6, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 6, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "A"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[609]:
#---#[ diagrams[610]:
diagrams[610] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "Z", 7, 3, 6, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 6, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "Z"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[610]:
#---#[ diagrams[611]:
diagrams[611] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "A", 7, 3, 6, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 8, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "A"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[611]:
#---#[ diagrams[612]:
diagrams[612] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 4, 3, 3, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 3, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 4, 1, 8, 2, "p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "A", 7, 3, 6, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 8, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "A"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[612]:
#---#[ diagrams[613]:
diagrams[613] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "Z", 7, 3, 6, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 8, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "Z"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[613]:
#---#[ diagrams[614]:
diagrams[614] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 4, 3, 3, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 3, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 4, 1, 8, 2, "p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "Z", 7, 3, 6, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 8, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "Z"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[614]:
#---#[ diagrams[615]:
diagrams[615] = Diagram(
   Leg(1, True, "U", 6, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 4, 3, 3, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 3, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 8, 1, 4, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "A", 7, 3, 6, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 6, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "A"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[615]:
#---#[ diagrams[616]:
diagrams[616] = Diagram(
   Leg(1, True, "U", 6, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 4, 3, 3, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 5, 1, 3, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 8, 1, 4, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "Z", 7, 3, 6, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 6, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "Z"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[616]:
#---#[ diagrams[617]:
diagrams[617] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 4, 3, 3, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 3, 1, 5, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 4, 1, 8, 2, "p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "A", 7, 3, 6, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 8, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "A"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[617]:
#---#[ diagrams[618]:
diagrams[618] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 4, 3, 3, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 3, 1, 5, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 4, 1, 8, 2, "p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "Z", 7, 3, 6, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 8, 1, 6, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "Z"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[618]:
#---#[ diagrams[619]:
diagrams[619] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 4, 3, 3, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 3, 1, 5, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 4, 1, 8, 2, "p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "A", 7, 3, 6, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 8, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "A"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[619]:
#---#[ diagrams[620]:
diagrams[620] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 4, 3, 3, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 3, 1, 5, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 4, 1, 8, 2, "p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "Z", 7, 3, 6, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 8, 1, 6, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "Z"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[620]:
#---#[ diagrams[621]:
diagrams[621] = Diagram(
   Leg(1, True, "U", 6, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "A", 7, 3, 6, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 6, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "A"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[621]:
#---#[ diagrams[622]:
diagrams[622] = Diagram(
   Leg(1, True, "U", 6, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 4, 3, 3, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 3, 1, 5, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 8, 1, 4, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "A", 7, 3, 6, 3, "-k5-k6-k7-k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Propagator(8, "U", 6, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "A"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[622]:
#---#[ diagrams[623]:
diagrams[623] = Diagram(
   Leg(1, True, "U", 6, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 8, 3, 4, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "Z", 7, 3, 6, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 6, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "Z"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[623]:
#---#[ diagrams[624]:
diagrams[624] = Diagram(
   Leg(1, True, "U", 6, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "g", 4, 3, 3, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(4, "U", 3, 1, 5, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "U", 8, 1, 4, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 3, 5, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "Z", 7, 3, 6, 3, "-k5-k6-k7-k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Propagator(8, "U", 6, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "Z"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[624]:
#---#[ diagrams[625]:
diagrams[625] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1-k1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "p1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "A", 8, 3, 7, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[625]:
#---#[ diagrams[626]:
diagrams[626] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1-k1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "p1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "Z", 8, 3, 7, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[626]:
#---#[ diagrams[627]:
diagrams[627] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1+k1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "-p1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "A", 8, 3, 7, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[627]:
#---#[ diagrams[628]:
diagrams[628] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1+k1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "-p1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "Z", 8, 3, 7, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[628]:
#---#[ diagrams[629]:
diagrams[629] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "p1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "A", 8, 3, 7, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[629]:
#---#[ diagrams[630]:
diagrams[630] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1-k1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "p1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "Z", 8, 3, 7, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[630]:
#---#[ diagrams[631]:
diagrams[631] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1+k1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "-p1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "A", 8, 3, 7, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[631]:
#---#[ diagrams[632]:
diagrams[632] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 3, 1, 4, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1+k1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "-p1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "Z", 8, 3, 7, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[632]:
#---#[ diagrams[633]:
diagrams[633] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1+k1+k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "-p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "A", 8, 3, 7, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[633]:
#---#[ diagrams[634]:
diagrams[634] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1+k1+k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "-p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "Z", 8, 3, 7, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[634]:
#---#[ diagrams[635]:
diagrams[635] = Diagram(
   Leg(1, True, "U", 6, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "p1+k1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "A", 8, 3, 7, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[635]:
#---#[ diagrams[636]:
diagrams[636] = Diagram(
   Leg(1, True, "U", 6, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "p1+k1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "Z", 8, 3, 7, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[636]:
#---#[ diagrams[637]:
diagrams[637] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1+k1-k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "-p1-k2+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "A", 8, 3, 7, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[637]:
#---#[ diagrams[638]:
diagrams[638] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1+k1-k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "-p1-k2+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "Z", 8, 3, 7, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[638]:
#---#[ diagrams[639]:
diagrams[639] = Diagram(
   Leg(1, True, "U", 6, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "p1+k1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "A", 8, 3, 7, 3, "k5+k6+k7+k8", "0", "0", 0, 2, 1,
      "A" == "A", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "A"),
   Vertex(8, 0, "Ubar", "U", "A"))
#---#] diagrams[639]:
#---#[ diagrams[640]:
diagrams[640] = Diagram(
   Leg(1, True, "U", 6, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 7, 2, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 1, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "U", 4, 1, 3, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(4, "g", 5, 3, 3, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "g", 6, 3, 4, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "p1+k1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "Z", 8, 3, 7, 3, "k5+k6+k7+k8", "mZ", "wZ", 0, 2, 1,
      "Z" == "Z", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Ubar", "U", "g"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 1, "Wp", "Wm", "Z"),
   Vertex(8, 0, "Ubar", "U", "Z"))
#---#] diagrams[640]:
#---#[ diagrams[641]:
diagrams[641] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 8, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 6, 1, 4, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "-p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[641]:
#---#[ diagrams[642]:
diagrams[642] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 8, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 6, 1, 4, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[642]:
#---#[ diagrams[643]:
diagrams[643] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 8, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 6, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[643]:
#---#[ diagrams[644]:
diagrams[644] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 8, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 6, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "-p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[644]:
#---#[ diagrams[645]:
diagrams[645] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 8, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 6, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[645]:
#---#[ diagrams[646]:
diagrams[646] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 8, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 6, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "-p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[646]:
#---#[ diagrams[647]:
diagrams[647] = Diagram(
   Leg(1, True, "U", 6, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 8, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 6, 1, 4, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "-p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1+k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[647]:
#---#[ diagrams[648]:
diagrams[648] = Diagram(
   Leg(1, True, "U", 6, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 8, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 6, 1, 4, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 7, 1, 5, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 8, 1, 7, 2, "-p1-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[648]:
#---#[ diagrams[649]:
diagrams[649] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 8, 1, 3, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 6, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 7, 2, "p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[649]:
#---#[ diagrams[650]:
diagrams[650] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 8, 1, 3, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 6, 1, 4, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 7, 2, "p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "p1+k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[650]:
#---#[ diagrams[651]:
diagrams[651] = Diagram(
   Leg(1, True, "U", 6, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 8, 1, 3, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 6, 1, 4, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 7, 2, "p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[651]:
#---#[ diagrams[652]:
diagrams[652] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 8, 1, 3, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 6, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 7, 2, "p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "p1+k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[652]:
#---#[ diagrams[653]:
diagrams[653] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 8, 1, 3, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 6, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 7, 2, "p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[653]:
#---#[ diagrams[654]:
diagrams[654] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 8, 1, 3, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 6, 1, 4, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 7, 2, "p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "p1+k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[654]:
#---#[ diagrams[655]:
diagrams[655] = Diagram(
   Leg(1, True, "U", 6, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 8, 1, 3, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 6, 1, 4, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 7, 2, "p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1-k1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "p1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[655]:
#---#[ diagrams[656]:
diagrams[656] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 8, 1, 3, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 6, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 7, 2, "p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "p1+k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[656]:
#---#[ diagrams[657]:
diagrams[657] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "U", 5, 1, 4, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 2, 4, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 7, 1, 6, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 1, 6, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[657]:
#---#[ diagrams[658]:
diagrams[658] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 8, 1, 4, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 8, 2, "p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 7, 1, 6, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 6, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[658]:
#---#[ diagrams[659]:
diagrams[659] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "U", 5, 1, 4, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 2, 4, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 7, 1, 6, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 1, 6, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[659]:
#---#[ diagrams[660]:
diagrams[660] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 8, 1, 4, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 8, 2, "p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 7, 1, 6, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 6, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[660]:
#---#[ diagrams[661]:
diagrams[661] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "U", 4, 1, 5, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 2, 4, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 7, 1, 6, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 1, 6, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[661]:
#---#[ diagrams[662]:
diagrams[662] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 8, 1, 5, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 7, 1, 6, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 6, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[662]:
#---#[ diagrams[663]:
diagrams[663] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "U", 4, 1, 5, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 2, 4, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 7, 1, 6, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 1, 6, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[663]:
#---#[ diagrams[664]:
diagrams[664] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 8, 1, 5, 2, "-p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 7, 1, 6, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 6, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[664]:
#---#[ diagrams[665]:
diagrams[665] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 7, 1, 3, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "U", 4, 1, 5, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 2, 4, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 6, 1, 7, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 1, 6, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[665]:
#---#[ diagrams[666]:
diagrams[666] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 7, 1, 3, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 8, 1, 5, 2, "-p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 7, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 6, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[666]:
#---#[ diagrams[667]:
diagrams[667] = Diagram(
   Leg(1, True, "U", 6, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 7, 1, 3, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "U", 5, 1, 4, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 2, 4, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 6, 1, 7, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 1, 6, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[667]:
#---#[ diagrams[668]:
diagrams[668] = Diagram(
   Leg(1, True, "U", 6, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 7, 1, 3, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 8, 1, 4, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 8, 2, "p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 7, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 6, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[668]:
#---#[ diagrams[669]:
diagrams[669] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 7, 1, 3, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "U", 4, 1, 5, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 2, 4, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 6, 1, 7, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 1, 6, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[669]:
#---#[ diagrams[670]:
diagrams[670] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 7, 1, 3, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 8, 1, 5, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 7, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 6, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[670]:
#---#[ diagrams[671]:
diagrams[671] = Diagram(
   Leg(1, True, "U", 6, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 7, 1, 3, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "U", 5, 1, 4, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 8, 2, 4, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 6, 1, 7, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 1, 6, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[671]:
#---#[ diagrams[672]:
diagrams[672] = Diagram(
   Leg(1, True, "U", 6, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 7, 1, 3, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 8, 1, 4, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 8, 2, "p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 7, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 6, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[672]:
#---#[ diagrams[673]:
diagrams[673] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 6, 1, 4, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 8, 1, 5, 2, "-p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[673]:
#---#[ diagrams[674]:
diagrams[674] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 6, 1, 4, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 8, 1, 5, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[674]:
#---#[ diagrams[675]:
diagrams[675] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "U", 4, 1, 5, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 6, 3, 4, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 6, 2, "p1+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[675]:
#---#[ diagrams[676]:
diagrams[676] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 6, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 8, 1, 5, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "-k2+k3+k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[676]:
#---#[ diagrams[677]:
diagrams[677] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "U", 4, 1, 5, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 6, 3, 4, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 6, 2, "p1-k1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[677]:
#---#[ diagrams[678]:
diagrams[678] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 6, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 8, 1, 5, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1-k1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 7, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[678]:
#---#[ diagrams[679]:
diagrams[679] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "U", 5, 1, 4, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 6, 3, 4, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 6, 2, "p1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[679]:
#---#[ diagrams[680]:
diagrams[680] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 7, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "U", 5, 1, 4, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 6, 3, 4, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 8, 1, 6, 2, "p1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 7, 1, 8, 2, "-k1-k2+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Ubar", "D", "Wp"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[680]:
#---#[ diagrams[681]:
diagrams[681] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 7, 1, 3, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "U", 4, 1, 5, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 6, 3, 4, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 6, 1, 8, 2, "-p1+k1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[681]:
#---#[ diagrams[682]:
diagrams[682] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 7, 1, 3, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "U", 5, 1, 4, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 6, 3, 4, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 6, 1, 8, 2, "-p1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[682]:
#---#[ diagrams[683]:
diagrams[683] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 7, 1, 3, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 6, 1, 4, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 8, 2, "p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[683]:
#---#[ diagrams[684]:
diagrams[684] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 3, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 7, 1, 3, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 6, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 8, 2, "p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1+k3+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "k1-k3-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[684]:
#---#[ diagrams[685]:
diagrams[685] = Diagram(
   Leg(1, True, "U", 4, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 7, 1, 3, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "U", 4, 1, 5, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 6, 3, 4, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 6, 1, 8, 2, "-p1+k1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[685]:
#---#[ diagrams[686]:
diagrams[686] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 7, 1, 3, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "U", 5, 1, 4, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(5, "g", 6, 3, 4, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "g", 8, 3, 5, 3, "-p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "U", 6, 1, 8, 2, "-p1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "U", 8, 1, 7, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[686]:
#---#[ diagrams[687]:
diagrams[687] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 7, 1, 3, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 6, 1, 4, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 8, 2, "p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[687]:
#---#[ diagrams[688]:
diagrams[688] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 3, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 4, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 2, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 2, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 1, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 1, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 3, 3, 1, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 2, 3, 7, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 7, 1, 3, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "g", 5, 3, 4, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(5, "U", 4, 1, 6, 2, "-p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "U", 5, 1, 8, 2, "p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "g", 8, 3, 6, 3, "p1-k2+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "U", 8, 1, 7, 2, "k1+k2-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Vertex(1, 0, "mup", "nmu", "Wm"),
   Vertex(2, 0, "nebar", "em", "Wp"),
   Vertex(3, 0, "Ubar", "D", "Wp"),
   Vertex(4, 0, "Ubar", "U", "g"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "U", "Wm"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[688]:
#---#[ diagrams[689]:
diagrams[689] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 4, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "D", 8, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1+k1-k3-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[689]:
#---#[ diagrams[690]:
diagrams[690] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 4, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "D", 8, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1+k1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[690]:
#---#[ diagrams[691]:
diagrams[691] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 4, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "D", 8, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1+k1+k2-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[691]:
#---#[ diagrams[692]:
diagrams[692] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 5, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 4, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "D", 8, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 3, 5, 3, "p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1+k1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[692]:
#---#[ diagrams[693]:
diagrams[693] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 4, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "D", 8, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1+k1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[693]:
#---#[ diagrams[694]:
diagrams[694] = Diagram(
   Leg(1, True, "U", 6, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 4, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "D", 8, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 3, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1-k3-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[694]:
#---#[ diagrams[695]:
diagrams[695] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 4, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "D", 8, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 3, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1+k1-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[695]:
#---#[ diagrams[696]:
diagrams[696] = Diagram(
   Leg(1, True, "U", 6, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 4, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "D", 8, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 7, 3, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "D", 7, 1, 8, 2, "-p1+k2-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Dbar", "D", "g"))
#---#] diagrams[696]:
#---#[ diagrams[697]:
diagrams[697] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 4, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "D", 7, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 2, 5, 3, "p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 1, 7, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[697]:
#---#[ diagrams[698]:
diagrams[698] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 5, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 4, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "D", 7, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "-k3-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[698]:
#---#[ diagrams[699]:
diagrams[699] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 4, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "D", 7, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 6, 1, 5, 2, "-p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 2, 5, 3, "p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1+k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 1, 7, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[699]:
#---#[ diagrams[700]:
diagrams[700] = Diagram(
   Leg(1, True, "U", 3, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 5, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 6, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 4, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "k1-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "D", 7, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 8, 1, 5, 2, "p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 6, 1, 8, 2, "p1-k4", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "k2-k4", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[700]:
#---#[ diagrams[701]:
diagrams[701] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 4, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "D", 7, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 2, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1+k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 1, 7, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[701]:
#---#[ diagrams[702]:
diagrams[702] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 4, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 6, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 4, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "D", 7, 1, 4, 2, "-k2+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "-p1+k3", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "k1-k3", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[702]:
#---#[ diagrams[703]:
diagrams[703] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 4, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "D", 7, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "U", 5, 1, 6, 2, "p1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(6, "g", 8, 2, 5, 3, "p1-k1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(7, "g", 8, 3, 6, 3, "-p1-k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(8, "g", 8, 1, 7, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 1, "g", "g", "g"))
#---#] diagrams[703]:
#---#[ diagrams[704]:
diagrams[704] = Diagram(
   Leg(1, True, "U", 5, 2, "k1", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, True, "Ubar", 6, 1, "k2", "mU", -1, 3, "Ubar" == "U"),
   Leg(1, False, "U", 4, 1, "k3", "mU", +1, 3, "U" == "Ubar"),
   Leg(2, False, "Ubar", 3, 2, "k4", "mU", -1, 3, "Ubar" == "U"),
   Leg(3, False, "ne", 1, 1, "k5", "0", +1, 1, "ne" == "nebar"),
   Leg(4, False, "ep", 1, 2, "k6", "me", -1, 1, "ep" == "em"),
   Leg(5, False, "mum", 2, 1, "k7", "mmu", +1, 1, "mum" == "mup"),
   Leg(6, False, "nmubar", 2, 2, "k8", "0", -1, 1, "nmubar" == "nmu"),
   Propagator(1, "Wm", 1, 3, 3, 3, "-k5-k6", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(2, "Wm", 4, 3, 2, 3, "k7+k8", "mW", "wW", 0, 2, 1,
      "Wm" == "Wp", sign="+"),
   Propagator(3, "D", 3, 1, 7, 2, "-k4-k5-k6", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(4, "D", 7, 1, 4, 2, "k3+k7+k8", "mD", "0", 0, 1, 3,
      "D" == "Dbar", sign="-"),
   Propagator(5, "g", 6, 3, 5, 3, "-p1", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Propagator(6, "U", 5, 1, 8, 2, "-p1+k1", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(7, "U", 8, 1, 6, 2, "-p1-k2", "mU", "0", 0, 1, 3,
      "U" == "Ubar", sign="-"),
   Propagator(8, "g", 8, 3, 7, 3, "k1+k2", "0", "0", 0, 2, 8,
      "g" == "g", sign="+"),
   Vertex(1, 0, "nebar", "em", "Wp"),
   Vertex(2, 0, "mup", "nmu", "Wm"),
   Vertex(3, 0, "Dbar", "U", "Wm"),
   Vertex(4, 0, "Ubar", "D", "Wp"),
   Vertex(5, 0, "Ubar", "U", "g"),
   Vertex(6, 0, "Ubar", "U", "g"),
   Vertex(7, 0, "Dbar", "D", "g"),
   Vertex(8, 0, "Ubar", "U", "g"))
#---#] diagrams[704]:
#-------------------------------------------------------------------
